/* Utils.c generated by valac 0.37.91, the Vala compiler
 * generated from Utils.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <meta/window.h>
#include <libbamf/libbamf.h>
#include <gio/gdesktopappinfo.h>
#include <plank.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <meta/workspace.h>
#include <meta/screen.h>
#include <meta/display.h>
#include <meta/meta-window-actor.h>
#include <meta/boxes.h>
#include <clutter/clutter.h>
#include <cairo.h>
#include <meta/meta-shaped-texture.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>
#include <gdk/gdk.h>
#include <meta/compositor.h>
#include "config.h"
#include <gobject/gvaluecollector.h>


#define GALA_TYPE_UTILS (gala_utils_get_type ())
#define GALA_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_UTILS, GalaUtils))
#define GALA_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_UTILS, GalaUtilsClass))
#define GALA_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_UTILS))
#define GALA_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_UTILS))
#define GALA_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_UTILS, GalaUtilsClass))

typedef struct _GalaUtils GalaUtils;
typedef struct _GalaUtilsClass GalaUtilsClass;
typedef struct _GalaUtilsPrivate GalaUtilsPrivate;
enum  {
	GALA_UTILS_DUMMY_PROPERTY,
	GALA_UTILS_LAST_PROPERTY
};
static GParamSpec* gala_utils_properties[GALA_UTILS_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _GalaParamSpecUtils GalaParamSpecUtils;

struct _GalaUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaUtilsPrivate * priv;
};

struct _GalaUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (GalaUtils *self);
};

struct _Block1Data {
	int _ref_count_;
	guint32* xids;
	gint xids_length1;
};

struct _Block2Data {
	int _ref_count_;
	cairo_surface_t* surface;
};

struct _GalaParamSpecUtils {
	GParamSpec parent_instance;
};


static gpointer gala_utils_parent_class = NULL;
static GHashTable* gala_utils_xid_pixbuf_cache;
static GHashTable* gala_utils_xid_pixbuf_cache = NULL;
static GHashTable* gala_utils_icon_pixbuf_cache;
static GHashTable* gala_utils_icon_pixbuf_cache = NULL;
static guint gala_utils_cache_clear_timeout;
static guint gala_utils_cache_clear_timeout = (guint) 0;
static GdkPixbuf* gala_utils_close_pixbuf;
static GdkPixbuf* gala_utils_close_pixbuf = NULL;
static GdkPixbuf* gala_utils_resize_pixbuf;
static GdkPixbuf* gala_utils_resize_pixbuf = NULL;

gpointer gala_utils_ref (gpointer instance);
void gala_utils_unref (gpointer instance);
GParamSpec* gala_param_spec_utils (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gala_value_set_utils (GValue* value, gpointer v_object);
void gala_value_take_utils (GValue* value, gpointer v_object);
gpointer gala_value_get_utils (const GValue* value);
GType gala_utils_get_type (void) G_GNUC_CONST;
static GalaUtils* gala_utils_new (void);
static GalaUtils* gala_utils_construct (GType object_type);
static void gala_utils_clean_icon_cache (guint32* xids, int xids_length1);
static gboolean _vala_uint32_array_contains (guint32 * stack, int stack_length, guint32 needle);
void gala_utils_request_clean_icon_cache (guint32* xids, int xids_length1);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block1Data* _data1_);
static gboolean __lambda6_ (Block1Data* _data1_);
static gboolean ___lambda6__gsource_func (gpointer self);
static gboolean ___lambda5__gsource_func (gpointer self);
GdkPixbuf* gala_utils_get_icon_for_window (MetaWindow* window, gint size, gboolean ignore_cache);
GdkPixbuf* gala_utils_get_icon_for_xid (guint32 xid, gint size, gboolean ignore_cache);
static GdkPixbuf* gala_utils_get_icon_for_application (BamfApplication* app, gint size, gboolean ignore_cache);
MetaWindow* gala_utils_get_next_window (MetaWorkspace* workspace, gboolean backward);
guint gala_utils_get_n_windows (MetaWorkspace* workspace);
ClutterActor* gala_utils_get_window_actor_snapshot (MetaWindowActor* actor, MetaRectangle* inner_rect, MetaRectangle* outer_rect);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block2Data* _data2_, cairo_t* cr);
static gboolean ___lambda7__clutter_canvas_draw (ClutterCanvas* _sender, cairo_t* cr, gint width, gint height, gpointer self);
void gala_utils_bell (MetaScreen* screen);
GdkPixbuf* gala_utils_get_close_button_pixbuf (void);
ClutterActor* gala_utils_create_close_button (void);
GdkPixbuf* gala_utils_get_resize_button_pixbuf (void);
ClutterActor* gala_utils_create_resize_button (void);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void gala_utils_finalize (GalaUtils * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static GalaUtils* gala_utils_construct (GType object_type) {
	GalaUtils* self = NULL;
#line 36 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	self = (GalaUtils*) g_type_create_instance (object_type);
#line 36 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return self;
#line 161 "Utils.c"
}


static GalaUtils* gala_utils_new (void) {
#line 36 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return gala_utils_construct (GALA_TYPE_UTILS);
#line 168 "Utils.c"
}


/**
 * Clean icon caches
 */
static guint64 uint64_parse (const gchar* str) {
	guint64 result = 0ULL;
	const gchar* _tmp0_;
	guint64 _tmp1_;
#line 745 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 746 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 746 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (_tmp0_, NULL, (guint) 0);
#line 746 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 746 "/usr/share/vala-0.38/vapi/glib-2.0.vapi"
	return result;
#line 189 "Utils.c"
}


static gboolean _vala_uint32_array_contains (guint32 * stack, int stack_length, guint32 needle) {
	int i;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	for (i = 0; i < stack_length; i++) {
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (needle == stack[i]) {
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return TRUE;
#line 201 "Utils.c"
		}
	}
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return FALSE;
#line 206 "Utils.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 213 "Utils.c"
}


static void gala_utils_clean_icon_cache (guint32* xids, int xids_length1) {
	GList* list = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GList* pixbuf_list = NULL;
	GHashTable* _tmp2_;
	GList* _tmp3_;
	GList* icon_list = NULL;
	GHashTable* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = gala_utils_xid_pixbuf_cache;
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	list = _tmp1_;
#line 46 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = gala_utils_icon_pixbuf_cache;
#line 46 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp3_ = g_hash_table_get_values (_tmp2_);
#line 46 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	pixbuf_list = _tmp3_;
#line 47 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp4_ = gala_utils_icon_pixbuf_cache;
#line 47 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp5_ = g_hash_table_get_keys (_tmp4_);
#line 47 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	icon_list = _tmp5_;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp6_ = list;
#line 248 "Utils.c"
	{
		GList* xid_key_collection = NULL;
		GList* xid_key_it = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		xid_key_collection = _tmp6_;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		for (xid_key_it = xid_key_collection; xid_key_it != NULL; xid_key_it = xid_key_it->next) {
#line 256 "Utils.c"
			const gchar* xid_key = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			xid_key = (const gchar*) xid_key_it->data;
#line 260 "Utils.c"
			{
				guint32 xid = 0U;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				guint64 _tmp12_;
				guint32 _tmp13_;
				guint32 _tmp14_;
				guint32* _tmp15_;
				gint _tmp15__length1;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp7_ = xid_key;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "::", 0);
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp10_ = _tmp9_;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp10__length1 = _vala_array_length (_tmp8_);
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp11_ = _tmp10_[0];
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp12_ = uint64_parse (_tmp11_);
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp13_ = (guint32) _tmp12_;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				xid = _tmp13_;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp14_ = xid;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp15_ = xids;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp15__length1 = xids_length1;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				if (!_vala_uint32_array_contains (_tmp15_, _tmp15__length1, _tmp14_)) {
#line 300 "Utils.c"
					GdkPixbuf* pixbuf = NULL;
					GHashTable* _tmp16_;
					const gchar* _tmp17_;
					gconstpointer _tmp18_;
					GdkPixbuf* _tmp19_;
					GHashTable* _tmp33_;
					const gchar* _tmp34_;
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp16_ = gala_utils_xid_pixbuf_cache;
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp17_ = xid_key;
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp18_ = g_hash_table_lookup (_tmp16_, _tmp17_);
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp19_ = _g_object_ref0 ((GdkPixbuf*) _tmp18_);
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					pixbuf = _tmp19_;
#line 318 "Utils.c"
					{
						gint j = 0;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
						j = 0;
#line 323 "Utils.c"
						{
							gboolean _tmp20_ = FALSE;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
							_tmp20_ = TRUE;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
							while (TRUE) {
#line 330 "Utils.c"
								gint _tmp22_;
								GList* _tmp23_;
								guint _tmp24_;
								GList* _tmp25_;
								gint _tmp26_;
								gconstpointer _tmp27_;
								GdkPixbuf* _tmp28_;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								if (!_tmp20_) {
#line 340 "Utils.c"
									gint _tmp21_;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
									_tmp21_ = j;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
									j = _tmp21_ + 1;
#line 346 "Utils.c"
								}
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								_tmp20_ = FALSE;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								_tmp22_ = j;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								_tmp23_ = pixbuf_list;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								_tmp24_ = g_list_length (_tmp23_);
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								if (!(((guint) _tmp22_) < _tmp24_)) {
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
									break;
#line 360 "Utils.c"
								}
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								_tmp25_ = pixbuf_list;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								_tmp26_ = j;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								_tmp27_ = g_list_nth_data (_tmp25_, (guint) _tmp26_);
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								_tmp28_ = pixbuf;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
								if (((GdkPixbuf*) _tmp27_) == _tmp28_) {
#line 372 "Utils.c"
									GHashTable* _tmp29_;
									GList* _tmp30_;
									gint _tmp31_;
									gconstpointer _tmp32_;
#line 55 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
									_tmp29_ = gala_utils_xid_pixbuf_cache;
#line 55 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
									_tmp30_ = icon_list;
#line 55 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
									_tmp31_ = j;
#line 55 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
									_tmp32_ = g_list_nth_data (_tmp30_, (guint) _tmp31_);
#line 55 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
									g_hash_table_remove (_tmp29_, (const gchar*) _tmp32_);
#line 387 "Utils.c"
								}
							}
						}
					}
#line 59 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp33_ = gala_utils_xid_pixbuf_cache;
#line 59 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp34_ = xid_key;
#line 59 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					g_hash_table_remove (_tmp33_, _tmp34_);
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_g_object_unref0 (pixbuf);
#line 400 "Utils.c"
				}
			}
		}
	}
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_list_free0 (icon_list);
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_list_free0 (pixbuf_list);
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_list_free0 (list);
#line 411 "Utils.c"
}


/**
 * Marks the given xids as no longer needed, the corresponding icons
 * may be freed now. Mainly for internal purposes.
 *
 * @param xids The xids of the window that no longer need icons
 */
static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return _data1_;
#line 426 "Utils.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_slice_free (Block1Data, _data1_);
#line 437 "Utils.c"
	}
}


static gboolean __lambda6_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	guint32* _tmp0_;
	gint _tmp0__length1;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = _data1_->xids;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0__length1 = _data1_->xids_length1;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	gala_utils_clean_icon_cache (_tmp0_, _tmp0__length1);
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = FALSE;
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 456 "Utils.c"
}


static gboolean ___lambda6__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda6_ (self);
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 465 "Utils.c"
}


static gboolean __lambda5_ (Block1Data* _data1_) {
	gboolean result = FALSE;
#line 76 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	gala_utils_cache_clear_timeout = (guint) 0;
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda6__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = FALSE;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 479 "Utils.c"
}


static gboolean ___lambda5__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda5_ (self);
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 488 "Utils.c"
}


void gala_utils_request_clean_icon_cache (guint32* xids, int xids_length1) {
	Block1Data* _data1_;
	guint32* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	guint _tmp3_;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data1_->_ref_count_ = 1;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = xids;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0__length1 = xids_length1;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data1_->xids = _tmp0_;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data1_->xids_length1 = _tmp0__length1;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = gala_utils_cache_clear_timeout;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp1_ > ((guint) 0)) {
#line 514 "Utils.c"
		guint _tmp2_;
#line 73 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp2_ = gala_utils_cache_clear_timeout;
#line 73 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_source_remove (_tmp2_);
#line 520 "Utils.c"
	}
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp3_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 30, ___lambda5__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	gala_utils_cache_clear_timeout = _tmp3_;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	block1_data_unref (_data1_);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data1_ = NULL;
#line 530 "Utils.c"
}


/**
 * Returns a pixbuf for the application of this window or a default icon
 *
 * @param window       The window to get an icon for
 * @param size         The size of the icon
 * @param ignore_cache Should not be necessary in most cases, if you care about the icon
 *                     being loaded correctly, you should consider using the WindowIcon class
 */
GdkPixbuf* gala_utils_get_icon_for_window (MetaWindow* window, gint size, gboolean ignore_cache) {
	GdkPixbuf* result = NULL;
	MetaWindow* _tmp0_;
	Window _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	GdkPixbuf* _tmp4_;
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = window;
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = meta_window_get_xwindow (_tmp0_);
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = size;
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp3_ = ignore_cache;
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp4_ = gala_utils_get_icon_for_xid ((guint32) _tmp1_, _tmp2_, _tmp3_);
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = _tmp4_;
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 565 "Utils.c"
}


/**
 * Returns a pixbuf for a given xid or a default icon
 *
 * @see get_icon_for_window
 */
GdkPixbuf* gala_utils_get_icon_for_xid (guint32 xid, gint size, gboolean ignore_cache) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _result_ = NULL;
	gchar* xid_key = NULL;
	guint32 _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	BamfApplication* app = NULL;
	BamfMatcher* _tmp10_;
	BamfMatcher* _tmp11_;
	guint32 _tmp12_;
	BamfApplication* _tmp13_;
	BamfApplication* _tmp14_;
	BamfApplication* _tmp15_;
	BamfApplication* _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_;
	GdkPixbuf* _tmp19_;
	GHashTable* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* _tmp24_;
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_result_ = NULL;
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = xid;
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = size;
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = g_strdup_printf ("%u::%i", (guint) _tmp0_, _tmp1_);
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	xid_key = _tmp2_;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp4_ = ignore_cache;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (!_tmp4_) {
#line 613 "Utils.c"
		GHashTable* _tmp5_;
		const gchar* _tmp6_;
		gconstpointer _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp5_ = gala_utils_xid_pixbuf_cache;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp6_ = xid_key;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp7_ = g_hash_table_lookup (_tmp5_, _tmp6_);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp8_ = _g_object_ref0 ((GdkPixbuf*) _tmp7_);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_object_unref0 (_result_);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_result_ = _tmp8_;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp9_ = _result_;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp3_ = _tmp9_ != NULL;
#line 635 "Utils.c"
	} else {
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp3_ = FALSE;
#line 639 "Utils.c"
	}
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp3_) {
#line 109 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		result = _result_;
#line 109 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_free0 (xid_key);
#line 109 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		return result;
#line 649 "Utils.c"
	}
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp10_ = bamf_matcher_get_default ();
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp11_ = _tmp10_;
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp12_ = xid;
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp13_ = bamf_matcher_get_application_for_xid (_tmp11_, _tmp12_);
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp15_ = _tmp14_;
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (_tmp11_);
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	app = _tmp15_;
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp16_ = app;
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp17_ = size;
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp18_ = ignore_cache;
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp19_ = gala_utils_get_icon_for_application (_tmp16_, _tmp17_, _tmp18_);
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (_result_);
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_result_ = _tmp19_;
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp20_ = gala_utils_xid_pixbuf_cache;
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp21_ = xid_key;
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp23_ = _result_;
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp24_ = _g_object_ref0 (_tmp23_);
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_hash_table_insert (_tmp20_, _tmp22_, _tmp24_);
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = _result_;
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (app);
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_free0 (xid_key);
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 699 "Utils.c"
}


/**
 * Returns a pixbuf for this application or a default icon
 *
 * @see get_icon_for_window
 */
static GdkPixbuf* gala_utils_get_icon_for_application (BamfApplication* app, gint size, gboolean ignore_cache) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* image = NULL;
	gboolean not_cached = FALSE;
	gchar* icon = NULL;
	gchar* icon_key = NULL;
	gboolean _tmp0_ = FALSE;
	BamfApplication* _tmp1_;
	GdkPixbuf* _tmp25_;
	GdkPixbuf* _tmp44_;
	gboolean _tmp57_ = FALSE;
	gint _tmp58_;
	GdkPixbuf* _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	gboolean _tmp70_;
	GError * _inner_error_ = NULL;
#line 127 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	image = NULL;
#line 128 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	not_cached = FALSE;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	icon = NULL;
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	icon_key = NULL;
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = app;
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp1_ != NULL) {
#line 737 "Utils.c"
		BamfApplication* _tmp2_;
		const gchar* _tmp3_;
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp2_ = app;
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp3_ = bamf_application_get_desktop_file (_tmp2_);
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 746 "Utils.c"
	} else {
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp0_ = FALSE;
#line 750 "Utils.c"
	}
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp0_) {
#line 754 "Utils.c"
		GDesktopAppInfo* appinfo = NULL;
		BamfApplication* _tmp4_;
		const gchar* _tmp5_;
		GDesktopAppInfo* _tmp6_;
		GDesktopAppInfo* _tmp7_;
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp4_ = app;
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp5_ = bamf_application_get_desktop_file (_tmp4_);
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp6_ = g_desktop_app_info_new_from_filename (_tmp5_);
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		appinfo = _tmp6_;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp7_ = appinfo;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (_tmp7_ != NULL) {
#line 772 "Utils.c"
			GDesktopAppInfo* _tmp8_;
			GIcon* _tmp9_;
			gchar* _tmp10_;
			const gchar* _tmp11_;
			gint _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			gboolean _tmp15_;
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp8_ = appinfo;
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp9_ = g_app_info_get_icon ((GAppInfo*) _tmp8_);
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp10_ = plank_drawing_service_get_icon_from_gicon (_tmp9_);
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_free0 (icon);
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			icon = _tmp10_;
#line 137 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp11_ = icon;
#line 137 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp12_ = size;
#line 137 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp13_ = g_strdup_printf ("%s::%i", _tmp11_, _tmp12_);
#line 137 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_free0 (icon_key);
#line 137 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			icon_key = _tmp13_;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp15_ = ignore_cache;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (_tmp15_) {
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp14_ = TRUE;
#line 807 "Utils.c"
			} else {
				GHashTable* _tmp16_;
				const gchar* _tmp17_;
				gconstpointer _tmp18_;
				GdkPixbuf* _tmp19_;
				GdkPixbuf* _tmp20_;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp16_ = gala_utils_icon_pixbuf_cache;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp17_ = icon_key;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp18_ = g_hash_table_lookup (_tmp16_, _tmp17_);
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp19_ = _g_object_ref0 ((GdkPixbuf*) _tmp18_);
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_g_object_unref0 (image);
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				image = _tmp19_;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp20_ = image;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp14_ = _tmp20_ == NULL;
#line 830 "Utils.c"
			}
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (_tmp14_) {
#line 834 "Utils.c"
				const gchar* _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
				GdkPixbuf* _tmp24_;
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp21_ = icon;
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp22_ = size;
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp23_ = size;
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp24_ = plank_drawing_service_load_icon (_tmp21_, _tmp22_, _tmp23_);
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_g_object_unref0 (image);
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				image = _tmp24_;
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				not_cached = TRUE;
#line 853 "Utils.c"
			}
		}
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_object_unref0 (appinfo);
#line 858 "Utils.c"
	}
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp25_ = image;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp25_ == NULL) {
#line 864 "Utils.c"
		{
			GtkIconTheme* icon_theme = NULL;
			GtkIconTheme* _tmp26_;
			gchar* _tmp27_;
			const gchar* _tmp28_;
			gint _tmp29_;
			gchar* _tmp30_;
			GHashTable* _tmp31_;
			const gchar* _tmp32_;
			gconstpointer _tmp33_;
			GdkPixbuf* _tmp34_;
			GdkPixbuf* _tmp35_;
#line 147 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp26_ = gtk_icon_theme_get_default ();
#line 147 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			icon_theme = _tmp26_;
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp27_ = g_strdup ("application-default-icon");
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_free0 (icon);
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			icon = _tmp27_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp28_ = icon;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp29_ = size;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp30_ = g_strdup_printf ("%s::%i", _tmp28_, _tmp29_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_free0 (icon_key);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			icon_key = _tmp30_;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp31_ = gala_utils_icon_pixbuf_cache;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp32_ = icon_key;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp33_ = g_hash_table_lookup (_tmp31_, _tmp32_);
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp34_ = _g_object_ref0 ((GdkPixbuf*) _tmp33_);
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (image);
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			image = _tmp34_;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp35_ = image;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (_tmp35_ == NULL) {
#line 913 "Utils.c"
				GdkPixbuf* _tmp36_ = NULL;
				GtkIconTheme* _tmp37_;
				const gchar* _tmp38_;
				gint _tmp39_;
				GdkPixbuf* _tmp40_;
				GdkPixbuf* _tmp41_;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp37_ = icon_theme;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp38_ = icon;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp39_ = size;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp40_ = gtk_icon_theme_load_icon (_tmp37_, _tmp38_, _tmp39_, 0, &_inner_error_);
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp36_ = _tmp40_;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 932 "Utils.c"
					goto __catch0_g_error;
				}
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp41_ = _tmp36_;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp36_ = NULL;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_g_object_unref0 (image);
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				image = _tmp41_;
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				not_cached = TRUE;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_g_object_unref0 (_tmp36_);
#line 947 "Utils.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp42_;
			const gchar* _tmp43_;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			e = _inner_error_;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_inner_error_ = NULL;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp42_ = e;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp43_ = _tmp42_->message;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_warning ("Utils.vala:155: %s", _tmp43_);
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_error_free0 (e);
#line 968 "Utils.c"
		}
		__finally0:
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_free0 (icon_key);
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_free0 (icon);
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (image);
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return NULL;
#line 985 "Utils.c"
		}
	}
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp44_ = image;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp44_ == NULL) {
#line 992 "Utils.c"
		gchar* _tmp45_;
		gint _tmp46_;
		gchar* _tmp47_;
		GHashTable* _tmp48_;
		const gchar* _tmp49_;
		gconstpointer _tmp50_;
		GdkPixbuf* _tmp51_;
		GdkPixbuf* _tmp52_;
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp45_ = g_strdup ("");
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_free0 (icon);
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		icon = _tmp45_;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp46_ = size;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp47_ = g_strdup_printf ("::%i", _tmp46_);
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_free0 (icon_key);
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		icon_key = _tmp47_;
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp48_ = gala_utils_icon_pixbuf_cache;
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp49_ = icon_key;
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp50_ = g_hash_table_lookup (_tmp48_, _tmp49_);
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp51_ = _g_object_ref0 ((GdkPixbuf*) _tmp50_);
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_object_unref0 (image);
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		image = _tmp51_;
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp52_ = image;
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (_tmp52_ == NULL) {
#line 1031 "Utils.c"
			gint _tmp53_;
			gint _tmp54_;
			GdkPixbuf* _tmp55_;
			GdkPixbuf* _tmp56_;
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp53_ = size;
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp54_ = size;
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp55_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, _tmp53_, _tmp54_);
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (image);
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			image = _tmp55_;
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp56_ = image;
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			gdk_pixbuf_fill (_tmp56_, (guint32) 0x00000000);
#line 165 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			not_cached = TRUE;
#line 1052 "Utils.c"
		}
	}
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp58_ = size;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp59_ = image;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp60_ = gdk_pixbuf_get_width (_tmp59_);
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp61_ = _tmp60_;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp58_ != _tmp61_) {
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp57_ = TRUE;
#line 1067 "Utils.c"
	} else {
		gint _tmp62_;
		GdkPixbuf* _tmp63_;
		gint _tmp64_;
		gint _tmp65_;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp62_ = size;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp63_ = image;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp64_ = gdk_pixbuf_get_height (_tmp63_);
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp65_ = _tmp64_;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp57_ = _tmp62_ != _tmp65_;
#line 1083 "Utils.c"
	}
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp57_) {
#line 1087 "Utils.c"
		GdkPixbuf* _tmp66_;
		gint _tmp67_;
		gint _tmp68_;
		GdkPixbuf* _tmp69_;
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp66_ = image;
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp67_ = size;
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp68_ = size;
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp69_ = plank_drawing_service_ar_scale (_tmp66_, _tmp67_, _tmp68_);
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_object_unref0 (image);
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		image = _tmp69_;
#line 1104 "Utils.c"
	}
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp70_ = not_cached;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp70_) {
#line 1110 "Utils.c"
		GHashTable* _tmp71_;
		const gchar* _tmp72_;
		gchar* _tmp73_;
		GdkPixbuf* _tmp74_;
		GdkPixbuf* _tmp75_;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp71_ = gala_utils_icon_pixbuf_cache;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp72_ = icon_key;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp73_ = g_strdup (_tmp72_);
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp74_ = image;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp75_ = _g_object_ref0 (_tmp74_);
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_hash_table_insert (_tmp71_, _tmp73_, _tmp75_);
#line 1128 "Utils.c"
	}
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = image;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_free0 (icon_key);
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_free0 (icon);
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1138 "Utils.c"
}


/**
 * Get the next window that should be active on a workspace right now. Based on
 * stacking order
 *
 * @param workspace The workspace on which to find the window
 * @param backward  Whether to get the previous one instead
 */
MetaWindow* gala_utils_get_next_window (MetaWorkspace* workspace, gboolean backward) {
	MetaWindow* result = NULL;
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaDisplay* display = NULL;
	MetaScreen* _tmp3_;
	MetaDisplay* _tmp4_;
	MetaDisplay* _tmp5_;
	MetaWindow* window = NULL;
	MetaDisplay* _tmp6_;
	MetaWorkspace* _tmp7_;
	gboolean _tmp8_;
	MetaWindow* _tmp9_;
	MetaWindow* _tmp10_;
	MetaWindow* _tmp11_;
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (workspace != NULL, NULL);
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = workspace;
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = meta_workspace_get_screen (_tmp0_);
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	screen = _tmp2_;
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp3_ = screen;
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp4_ = meta_screen_get_display (_tmp3_);
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	display = _tmp5_;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp6_ = display;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp7_ = workspace;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp8_ = backward;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp9_ = meta_display_get_tab_next (_tmp6_, META_TAB_LIST_NORMAL, _tmp7_, NULL, _tmp8_);
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	window = _tmp10_;
#line 193 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp11_ = window;
#line 193 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp11_ == NULL) {
#line 1200 "Utils.c"
		MetaDisplay* _tmp12_;
		MetaWorkspace* _tmp13_;
		MetaWindow* _tmp14_;
		MetaWindow* _tmp15_;
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp12_ = display;
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp13_ = workspace;
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp14_ = meta_display_get_tab_current (_tmp12_, META_TAB_LIST_NORMAL, _tmp13_);
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp15_ = _g_object_ref0 (_tmp14_);
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_object_unref0 (window);
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		window = _tmp15_;
#line 1217 "Utils.c"
	}
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = window;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (display);
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (screen);
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1227 "Utils.c"
}


/**
 * Get the number of toplevel windows on a workspace excluding those that are
 * on all workspaces
 *
 * @param workspace The workspace on which to count the windows
 */
guint gala_utils_get_n_windows (MetaWorkspace* workspace) {
	guint result = 0U;
	gint n = 0;
	MetaWorkspace* _tmp0_;
	GList* _tmp1_;
#line 205 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (workspace != NULL, 0U);
#line 207 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	n = 0;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = workspace;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = meta_workspace_list_windows (_tmp0_);
#line 1250 "Utils.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		window_collection = _tmp1_;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1258 "Utils.c"
			MetaWindow* window = NULL;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			window = (MetaWindow*) window_it->data;
#line 1262 "Utils.c"
			{
				MetaWindow* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				MetaWindow* _tmp6_;
				MetaWindowType _tmp7_;
				MetaWindowType _tmp8_;
#line 209 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp2_ = window;
#line 209 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp3_ = meta_window_is_on_all_workspaces (_tmp2_);
#line 209 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				if (_tmp3_) {
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					continue;
#line 1279 "Utils.c"
				}
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp6_ = window;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp7_ = meta_window_get_window_type (_tmp6_);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp8_ = _tmp7_;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				if (_tmp8_ == META_WINDOW_NORMAL) {
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp5_ = TRUE;
#line 1291 "Utils.c"
				} else {
					MetaWindow* _tmp9_;
					MetaWindowType _tmp10_;
					MetaWindowType _tmp11_;
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp9_ = window;
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp10_ = meta_window_get_window_type (_tmp9_);
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp11_ = _tmp10_;
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp5_ = _tmp11_ == META_WINDOW_DIALOG;
#line 1304 "Utils.c"
				}
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				if (_tmp5_) {
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp4_ = TRUE;
#line 1310 "Utils.c"
				} else {
					MetaWindow* _tmp12_;
					MetaWindowType _tmp13_;
					MetaWindowType _tmp14_;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp12_ = window;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp13_ = meta_window_get_window_type (_tmp12_);
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp14_ = _tmp13_;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp4_ = _tmp14_ == META_WINDOW_MODAL_DIALOG;
#line 1323 "Utils.c"
				}
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				if (_tmp4_) {
#line 1327 "Utils.c"
					gint _tmp15_;
#line 214 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					_tmp15_ = n;
#line 214 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
					n = _tmp15_ + 1;
#line 1333 "Utils.c"
				}
			}
		}
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_list_free0 (window_collection);
#line 1339 "Utils.c"
	}
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = (guint) n;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1345 "Utils.c"
}


/**
 * Creates an actor showing the current contents of the given WindowActor.
 *
 * @param actor 	 The actor from which to create a shnapshot
 * @param inner_rect The inner (actually visible) rectangle of the window
 * @param outer_rect The outer (input region) rectangle of the window
 *
 * @return           A copy of the actor at that time or %NULL
 */
static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return _data2_;
#line 1363 "Utils.c"
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_cairo_surface_destroy0 (_data2_->surface);
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_slice_free (Block2Data, _data2_);
#line 1376 "Utils.c"
	}
}


static gboolean __lambda7_ (Block2Data* _data2_, cairo_t* cr) {
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_t* _tmp2_;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = cr;
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = _data2_->surface;
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	cairo_set_source_surface (_tmp0_, _tmp1_, (gdouble) 0, (gdouble) 0);
#line 249 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = cr;
#line 249 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	cairo_paint (_tmp2_);
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = FALSE;
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1402 "Utils.c"
}


static gboolean ___lambda7__clutter_canvas_draw (ClutterCanvas* _sender, cairo_t* cr, gint width, gint height, gpointer self) {
	gboolean result;
	result = __lambda7_ (self, cr);
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1411 "Utils.c"
}


ClutterActor* gala_utils_get_window_actor_snapshot (MetaWindowActor* actor, MetaRectangle* inner_rect, MetaRectangle* outer_rect) {
	ClutterActor* result = NULL;
	Block2Data* _data2_;
	MetaShapedTexture* texture = NULL;
	MetaWindowActor* _tmp0_;
	ClutterActor* _tmp1_;
	MetaShapedTexture* _tmp2_;
	MetaShapedTexture* _tmp3_;
	MetaShapedTexture* _tmp4_;
	MetaRectangle _tmp5_;
	gint _tmp6_;
	MetaRectangle _tmp7_;
	gint _tmp8_;
	MetaRectangle _tmp9_;
	gint _tmp10_;
	MetaRectangle _tmp11_;
	gint _tmp12_;
	MetaRectangle _tmp13_;
	gint _tmp14_;
	MetaRectangle _tmp15_;
	gint _tmp16_;
	cairo_rectangle_int_t _tmp17_ = {0};
	cairo_surface_t* _tmp18_;
	cairo_surface_t* _tmp19_;
	ClutterCanvas* canvas = NULL;
	ClutterCanvas* _tmp20_;
	gulong handler = 0UL;
	ClutterCanvas* _tmp21_;
	gulong _tmp22_;
	ClutterCanvas* _tmp23_;
	MetaRectangle _tmp24_;
	gint _tmp25_;
	MetaRectangle _tmp26_;
	gint _tmp27_;
	ClutterCanvas* _tmp28_;
	gulong _tmp29_;
	ClutterActor* container = NULL;
	ClutterActor* _tmp30_;
	ClutterActor* _tmp31_;
	MetaRectangle _tmp32_;
	gint _tmp33_;
	MetaRectangle _tmp34_;
	gint _tmp35_;
	ClutterActor* _tmp36_;
	ClutterCanvas* _tmp37_;
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (inner_rect != NULL, NULL);
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (outer_rect != NULL, NULL);
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data2_->_ref_count_ = 1;
#line 231 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = actor;
#line 231 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = meta_window_actor_get_texture (_tmp0_);
#line 231 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, meta_shaped_texture_get_type ()) ? ((MetaShapedTexture*) _tmp1_) : NULL);
#line 231 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	texture = _tmp2_;
#line 233 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp3_ = texture;
#line 233 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp3_ == NULL) {
#line 234 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		result = NULL;
#line 234 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_object_unref0 (texture);
#line 234 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		block2_data_unref (_data2_);
#line 234 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_data2_ = NULL;
#line 234 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		return result;
#line 1492 "Utils.c"
	}
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp4_ = texture;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp5_ = *inner_rect;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp6_ = _tmp5_.x;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp7_ = *outer_rect;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp8_ = _tmp7_.x;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp9_ = *inner_rect;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp10_ = _tmp9_.y;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp11_ = *outer_rect;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp12_ = _tmp11_.y;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp13_ = *inner_rect;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp14_ = _tmp13_.width;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp15_ = *inner_rect;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp16_ = _tmp15_.height;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp17_.x = _tmp6_ - _tmp8_;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp17_.y = _tmp10_ - _tmp12_;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp17_.width = _tmp14_;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp17_.height = _tmp16_;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp18_ = meta_shaped_texture_get_image (_tmp4_, &_tmp17_);
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data2_->surface = _tmp18_;
#line 243 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp19_ = _data2_->surface;
#line 243 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp19_ == NULL) {
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		result = NULL;
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_g_object_unref0 (texture);
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		block2_data_unref (_data2_);
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_data2_ = NULL;
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		return result;
#line 1546 "Utils.c"
	}
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp20_ = (ClutterCanvas*) clutter_canvas_new ();
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	canvas = _tmp20_;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp21_ = canvas;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp22_ = g_signal_connect_data (_tmp21_, "draw", (GCallback) ___lambda7__clutter_canvas_draw, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	handler = _tmp22_;
#line 252 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp23_ = canvas;
#line 252 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp24_ = *inner_rect;
#line 252 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp25_ = _tmp24_.width;
#line 252 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp26_ = *inner_rect;
#line 252 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp27_ = _tmp26_.height;
#line 252 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	clutter_canvas_set_size (_tmp23_, _tmp25_, _tmp27_);
#line 253 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp28_ = canvas;
#line 253 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp29_ = handler;
#line 253 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_signal_handler_disconnect (_tmp28_, _tmp29_);
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp30_ = clutter_actor_new ();
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_object_ref_sink (_tmp30_);
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	container = _tmp30_;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp31_ = container;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp32_ = *inner_rect;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp33_ = _tmp32_.width;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp34_ = *inner_rect;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp35_ = _tmp34_.height;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	clutter_actor_set_size (_tmp31_, (gfloat) _tmp33_, (gfloat) _tmp35_);
#line 257 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp36_ = container;
#line 257 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp37_ = canvas;
#line 257 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	clutter_actor_set_content (_tmp36_, (ClutterContent*) _tmp37_);
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = container;
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (canvas);
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (texture);
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	block2_data_unref (_data2_);
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_data2_ = NULL;
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1612 "Utils.c"
}


/**
 * Ring the system bell, will most likely emit a <beep> error sound or, if the
 * audible bell is disabled, flash the screen
 *
 * @param screen The screen to flash, if necessary
 */
void gala_utils_bell (MetaScreen* screen) {
	gboolean _tmp0_;
#line 268 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_if_fail (screen != NULL);
#line 270 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = meta_prefs_bell_is_audible ();
#line 270 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp0_) {
#line 271 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		gdk_beep ();
#line 1632 "Utils.c"
	} else {
		MetaScreen* _tmp1_;
		MetaDisplay* _tmp2_;
		MetaCompositor* _tmp3_;
		MetaScreen* _tmp4_;
#line 273 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp1_ = screen;
#line 273 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp2_ = meta_screen_get_display (_tmp1_);
#line 273 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp3_ = meta_display_get_compositor (_tmp2_);
#line 273 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp4_ = screen;
#line 273 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		meta_compositor_flash_screen (_tmp3_, _tmp4_);
#line 1648 "Utils.c"
	}
}


/**
 * Returns the pixbuf that is used for close buttons throughout gala at a
 * size of 36px
 *
 * @return the close button pixbuf or null if it failed to load
 */
GdkPixbuf* gala_utils_get_close_button_pixbuf (void) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GError * _inner_error_ = NULL;
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = gala_utils_close_pixbuf;
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp0_ == NULL) {
#line 1669 "Utils.c"
		{
			GdkPixbuf* _tmp1_ = NULL;
			GdkPixbuf* _tmp2_;
			GdkPixbuf* _tmp3_;
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp2_ = gdk_pixbuf_new_from_resource_at_scale (RESOURCEPATH "/buttons/close.svg", -1, 36, TRUE, &_inner_error_);
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp1_ = _tmp2_;
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1680 "Utils.c"
				goto __catch1_g_error;
			}
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp3_ = _tmp1_;
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp1_ = NULL;
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (gala_utils_close_pixbuf);
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			gala_utils_close_pixbuf = _tmp3_;
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (_tmp1_);
#line 1693 "Utils.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			e = _inner_error_;
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_inner_error_ = NULL;
#line 288 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp4_ = e;
#line 288 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp5_ = _tmp4_->message;
#line 288 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_warning ("Utils.vala:288: %s", _tmp5_);
#line 289 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			result = NULL;
#line 289 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_error_free0 (e);
#line 289 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return result;
#line 1717 "Utils.c"
		}
		__finally1:
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return NULL;
#line 1728 "Utils.c"
		}
	}
#line 293 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp6_ = gala_utils_close_pixbuf;
#line 293 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 293 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = _tmp7_;
#line 293 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1739 "Utils.c"
}


/**
 * Creates a new reactive ClutterActor at 36px with the close pixbuf
 *
 * @return The close button actor
 */
ClutterActor* gala_utils_create_close_button (void) {
	ClutterActor* result = NULL;
	ClutterTexture* texture = NULL;
	ClutterTexture* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	ClutterTexture* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 303 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = (ClutterTexture*) clutter_texture_new ();
#line 303 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_object_ref_sink (_tmp0_);
#line 303 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	texture = _tmp0_;
#line 304 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = gala_utils_get_close_button_pixbuf ();
#line 304 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	pixbuf = _tmp1_;
#line 306 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = texture;
#line 306 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	clutter_actor_set_reactive ((ClutterActor*) _tmp2_, TRUE);
#line 308 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp3_ = pixbuf;
#line 308 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp3_ != NULL) {
#line 1775 "Utils.c"
		{
			gint _tmp4_ = 0;
			GdkPixbuf* _tmp5_;
			gboolean _tmp6_;
			ClutterTexture* _tmp7_;
			GdkPixbuf* _tmp8_;
			guint8* _tmp9_;
			GdkPixbuf* _tmp10_;
			gboolean _tmp11_;
			GdkPixbuf* _tmp12_;
			gint _tmp13_;
			GdkPixbuf* _tmp14_;
			gint _tmp15_;
			GdkPixbuf* _tmp16_;
			gint _tmp17_;
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp5_ = pixbuf;
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp6_ = gdk_pixbuf_get_has_alpha (_tmp5_);
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (_tmp6_) {
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp4_ = 4;
#line 1799 "Utils.c"
			} else {
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp4_ = 3;
#line 1803 "Utils.c"
			}
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp7_ = texture;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp8_ = pixbuf;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp9_ = gdk_pixbuf_get_pixels (_tmp8_);
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp10_ = pixbuf;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp11_ = gdk_pixbuf_get_has_alpha (_tmp10_);
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp12_ = pixbuf;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp14_ = pixbuf;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp15_ = gdk_pixbuf_get_height (_tmp14_);
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp16_ = pixbuf;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp17_ = gdk_pixbuf_get_rowstride (_tmp16_);
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			clutter_texture_set_from_rgb_data (_tmp7_, _tmp9_, _tmp11_, _tmp13_, _tmp15_, _tmp17_, _tmp4_, 0, &_inner_error_);
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1831 "Utils.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			e = _inner_error_;
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_inner_error_ = NULL;
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_error_free0 (e);
#line 1845 "Utils.c"
		}
		__finally2:
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (pixbuf);
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (texture);
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 309 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return NULL;
#line 1860 "Utils.c"
		}
	} else {
		ClutterTexture* _tmp18_;
		ClutterTexture* _tmp19_;
		ClutterColor _tmp20_ = {0};
#line 318 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp18_ = texture;
#line 318 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		clutter_actor_set_size ((ClutterActor*) _tmp18_, (gfloat) 36, (gfloat) 36);
#line 319 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp19_ = texture;
#line 319 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp20_.red = (guint8) 255;
#line 319 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp20_.green = (guint8) 0;
#line 319 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp20_.blue = (guint8) 0;
#line 319 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp20_.alpha = (guint8) 255;
#line 319 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		clutter_actor_set_background_color ((ClutterActor*) _tmp19_, &_tmp20_);
#line 1882 "Utils.c"
	}
#line 322 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = (ClutterActor*) texture;
#line 322 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (pixbuf);
#line 322 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1890 "Utils.c"
}


/**
 * Returns the pixbuf that is used for resize buttons throughout gala at a
 * size of 36px
 *
 * @return the close button pixbuf or null if it failed to load
 */
GdkPixbuf* gala_utils_get_resize_button_pixbuf (void) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GError * _inner_error_ = NULL;
#line 332 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = gala_utils_resize_pixbuf;
#line 332 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp0_ == NULL) {
#line 1910 "Utils.c"
		{
			GdkPixbuf* _tmp1_ = NULL;
			GdkPixbuf* _tmp2_;
			GdkPixbuf* _tmp3_;
#line 334 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp2_ = gdk_pixbuf_new_from_resource_at_scale (RESOURCEPATH "/buttons/resize.svg", -1, 36, TRUE, &_inner_error_);
#line 334 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp1_ = _tmp2_;
#line 334 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1921 "Utils.c"
				goto __catch3_g_error;
			}
#line 334 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp3_ = _tmp1_;
#line 334 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp1_ = NULL;
#line 334 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (gala_utils_resize_pixbuf);
#line 334 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			gala_utils_resize_pixbuf = _tmp3_;
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (_tmp1_);
#line 1934 "Utils.c"
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			e = _inner_error_;
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_inner_error_ = NULL;
#line 336 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp4_ = e;
#line 336 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp5_ = _tmp4_->message;
#line 336 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_warning ("Utils.vala:336: %s", _tmp5_);
#line 337 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			result = NULL;
#line 337 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_error_free0 (e);
#line 337 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return result;
#line 1958 "Utils.c"
		}
		__finally3:
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return NULL;
#line 1969 "Utils.c"
		}
	}
#line 341 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp6_ = gala_utils_resize_pixbuf;
#line 341 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 341 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = _tmp7_;
#line 341 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 1980 "Utils.c"
}


/**
 * Creates a new reactive ClutterActor at 36px with the resize pixbuf
 *
 * @return The resize button actor
 */
ClutterActor* gala_utils_create_resize_button (void) {
	ClutterActor* result = NULL;
	ClutterTexture* texture = NULL;
	ClutterTexture* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	ClutterTexture* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 351 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = (ClutterTexture*) clutter_texture_new ();
#line 351 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_object_ref_sink (_tmp0_);
#line 351 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	texture = _tmp0_;
#line 352 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = gala_utils_get_resize_button_pixbuf ();
#line 352 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	pixbuf = _tmp1_;
#line 354 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = texture;
#line 354 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	clutter_actor_set_reactive ((ClutterActor*) _tmp2_, TRUE);
#line 356 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp3_ = pixbuf;
#line 356 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (_tmp3_ != NULL) {
#line 2016 "Utils.c"
		{
			gint _tmp4_ = 0;
			GdkPixbuf* _tmp5_;
			gboolean _tmp6_;
			ClutterTexture* _tmp7_;
			GdkPixbuf* _tmp8_;
			guint8* _tmp9_;
			GdkPixbuf* _tmp10_;
			gboolean _tmp11_;
			GdkPixbuf* _tmp12_;
			gint _tmp13_;
			GdkPixbuf* _tmp14_;
			gint _tmp15_;
			GdkPixbuf* _tmp16_;
			gint _tmp17_;
#line 360 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp5_ = pixbuf;
#line 360 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp6_ = gdk_pixbuf_get_has_alpha (_tmp5_);
#line 360 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (_tmp6_) {
#line 360 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp4_ = 4;
#line 2040 "Utils.c"
			} else {
#line 360 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
				_tmp4_ = 3;
#line 2044 "Utils.c"
			}
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp7_ = texture;
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp8_ = pixbuf;
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp9_ = gdk_pixbuf_get_pixels (_tmp8_);
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp10_ = pixbuf;
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp11_ = gdk_pixbuf_get_has_alpha (_tmp10_);
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp12_ = pixbuf;
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp14_ = pixbuf;
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp15_ = gdk_pixbuf_get_height (_tmp14_);
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp16_ = pixbuf;
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_tmp17_ = gdk_pixbuf_get_rowstride (_tmp16_);
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			clutter_texture_set_from_rgb_data (_tmp7_, _tmp9_, _tmp11_, _tmp13_, _tmp15_, _tmp17_, _tmp4_, 0, &_inner_error_);
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2072 "Utils.c"
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			e = _inner_error_;
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_inner_error_ = NULL;
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_error_free0 (e);
#line 2086 "Utils.c"
		}
		__finally4:
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (pixbuf);
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			_g_object_unref0 (texture);
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			g_clear_error (&_inner_error_);
#line 357 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return NULL;
#line 2101 "Utils.c"
		}
	} else {
		ClutterTexture* _tmp18_;
		ClutterTexture* _tmp19_;
		ClutterColor _tmp20_ = {0};
#line 366 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp18_ = texture;
#line 366 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		clutter_actor_set_size ((ClutterActor*) _tmp18_, (gfloat) 36, (gfloat) 36);
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp19_ = texture;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp20_.red = (guint8) 255;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp20_.green = (guint8) 0;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp20_.blue = (guint8) 0;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		_tmp20_.alpha = (guint8) 255;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		clutter_actor_set_background_color ((ClutterActor*) _tmp19_, &_tmp20_);
#line 2123 "Utils.c"
	}
#line 370 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	result = (ClutterActor*) texture;
#line 370 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_object_unref0 (pixbuf);
#line 370 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return result;
#line 2131 "Utils.c"
}


static void _g_free0_ (gpointer var) {
#line 32 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	var = (g_free (var), NULL);
#line 2138 "Utils.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 32 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2145 "Utils.c"
}


static void gala_value_utils_init (GValue* value) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	value->data[0].v_pointer = NULL;
#line 2152 "Utils.c"
}


static void gala_value_utils_free_value (GValue* value) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		gala_utils_unref (value->data[0].v_pointer);
#line 2161 "Utils.c"
	}
}


static void gala_value_utils_copy_value (const GValue* src_value, GValue* dest_value) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		dest_value->data[0].v_pointer = gala_utils_ref (src_value->data[0].v_pointer);
#line 2171 "Utils.c"
	} else {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2175 "Utils.c"
	}
}


static gpointer gala_value_utils_peek_pointer (const GValue* value) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return value->data[0].v_pointer;
#line 2183 "Utils.c"
}


static gchar* gala_value_utils_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (collect_values[0].v_pointer) {
#line 2190 "Utils.c"
		GalaUtils * object;
		object = collect_values[0].v_pointer;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2197 "Utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2201 "Utils.c"
		}
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		value->data[0].v_pointer = gala_utils_ref (object);
#line 2205 "Utils.c"
	} else {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 2209 "Utils.c"
	}
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return NULL;
#line 2213 "Utils.c"
}


static gchar* gala_value_utils_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GalaUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (!object_p) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2224 "Utils.c"
	}
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (!value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		*object_p = NULL;
#line 2230 "Utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		*object_p = value->data[0].v_pointer;
#line 2234 "Utils.c"
	} else {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		*object_p = gala_utils_ref (value->data[0].v_pointer);
#line 2238 "Utils.c"
	}
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return NULL;
#line 2242 "Utils.c"
}


GParamSpec* gala_param_spec_utils (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GalaParamSpecUtils* spec;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GALA_TYPE_UTILS), NULL);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return G_PARAM_SPEC (spec);
#line 2256 "Utils.c"
}


gpointer gala_value_get_utils (const GValue* value) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS), NULL);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return value->data[0].v_pointer;
#line 2265 "Utils.c"
}


void gala_value_set_utils (GValue* value, gpointer v_object) {
	GalaUtils * old;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	old = value->data[0].v_pointer;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (v_object) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_UTILS));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		gala_utils_ref (value->data[0].v_pointer);
#line 2285 "Utils.c"
	} else {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 2289 "Utils.c"
	}
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (old) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		gala_utils_unref (old);
#line 2295 "Utils.c"
	}
}


void gala_value_take_utils (GValue* value, gpointer v_object) {
	GalaUtils * old;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	old = value->data[0].v_pointer;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (v_object) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_UTILS));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 2314 "Utils.c"
	} else {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 2318 "Utils.c"
	}
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (old) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		gala_utils_unref (old);
#line 2324 "Utils.c"
	}
}


static void gala_utils_class_init (GalaUtilsClass * klass) {
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	gala_utils_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	((GalaUtilsClass *) klass)->finalize = gala_utils_finalize;
#line 32 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp0_ = g_str_hash;
#line 32 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp1_ = g_str_equal;
#line 32 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 32 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_hash_table_unref0 (gala_utils_xid_pixbuf_cache);
#line 32 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	gala_utils_xid_pixbuf_cache = _tmp2_;
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp3_ = g_str_hash;
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp4_ = g_str_equal;
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _g_object_unref0_);
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	_g_hash_table_unref0 (gala_utils_icon_pixbuf_cache);
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	gala_utils_icon_pixbuf_cache = _tmp5_;
#line 2360 "Utils.c"
}


static void gala_utils_instance_init (GalaUtils * self) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	self->ref_count = 1;
#line 2367 "Utils.c"
}


static void gala_utils_finalize (GalaUtils * obj) {
	GalaUtils * self;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_UTILS, GalaUtils);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_signal_handlers_destroy (self);
#line 2377 "Utils.c"
}


GType gala_utils_get_type (void) {
	static volatile gsize gala_utils_type_id__volatile = 0;
	if (g_once_init_enter (&gala_utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gala_value_utils_init, gala_value_utils_free_value, gala_value_utils_copy_value, gala_value_utils_peek_pointer, "p", gala_value_utils_collect_value, "p", gala_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GalaUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaUtils), 0, (GInstanceInitFunc) gala_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gala_utils_type_id;
		gala_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gala_utils_type_id__volatile, gala_utils_type_id);
	}
	return gala_utils_type_id__volatile;
}


gpointer gala_utils_ref (gpointer instance) {
	GalaUtils * self;
	self = instance;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	return instance;
#line 2402 "Utils.c"
}


void gala_utils_unref (gpointer instance) {
	GalaUtils * self;
	self = instance;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		GALA_UTILS_GET_CLASS (self)->finalize (self);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/Utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2415 "Utils.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



