/* WindowIcon.c generated by valac 0.37.91, the Vala compiler
 * generated from WindowIcon.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <meta/window.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>


#define GALA_TYPE_WINDOW_ICON (gala_window_icon_get_type ())
#define GALA_WINDOW_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_ICON, GalaWindowIcon))
#define GALA_WINDOW_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_ICON, GalaWindowIconClass))
#define GALA_IS_WINDOW_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_ICON))
#define GALA_IS_WINDOW_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_ICON))
#define GALA_WINDOW_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_ICON, GalaWindowIconClass))

typedef struct _GalaWindowIcon GalaWindowIcon;
typedef struct _GalaWindowIconClass GalaWindowIconClass;
typedef struct _GalaWindowIconPrivate GalaWindowIconPrivate;
enum  {
	GALA_WINDOW_ICON_DUMMY_PROPERTY,
	GALA_WINDOW_ICON_WINDOW,
	GALA_WINDOW_ICON_ICON_SIZE,
	GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED,
	GALA_WINDOW_ICON_LAST_PROPERTY
};
static GParamSpec* gala_window_icon_properties[GALA_WINDOW_ICON_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GalaWindowIcon {
	ClutterTexture parent_instance;
	GalaWindowIconPrivate * priv;
};

struct _GalaWindowIconClass {
	ClutterTextureClass parent_class;
};

struct _GalaWindowIconPrivate {
	MetaWindow* _window;
	gint _icon_size;
	gboolean _destroy_on_unmanaged;
	gboolean loaded;
	guint32 xid;
};


static gpointer gala_window_icon_parent_class = NULL;
static BamfMatcher* gala_window_icon_matcher;
static BamfMatcher* gala_window_icon_matcher = NULL;

GType gala_window_icon_get_type (void) G_GNUC_CONST;
#define GALA_WINDOW_ICON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_WINDOW_ICON, GalaWindowIconPrivate))
static void gala_window_icon_retry_load (GalaWindowIcon* self, BamfView* view);
static void _gala_window_icon_retry_load_bamf_matcher_view_opened (BamfMatcher* _sender, BamfView* object, gpointer self);
GalaWindowIcon* gala_window_icon_new (MetaWindow* window, gint icon_size, gboolean destroy_on_unmanaged);
GalaWindowIcon* gala_window_icon_construct (GType object_type, MetaWindow* window, gint icon_size, gboolean destroy_on_unmanaged);
static void gala_window_icon_update_texture (GalaWindowIcon* self, gboolean initial);
GdkPixbuf* gala_utils_get_icon_for_xid (guint32 xid, gint size, gboolean ignore_cache);
gint gala_window_icon_get_icon_size (GalaWindowIcon* self);
static void gala_window_icon_unmanaged (GalaWindowIcon* self, MetaWindow* window);
MetaWindow* gala_window_icon_get_window (GalaWindowIcon* self);
static void gala_window_icon_set_window (GalaWindowIcon* self, MetaWindow* value);
static void gala_window_icon_set_icon_size (GalaWindowIcon* self, gint value);
gboolean gala_window_icon_get_destroy_on_unmanaged (GalaWindowIcon* self);
void gala_window_icon_set_destroy_on_unmanaged (GalaWindowIcon* self, gboolean value);
static void _gala_window_icon_unmanaged_meta_window_unmanaged (MetaWindow* _sender, gpointer self);
static GObject * gala_window_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void gala_window_icon_finalize (GObject * obj);
static void _vala_gala_window_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_window_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _gala_window_icon_retry_load_bamf_matcher_view_opened (BamfMatcher* _sender, BamfView* object, gpointer self) {
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	gala_window_icon_retry_load ((GalaWindowIcon*) self, object);
#line 100 "WindowIcon.c"
}


/**
 * Creates a new WindowIcon
 *
 * @param window               The window for which to create the icon
 * @param icon_size            The size of the icon in pixels
 * @param destroy_on_unmanaged see destroy_on_unmanaged property
 */
GalaWindowIcon* gala_window_icon_construct (GType object_type, MetaWindow* window, gint icon_size, gboolean destroy_on_unmanaged) {
	GalaWindowIcon * self = NULL;
	MetaWindow* _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = window;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp1_ = icon_size;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp2_ = destroy_on_unmanaged;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self = (GalaWindowIcon*) g_object_new (object_type, "window", _tmp0_, "icon-size", _tmp1_, "destroy-on-unmanaged", _tmp2_, NULL);
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	return self;
#line 128 "WindowIcon.c"
}


GalaWindowIcon* gala_window_icon_new (MetaWindow* window, gint icon_size, gboolean destroy_on_unmanaged) {
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	return gala_window_icon_construct (GALA_TYPE_WINDOW_ICON, window, icon_size, destroy_on_unmanaged);
#line 135 "WindowIcon.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	return self ? g_object_ref (self) : NULL;
#line 142 "WindowIcon.c"
}


static void gala_window_icon_retry_load (GalaWindowIcon* self, BamfView* view) {
	BamfApplication* app = NULL;
	BamfMatcher* _tmp0_;
	guint32 _tmp1_;
	BamfApplication* _tmp2_;
	BamfApplication* _tmp3_;
	BamfMatcher* _tmp4_;
	guint _tmp5_;
	BamfApplication* _tmp6_;
#line 99 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 99 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_if_fail (view != NULL);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = gala_window_icon_matcher;
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp1_ = self->priv->xid;
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp2_ = bamf_matcher_get_application_for_xid (_tmp0_, _tmp1_);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	app = _tmp3_;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self->priv->loaded = TRUE;
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp4_ = gala_window_icon_matcher;
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_signal_parse_name ("view-opened", bamf_matcher_get_type (), &_tmp5_, NULL, FALSE);
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self);
#line 107 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp6_ = app;
#line 107 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	if (_tmp6_ == NULL) {
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_g_object_unref0 (app);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		return;
#line 185 "WindowIcon.c"
	}
#line 110 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	gala_window_icon_update_texture (self, FALSE);
#line 99 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_g_object_unref0 (app);
#line 191 "WindowIcon.c"
}


static void gala_window_icon_update_texture (GalaWindowIcon* self, gboolean initial) {
	GdkPixbuf* pixbuf = NULL;
	guint32 _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = self->priv->xid;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp1_ = self->priv->_icon_size;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp2_ = initial;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp3_ = gala_utils_get_icon_for_xid (_tmp0_, _tmp1_, !_tmp2_);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	pixbuf = _tmp3_;
#line 214 "WindowIcon.c"
	{
		gint _tmp4_ = 0;
		GdkPixbuf* _tmp5_;
		gboolean _tmp6_;
		GdkPixbuf* _tmp7_;
		guint8* _tmp8_;
		GdkPixbuf* _tmp9_;
		gboolean _tmp10_;
		GdkPixbuf* _tmp11_;
		gint _tmp12_;
		GdkPixbuf* _tmp13_;
		gint _tmp14_;
		GdkPixbuf* _tmp15_;
		gint _tmp16_;
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp5_ = pixbuf;
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp6_ = gdk_pixbuf_get_has_alpha (_tmp5_);
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		if (_tmp6_) {
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
			_tmp4_ = 4;
#line 237 "WindowIcon.c"
		} else {
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
			_tmp4_ = 3;
#line 241 "WindowIcon.c"
		}
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp7_ = pixbuf;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp8_ = gdk_pixbuf_get_pixels (_tmp7_);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp9_ = pixbuf;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp10_ = gdk_pixbuf_get_has_alpha (_tmp9_);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp11_ = pixbuf;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp12_ = gdk_pixbuf_get_width (_tmp11_);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp13_ = pixbuf;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp14_ = gdk_pixbuf_get_height (_tmp13_);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp15_ = pixbuf;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp16_ = gdk_pixbuf_get_rowstride (_tmp15_);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		clutter_texture_set_from_rgb_data ((ClutterTexture*) self, _tmp8_, _tmp10_, _tmp12_, _tmp14_, _tmp16_, _tmp4_, 0, &_inner_error_);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 267 "WindowIcon.c"
			goto __catch5_g_error;
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		e = _inner_error_;
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_inner_error_ = NULL;
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_g_error_free0 (e);
#line 281 "WindowIcon.c"
	}
	__finally5:
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_g_object_unref0 (pixbuf);
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_clear_error (&_inner_error_);
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		return;
#line 294 "WindowIcon.c"
	}
#line 113 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_g_object_unref0 (pixbuf);
#line 298 "WindowIcon.c"
}


static void gala_window_icon_unmanaged (GalaWindowIcon* self, MetaWindow* window) {
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_if_fail (window != NULL);
#line 126 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	clutter_actor_destroy ((ClutterActor*) self);
#line 309 "WindowIcon.c"
}


MetaWindow* gala_window_icon_get_window (GalaWindowIcon* self) {
	MetaWindow* result;
	MetaWindow* _tmp0_;
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = self->priv->_window;
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	return result;
#line 324 "WindowIcon.c"
}


static void gala_window_icon_set_window (GalaWindowIcon* self, MetaWindow* value) {
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	if (gala_window_icon_get_window (self) != value) {
#line 333 "WindowIcon.c"
		MetaWindow* _tmp0_;
		MetaWindow* _tmp1_;
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp0_ = value;
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_g_object_unref0 (self->priv->_window);
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		self->priv->_window = _tmp1_;
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_WINDOW]);
#line 346 "WindowIcon.c"
	}
}


gint gala_window_icon_get_icon_size (GalaWindowIcon* self) {
	gint result;
	gint _tmp0_;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = self->priv->_icon_size;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	return result;
#line 362 "WindowIcon.c"
}


static void gala_window_icon_set_icon_size (GalaWindowIcon* self, gint value) {
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	if (gala_window_icon_get_icon_size (self) != value) {
#line 371 "WindowIcon.c"
		gint _tmp0_;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp0_ = value;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		self->priv->_icon_size = _tmp0_;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_ICON_SIZE]);
#line 379 "WindowIcon.c"
	}
}


gboolean gala_window_icon_get_destroy_on_unmanaged (GalaWindowIcon* self) {
	gboolean result;
	gboolean _tmp0_;
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = self->priv->_destroy_on_unmanaged;
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	result = _tmp0_;
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	return result;
#line 395 "WindowIcon.c"
}


static void _gala_window_icon_unmanaged_meta_window_unmanaged (MetaWindow* _sender, gpointer self) {
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	gala_window_icon_unmanaged ((GalaWindowIcon*) self, _sender);
#line 402 "WindowIcon.c"
}


void gala_window_icon_set_destroy_on_unmanaged (GalaWindowIcon* self, gboolean value) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_return_if_fail (self != NULL);
#line 46 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = self->priv->_destroy_on_unmanaged;
#line 46 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp1_ = value;
#line 46 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	if (_tmp0_ == _tmp1_) {
#line 47 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		return;
#line 421 "WindowIcon.c"
	}
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp2_ = value;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self->priv->_destroy_on_unmanaged = _tmp2_;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp3_ = self->priv->_destroy_on_unmanaged;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	if (_tmp3_) {
#line 431 "WindowIcon.c"
		MetaWindow* _tmp4_;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp4_ = self->priv->_window;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_signal_connect_object (_tmp4_, "unmanaged", (GCallback) _gala_window_icon_unmanaged_meta_window_unmanaged, self, 0);
#line 437 "WindowIcon.c"
	} else {
		MetaWindow* _tmp5_;
		guint _tmp6_;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp5_ = self->priv->_window;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_signal_parse_name ("unmanaged", meta_window_get_type (), &_tmp6_, NULL, FALSE);
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _gala_window_icon_unmanaged_meta_window_unmanaged, self);
#line 447 "WindowIcon.c"
	}
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_object_notify_by_pspec ((GObject *) self, gala_window_icon_properties[GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED]);
#line 451 "WindowIcon.c"
}


static GObject * gala_window_icon_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowIcon * self;
	gint _tmp0_;
	gint _tmp1_;
	MetaWindow* _tmp2_;
	Window _tmp3_;
	BamfApplication* app = NULL;
	BamfMatcher* _tmp4_;
	guint32 _tmp5_;
	BamfApplication* _tmp6_;
	BamfApplication* _tmp7_;
	BamfApplication* _tmp8_;
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	parent_class = G_OBJECT_CLASS (gala_window_icon_parent_class);
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = self->priv->_icon_size;
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	clutter_actor_set_width ((ClutterActor*) self, (gfloat) _tmp0_);
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp1_ = self->priv->_icon_size;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	clutter_actor_set_height ((ClutterActor*) self, (gfloat) _tmp1_);
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp2_ = self->priv->_window;
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp3_ = meta_window_get_xwindow (_tmp2_);
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self->priv->xid = (guint32) _tmp3_;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp4_ = gala_window_icon_matcher;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp5_ = self->priv->xid;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp6_ = bamf_matcher_get_application_for_xid (_tmp4_, _tmp5_);
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	app = _tmp7_;
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp8_ = app;
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	if (_tmp8_ == NULL) {
#line 503 "WindowIcon.c"
		BamfMatcher* _tmp9_;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp9_ = gala_window_icon_matcher;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_signal_connect_object (_tmp9_, "view-opened", (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self, 0);
#line 509 "WindowIcon.c"
	} else {
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		self->priv->loaded = TRUE;
#line 513 "WindowIcon.c"
	}
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	gala_window_icon_update_texture (self, TRUE);
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_g_object_unref0 (app);
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	return obj;
#line 521 "WindowIcon.c"
}


static void gala_window_icon_class_init (GalaWindowIconClass * klass) {
	BamfMatcher* _tmp0_;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	gala_window_icon_parent_class = g_type_class_peek_parent (klass);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_type_class_add_private (klass, sizeof (GalaWindowIconPrivate));
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_icon_get_property;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_icon_set_property;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_icon_constructor;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_icon_finalize;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_WINDOW, gala_window_icon_properties[GALA_WINDOW_ICON_WINDOW] = g_param_spec_object ("window", "window", "window", meta_window_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_ICON_SIZE, gala_window_icon_properties[GALA_WINDOW_ICON_ICON_SIZE] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 543 "WindowIcon.c"
	/**
	 * If set to true, the SafeWindowClone will destroy itself when the connected
	 * window is unmanaged
	 */
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED, gala_window_icon_properties[GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED] = g_param_spec_boolean ("destroy-on-unmanaged", "destroy-on-unmanaged", "destroy-on-unmanaged", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = bamf_matcher_get_default ();
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_g_object_unref0 (gala_window_icon_matcher);
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	gala_window_icon_matcher = _tmp0_;
#line 556 "WindowIcon.c"
}


static void gala_window_icon_instance_init (GalaWindowIcon * self) {
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self->priv = GALA_WINDOW_ICON_GET_PRIVATE (self);
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self->priv->_destroy_on_unmanaged = FALSE;
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self->priv->loaded = FALSE;
#line 567 "WindowIcon.c"
}


static void gala_window_icon_finalize (GObject * obj) {
	GalaWindowIcon * self;
	gboolean _tmp0_;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_tmp0_ = self->priv->loaded;
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	if (!_tmp0_) {
#line 580 "WindowIcon.c"
		BamfMatcher* _tmp1_;
		guint _tmp2_;
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		_tmp1_ = gala_window_icon_matcher;
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_signal_parse_name ("view-opened", bamf_matcher_get_type (), &_tmp2_, NULL, FALSE);
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_window_icon_retry_load_bamf_matcher_view_opened, self);
#line 589 "WindowIcon.c"
	}
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	_g_object_unref0 (self->priv->_window);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	G_OBJECT_CLASS (gala_window_icon_parent_class)->finalize (obj);
#line 595 "WindowIcon.c"
}


/**
 * Creates a new ClutterTexture with an icon for the window at the given size.
 * This is recommended way to grab an icon for a window as this method will make
 * sure the icon is updated if it becomes available at a later point.
 */
GType gala_window_icon_get_type (void) {
	static volatile gsize gala_window_icon_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWindowIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowIcon), 0, (GInstanceInitFunc) gala_window_icon_instance_init, NULL };
		GType gala_window_icon_type_id;
		gala_window_icon_type_id = g_type_register_static (clutter_texture_get_type (), "GalaWindowIcon", &g_define_type_info, 0);
		g_once_init_leave (&gala_window_icon_type_id__volatile, gala_window_icon_type_id);
	}
	return gala_window_icon_type_id__volatile;
}


static void _vala_gala_window_icon_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaWindowIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	switch (property_id) {
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		case GALA_WINDOW_ICON_WINDOW:
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_value_set_object (value, gala_window_icon_get_window (self));
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		break;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		case GALA_WINDOW_ICON_ICON_SIZE:
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_value_set_int (value, gala_window_icon_get_icon_size (self));
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		break;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		case GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED:
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		g_value_set_boolean (value, gala_window_icon_get_destroy_on_unmanaged (self));
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		break;
#line 639 "WindowIcon.c"
		default:
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		break;
#line 645 "WindowIcon.c"
	}
}


static void _vala_gala_window_icon_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaWindowIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
	switch (property_id) {
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		case GALA_WINDOW_ICON_WINDOW:
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		gala_window_icon_set_window (self, g_value_get_object (value));
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		break;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		case GALA_WINDOW_ICON_ICON_SIZE:
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		gala_window_icon_set_icon_size (self, g_value_get_int (value));
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		break;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		case GALA_WINDOW_ICON_DESTROY_ON_UNMANAGED:
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		gala_window_icon_set_destroy_on_unmanaged (self, g_value_get_boolean (value));
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		break;
#line 673 "WindowIcon.c"
		default:
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowIcon.vala"
		break;
#line 679 "WindowIcon.c"
	}
}



