/* WindowManager.c generated by valac 0.37.91, the Vala compiler
 * generated from WindowManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <meta/keybindings.h>
#include <meta/meta-plugin.h>
#include <meta/window.h>
#include <meta/common.h>
#include <clutter/clutter.h>
#include <meta/meta-background-group.h>


#define GALA_TYPE_ACTION_TYPE (gala_action_type_get_type ())

#define GALA_TYPE_MODAL_PROXY (gala_modal_proxy_get_type ())
#define GALA_MODAL_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_MODAL_PROXY, GalaModalProxy))
#define GALA_MODAL_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_MODAL_PROXY, GalaModalProxyClass))
#define GALA_IS_MODAL_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_MODAL_PROXY))
#define GALA_IS_MODAL_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_MODAL_PROXY))
#define GALA_MODAL_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_MODAL_PROXY, GalaModalProxyClass))

typedef struct _GalaModalProxy GalaModalProxy;
typedef struct _GalaModalProxyClass GalaModalProxyClass;
typedef struct _GalaModalProxyPrivate GalaModalProxyPrivate;
enum  {
	GALA_MODAL_PROXY_DUMMY_PROPERTY,
	GALA_MODAL_PROXY_LAST_PROPERTY
};
static GParamSpec* gala_modal_proxy_properties[GALA_MODAL_PROXY_LAST_PROPERTY];

#define GALA_TYPE_WINDOW_MANAGER (gala_window_manager_get_type ())
#define GALA_WINDOW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_MANAGER, GalaWindowManager))
#define GALA_IS_WINDOW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_MANAGER))
#define GALA_WINDOW_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GALA_TYPE_WINDOW_MANAGER, GalaWindowManagerIface))

typedef struct _GalaWindowManager GalaWindowManager;
typedef struct _GalaWindowManagerIface GalaWindowManagerIface;

typedef enum  {
	GALA_ACTION_TYPE_NONE = 0,
	GALA_ACTION_TYPE_SHOW_WORKSPACE_VIEW,
	GALA_ACTION_TYPE_MAXIMIZE_CURRENT,
	GALA_ACTION_TYPE_MINIMIZE_CURRENT,
	GALA_ACTION_TYPE_OPEN_LAUNCHER,
	GALA_ACTION_TYPE_CUSTOM_COMMAND,
	GALA_ACTION_TYPE_WINDOW_OVERVIEW,
	GALA_ACTION_TYPE_WINDOW_OVERVIEW_ALL
} GalaActionType;

typedef gboolean (*GalaKeybindingFilter) (MetaKeyBinding* binding, void* user_data);
struct _GalaModalProxy {
	GObject parent_instance;
	GalaModalProxyPrivate * priv;
};

struct _GalaModalProxyClass {
	GObjectClass parent_class;
};

struct _GalaModalProxyPrivate {
	GalaKeybindingFilter _keybinding_filter;
	gpointer _keybinding_filter_target;
	GDestroyNotify _keybinding_filter_target_destroy_notify;
};

struct _GalaWindowManagerIface {
	GTypeInterface parent_iface;
	GalaModalProxy* (*push_modal) (GalaWindowManager* self);
	void (*pop_modal) (GalaWindowManager* self, GalaModalProxy* proxy);
	gboolean (*is_modal) (GalaWindowManager* self);
	gboolean (*modal_proxy_valid) (GalaWindowManager* self, GalaModalProxy* proxy);
	void (*perform_action) (GalaWindowManager* self, GalaActionType type);
	void (*move_window) (GalaWindowManager* self, MetaWindow* window, MetaMotionDirection direction);
	void (*switch_to_next_workspace) (GalaWindowManager* self, MetaMotionDirection direction);
	ClutterActor* (*get_ui_group) (GalaWindowManager* self);
	void (*set_ui_group) (GalaWindowManager* self, ClutterActor* value);
	ClutterStage* (*get_stage) (GalaWindowManager* self);
	void (*set_stage) (GalaWindowManager* self, ClutterStage* value);
	ClutterActor* (*get_window_group) (GalaWindowManager* self);
	void (*set_window_group) (GalaWindowManager* self, ClutterActor* value);
	ClutterActor* (*get_top_window_group) (GalaWindowManager* self);
	void (*set_top_window_group) (GalaWindowManager* self, ClutterActor* value);
	MetaBackgroundGroup* (*get_background_group) (GalaWindowManager* self);
	void (*set_background_group) (GalaWindowManager* self, MetaBackgroundGroup* value);
};


static gpointer gala_modal_proxy_parent_class = NULL;

GType gala_action_type_get_type (void) G_GNUC_CONST;
GType gala_modal_proxy_get_type (void) G_GNUC_CONST;
#define GALA_MODAL_PROXY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_MODAL_PROXY, GalaModalProxyPrivate))
static gboolean _gala_modal_proxy__keybinding_filter_lambda4_ (void);
static gboolean __gala_modal_proxy__keybinding_filter_lambda4__gala_keybinding_filter (MetaKeyBinding* binding, gpointer self);
GalaModalProxy* gala_modal_proxy_new (void);
GalaModalProxy* gala_modal_proxy_construct (GType object_type);
void gala_modal_proxy_allow_all_keybindings (GalaModalProxy* self);
void gala_modal_proxy_set_keybinding_filter (GalaModalProxy* self, GalaKeybindingFilter value, gpointer value_target, GDestroyNotify value_target_destroy_notify);
GalaKeybindingFilter gala_modal_proxy_get_keybinding_filter (GalaModalProxy* self, gpointer* result_target);
static void gala_modal_proxy_finalize (GObject * obj);
static void _vala_gala_modal_proxy_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_modal_proxy_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType gala_window_manager_get_type (void) G_GNUC_CONST;
GalaModalProxy* gala_window_manager_push_modal (GalaWindowManager* self);
void gala_window_manager_pop_modal (GalaWindowManager* self, GalaModalProxy* proxy);
gboolean gala_window_manager_is_modal (GalaWindowManager* self);
gboolean gala_window_manager_modal_proxy_valid (GalaWindowManager* self, GalaModalProxy* proxy);
void gala_window_manager_perform_action (GalaWindowManager* self, GalaActionType type);
void gala_window_manager_move_window (GalaWindowManager* self, MetaWindow* window, MetaMotionDirection direction);
void gala_window_manager_switch_to_next_workspace (GalaWindowManager* self, MetaMotionDirection direction);
ClutterActor* gala_window_manager_get_ui_group (GalaWindowManager* self);
void gala_window_manager_set_ui_group (GalaWindowManager* self, ClutterActor* value);
ClutterStage* gala_window_manager_get_stage (GalaWindowManager* self);
void gala_window_manager_set_stage (GalaWindowManager* self, ClutterStage* value);
ClutterActor* gala_window_manager_get_window_group (GalaWindowManager* self);
void gala_window_manager_set_window_group (GalaWindowManager* self, ClutterActor* value);
ClutterActor* gala_window_manager_get_top_window_group (GalaWindowManager* self);
void gala_window_manager_set_top_window_group (GalaWindowManager* self, ClutterActor* value);
MetaBackgroundGroup* gala_window_manager_get_background_group (GalaWindowManager* self);
void gala_window_manager_set_background_group (GalaWindowManager* self, MetaBackgroundGroup* value);


GType gala_action_type_get_type (void) {
	static volatile gsize gala_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GALA_ACTION_TYPE_NONE, "GALA_ACTION_TYPE_NONE", "none"}, {GALA_ACTION_TYPE_SHOW_WORKSPACE_VIEW, "GALA_ACTION_TYPE_SHOW_WORKSPACE_VIEW", "show-workspace-view"}, {GALA_ACTION_TYPE_MAXIMIZE_CURRENT, "GALA_ACTION_TYPE_MAXIMIZE_CURRENT", "maximize-current"}, {GALA_ACTION_TYPE_MINIMIZE_CURRENT, "GALA_ACTION_TYPE_MINIMIZE_CURRENT", "minimize-current"}, {GALA_ACTION_TYPE_OPEN_LAUNCHER, "GALA_ACTION_TYPE_OPEN_LAUNCHER", "open-launcher"}, {GALA_ACTION_TYPE_CUSTOM_COMMAND, "GALA_ACTION_TYPE_CUSTOM_COMMAND", "custom-command"}, {GALA_ACTION_TYPE_WINDOW_OVERVIEW, "GALA_ACTION_TYPE_WINDOW_OVERVIEW", "window-overview"}, {GALA_ACTION_TYPE_WINDOW_OVERVIEW_ALL, "GALA_ACTION_TYPE_WINDOW_OVERVIEW_ALL", "window-overview-all"}, {0, NULL, NULL}};
		GType gala_action_type_type_id;
		gala_action_type_type_id = g_enum_register_static ("GalaActionType", values);
		g_once_init_leave (&gala_action_type_type_id__volatile, gala_action_type_type_id);
	}
	return gala_action_type_type_id__volatile;
}


static gboolean _gala_modal_proxy__keybinding_filter_lambda4_ (void) {
	gboolean result = FALSE;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	result = TRUE;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return result;
#line 160 "WindowManager.c"
}


static gboolean __gala_modal_proxy__keybinding_filter_lambda4__gala_keybinding_filter (MetaKeyBinding* binding, gpointer self) {
	gboolean result;
	result = _gala_modal_proxy__keybinding_filter_lambda4_ ();
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return result;
#line 169 "WindowManager.c"
}


GalaModalProxy* gala_modal_proxy_construct (GType object_type) {
	GalaModalProxy * self = NULL;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self = (GalaModalProxy*) g_object_new (object_type, NULL);
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return self;
#line 179 "WindowManager.c"
}


GalaModalProxy* gala_modal_proxy_new (void) {
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return gala_modal_proxy_construct (GALA_TYPE_MODAL_PROXY);
#line 186 "WindowManager.c"
}


/**
 * Small utility to allow all keybindings
 */
void gala_modal_proxy_allow_all_keybindings (GalaModalProxy* self) {
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 60 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	gala_modal_proxy_set_keybinding_filter (self, NULL, NULL, NULL);
#line 198 "WindowManager.c"
}


GalaKeybindingFilter gala_modal_proxy_get_keybinding_filter (GalaModalProxy* self, gpointer* result_target) {
	GalaKeybindingFilter result;
	GalaKeybindingFilter _tmp0_;
	void* _tmp0__target;
	GalaKeybindingFilter _tmp1_;
	void* _tmp1__target;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	_tmp0_ = self->priv->_keybinding_filter;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	_tmp0__target = self->priv->_keybinding_filter_target;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	_tmp1__target = _tmp0__target;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	*result_target = _tmp1__target;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	result = _tmp1_;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return result;
#line 224 "WindowManager.c"
}


void gala_modal_proxy_set_keybinding_filter (GalaModalProxy* self, GalaKeybindingFilter value, gpointer value_target, GDestroyNotify value_target_destroy_notify) {
	GalaKeybindingFilter _tmp0_;
	void* _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	_tmp0_ = value;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	_tmp0__target = value_target;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	_tmp0__target_destroy_notify = value_target_destroy_notify;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	value = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	value_target = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	value_target_destroy_notify = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	(self->priv->_keybinding_filter_target_destroy_notify == NULL) ? NULL : (self->priv->_keybinding_filter_target_destroy_notify (self->priv->_keybinding_filter_target), NULL);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter_target = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter_target_destroy_notify = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter = _tmp0_;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter_target = _tmp0__target;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter_target_destroy_notify = _tmp0__target_destroy_notify;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	value = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	value_target = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	value_target_destroy_notify = NULL;
#line 268 "WindowManager.c"
}


static void gala_modal_proxy_class_init (GalaModalProxyClass * klass) {
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	gala_modal_proxy_parent_class = g_type_class_peek_parent (klass);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_type_class_add_private (klass, sizeof (GalaModalProxyPrivate));
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_modal_proxy_get_property;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_modal_proxy_set_property;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_modal_proxy_finalize;
#line 283 "WindowManager.c"
}


static void gala_modal_proxy_instance_init (GalaModalProxy * self) {
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv = GALA_MODAL_PROXY_GET_PRIVATE (self);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter = __gala_modal_proxy__keybinding_filter_lambda4__gala_keybinding_filter;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter_target = self;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter_target_destroy_notify = NULL;
#line 296 "WindowManager.c"
}


static void gala_modal_proxy_finalize (GObject * obj) {
	GalaModalProxy * self;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_MODAL_PROXY, GalaModalProxy);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	(self->priv->_keybinding_filter_target_destroy_notify == NULL) ? NULL : (self->priv->_keybinding_filter_target_destroy_notify (self->priv->_keybinding_filter_target), NULL);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter_target = NULL;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	self->priv->_keybinding_filter_target_destroy_notify = NULL;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	G_OBJECT_CLASS (gala_modal_proxy_parent_class)->finalize (obj);
#line 314 "WindowManager.c"
}


/**
 * A minimal class mostly used to identify your call to {@link WindowManager.push_modal} and used
 * to end your modal mode again with {@link WindowManager.pop_modal}
 */
GType gala_modal_proxy_get_type (void) {
	static volatile gsize gala_modal_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&gala_modal_proxy_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaModalProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_modal_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaModalProxy), 0, (GInstanceInitFunc) gala_modal_proxy_instance_init, NULL };
		GType gala_modal_proxy_type_id;
		gala_modal_proxy_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaModalProxy", &g_define_type_info, 0);
		g_once_init_leave (&gala_modal_proxy_type_id__volatile, gala_modal_proxy_type_id);
	}
	return gala_modal_proxy_type_id__volatile;
}


static void _vala_gala_modal_proxy_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaModalProxy * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_MODAL_PROXY, GalaModalProxy);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	switch (property_id) {
#line 339 "WindowManager.c"
		default:
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		break;
#line 345 "WindowManager.c"
	}
}


static void _vala_gala_modal_proxy_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaModalProxy * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_MODAL_PROXY, GalaModalProxy);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	switch (property_id) {
#line 355 "WindowManager.c"
		default:
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		break;
#line 361 "WindowManager.c"
	}
}


/**
 * Enters the modal mode, which means that all events are directed to the stage instead
 * of the windows. This is the only way to receive keyboard events besides shortcut listeners.
 *
 * @return a {@link ModalProxy} which is needed to end the modal mode again and provides some
 *         some basic control on the behavior of the window manager while it is in modal mode.
 */
GalaModalProxy* gala_window_manager_push_modal (GalaWindowManager* self) {
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->push_modal (self);
#line 378 "WindowManager.c"
}


/**
 * May exit the modal mode again, unless another component has called {@link push_modal}
 *
 * @param proxy The {@link ModalProxy} received from {@link push_modal}
 */
void gala_window_manager_pop_modal (GalaWindowManager* self, GalaModalProxy* proxy) {
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->pop_modal (self, proxy);
#line 392 "WindowManager.c"
}


/**
 * Returns whether the window manager is currently in modal mode.
 * @see push_modal
 */
gboolean gala_window_manager_is_modal (GalaWindowManager* self) {
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->is_modal (self);
#line 405 "WindowManager.c"
}


/**
 * Tests if a given {@link ModalProxy} is valid and may be popped. Should not be necessary
 * to use this function in most cases, but it may be helpful for debugging. Gala catches
 * invalid proxies as well and emits a warning in that case.
 *
 * @param proxy The {@link ModalProxy} to check
 * @return      Returns true if the prox is valid
 */
gboolean gala_window_manager_modal_proxy_valid (GalaWindowManager* self, GalaModalProxy* proxy) {
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->modal_proxy_valid (self, proxy);
#line 422 "WindowManager.c"
}


/**
 * Tells the window manager to perform the given action.
 *
 * @param type The type of action to perform
 */
void gala_window_manager_perform_action (GalaWindowManager* self, GalaActionType type) {
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->perform_action (self, type);
#line 436 "WindowManager.c"
}


/**
 * Moves the window to the workspace next to its current workspace in the given direction.
 * Gala currently only supports LEFT and RIGHT.
 *
 * @param window    The window to be moved
 * @param direction The direction in which to move the window
 */
void gala_window_manager_move_window (GalaWindowManager* self, MetaWindow* window, MetaMotionDirection direction) {
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->move_window (self, window, direction);
#line 452 "WindowManager.c"
}


/**
 * Switches to the next workspace in the given direction.
 *
 * @param direction The direction in which to switch
 */
void gala_window_manager_switch_to_next_workspace (GalaWindowManager* self, MetaMotionDirection direction) {
#line 147 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 147 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->switch_to_next_workspace (self, direction);
#line 466 "WindowManager.c"
}


ClutterActor* gala_window_manager_get_ui_group (GalaWindowManager* self) {
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_ui_group (self);
#line 475 "WindowManager.c"
}


void gala_window_manager_set_ui_group (GalaWindowManager* self, ClutterActor* value) {
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_ui_group (self, value);
#line 484 "WindowManager.c"
}


ClutterStage* gala_window_manager_get_stage (GalaWindowManager* self) {
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_stage (self);
#line 493 "WindowManager.c"
}


void gala_window_manager_set_stage (GalaWindowManager* self, ClutterStage* value) {
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 75 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_stage (self, value);
#line 502 "WindowManager.c"
}


ClutterActor* gala_window_manager_get_window_group (GalaWindowManager* self) {
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_window_group (self);
#line 511 "WindowManager.c"
}


void gala_window_manager_set_window_group (GalaWindowManager* self, ClutterActor* value) {
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_window_group (self, value);
#line 520 "WindowManager.c"
}


ClutterActor* gala_window_manager_get_top_window_group (GalaWindowManager* self) {
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_top_window_group (self);
#line 529 "WindowManager.c"
}


void gala_window_manager_set_top_window_group (GalaWindowManager* self, ClutterActor* value) {
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_top_window_group (self, value);
#line 538 "WindowManager.c"
}


MetaBackgroundGroup* gala_window_manager_get_background_group (GalaWindowManager* self) {
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	return GALA_WINDOW_MANAGER_GET_INTERFACE (self)->get_background_group (self);
#line 547 "WindowManager.c"
}


void gala_window_manager_set_background_group (GalaWindowManager* self, MetaBackgroundGroup* value) {
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	GALA_WINDOW_MANAGER_GET_INTERFACE (self)->set_background_group (self, value);
#line 556 "WindowManager.c"
}


static void gala_window_manager_base_init (GalaWindowManagerIface * iface) {
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	static gboolean initialized = FALSE;
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
	if (!initialized) {
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		initialized = TRUE;
#line 567 "WindowManager.c"
		/**
		 * This is the container you'll most likely want to add your component to. It wraps
		 * every other container listed in this interface and is a direct child of the stage.
		 */
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		g_object_interface_install_property (iface, g_param_spec_object ("ui-group", "ui-group", "ui-group", clutter_actor_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 574 "WindowManager.c"
		/**
		 * The stage of the window manager
		 */
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		g_object_interface_install_property (iface, g_param_spec_object ("stage", "stage", "stage", clutter_stage_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 580 "WindowManager.c"
		/**
		 * A group containting all 'usual' windows
		 * @see top_window_group
		 */
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		g_object_interface_install_property (iface, g_param_spec_object ("window-group", "window-group", "window-group", clutter_actor_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 587 "WindowManager.c"
		/**
		 * The top window group contains special windows that are always placed on top
		 * like fullscreen windows.
		 */
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		g_object_interface_install_property (iface, g_param_spec_object ("top-window-group", "top-window-group", "top-window-group", clutter_actor_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 594 "WindowManager.c"
		/**
		 * The background group is a container for the background actors forming the wallpaper
		 */
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/lib/WindowManager.vala"
		g_object_interface_install_property (iface, g_param_spec_object ("background-group", "background-group", "background-group", meta_background_group_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 600 "WindowManager.c"
	}
}


GType gala_window_manager_get_type (void) {
	static volatile gsize gala_window_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWindowManagerIface), (GBaseInitFunc) gala_window_manager_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gala_window_manager_type_id;
		gala_window_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "GalaWindowManager", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gala_window_manager_type_id, meta_plugin_get_type ());
		g_once_init_leave (&gala_window_manager_type_id__volatile, gala_window_manager_type_id);
	}
	return gala_window_manager_type_id__volatile;
}



