/* BackgroundSource.c generated by valac 0.37.91, the Vala compiler
 * generated from BackgroundSource.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <meta/screen.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gsettings-desktop-schemas/gdesktop-enums.h>


#define GALA_TYPE_BACKGROUND_SOURCE (gala_background_source_get_type ())
#define GALA_BACKGROUND_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource))
#define GALA_BACKGROUND_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSourceClass))
#define GALA_IS_BACKGROUND_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BACKGROUND_SOURCE))
#define GALA_IS_BACKGROUND_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BACKGROUND_SOURCE))
#define GALA_BACKGROUND_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSourceClass))

typedef struct _GalaBackgroundSource GalaBackgroundSource;
typedef struct _GalaBackgroundSourceClass GalaBackgroundSourceClass;
typedef struct _GalaBackgroundSourcePrivate GalaBackgroundSourcePrivate;

#define GALA_TYPE_BACKGROUND (gala_background_get_type ())
#define GALA_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BACKGROUND, GalaBackground))
#define GALA_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BACKGROUND, GalaBackgroundClass))
#define GALA_IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BACKGROUND))
#define GALA_IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BACKGROUND))
#define GALA_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BACKGROUND, GalaBackgroundClass))

typedef struct _GalaBackground GalaBackground;
typedef struct _GalaBackgroundClass GalaBackgroundClass;

#define GALA_BACKGROUND_SOURCE_TYPE_SETTINGS_HASH_CACHE (gala_background_source_settings_hash_cache_get_type ())
typedef struct _GalaBackgroundSourceSettingsHashCache GalaBackgroundSourceSettingsHashCache;
enum  {
	GALA_BACKGROUND_SOURCE_DUMMY_PROPERTY,
	GALA_BACKGROUND_SOURCE_SCREEN,
	GALA_BACKGROUND_SOURCE_SETTINGS,
	GALA_BACKGROUND_SOURCE_USE_COUNT,
	GALA_BACKGROUND_SOURCE_LAST_PROPERTY
};
static GParamSpec* gala_background_source_properties[GALA_BACKGROUND_SOURCE_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	GALA_BACKGROUND_SOURCE_CHANGED_SIGNAL,
	GALA_BACKGROUND_SOURCE_LAST_SIGNAL
};
static guint gala_background_source_signals[GALA_BACKGROUND_SOURCE_LAST_SIGNAL] = {0};

struct _GalaBackgroundSource {
	GObject parent_instance;
	GalaBackgroundSourcePrivate * priv;
};

struct _GalaBackgroundSourceClass {
	GObjectClass parent_class;
};

struct _GalaBackgroundSourceSettingsHashCache {
	guint color_shading_type;
	guint picture_opacity;
	guint picture_options;
	guint picture_uri;
	guint primar_color;
	guint secondary_color;
};

struct _GalaBackgroundSourcePrivate {
	MetaScreen* _screen;
	GSettings* _settings;
	gint _use_count;
	GeeHashMap* backgrounds;
	GalaBackgroundSourceSettingsHashCache settings_hash_cache;
};


static gpointer gala_background_source_parent_class = NULL;

GType gala_background_source_get_type (void) G_GNUC_CONST;
GType gala_background_get_type (void) G_GNUC_CONST;
static GType gala_background_source_settings_hash_cache_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GalaBackgroundSourceSettingsHashCache* gala_background_source_settings_hash_cache_dup (const GalaBackgroundSourceSettingsHashCache* self);
static void gala_background_source_settings_hash_cache_free (GalaBackgroundSourceSettingsHashCache* self);
#define GALA_BACKGROUND_SOURCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSourcePrivate))
GalaBackgroundSource* gala_background_source_new (MetaScreen* screen, const gchar* settings_schema);
GalaBackgroundSource* gala_background_source_construct (GType object_type, MetaScreen* screen, const gchar* settings_schema);
static void gala_background_source_monitors_changed (GalaBackgroundSource* self);
MetaScreen* gala_background_source_get_screen (GalaBackgroundSource* self);
void gala_background_update_resolution (GalaBackground* self);
static void gala_background_source_background_changed (GalaBackgroundSource* self, GalaBackground* background);
static void _gala_background_source_background_changed_gala_background_changed (GalaBackground* _sender, gpointer self);
void gala_background_destroy (GalaBackground* self);
GalaBackground* gala_background_source_get_background (GalaBackgroundSource* self, gint monitor_index);
GSettings* gala_background_source_get_settings (GalaBackgroundSource* self);
GalaBackground* gala_background_new (MetaScreen* screen, gint monitor_index, const gchar* filename, GalaBackgroundSource* background_source, GDesktopBackgroundStyle style);
GalaBackground* gala_background_construct (GType object_type, MetaScreen* screen, gint monitor_index, const gchar* filename, GalaBackgroundSource* background_source, GDesktopBackgroundStyle style);
gint gala_background_get_monitor_index (GalaBackground* self);
void gala_background_source_destroy (GalaBackgroundSource* self);
static void _gala_background_source_monitors_changed_meta_screen_monitors_changed (MetaScreen* _sender, gpointer self);
static void gala_background_source_settings_changed (GalaBackgroundSource* self, const gchar* key);
static gboolean _vala_string_array_contains (const gchar* * stack, int stack_length, const gchar* needle);
static void gala_background_source_get_current_settings_hash_cache (GalaBackgroundSource* self, GalaBackgroundSourceSettingsHashCache* result);
static void gala_background_source_set_screen (GalaBackgroundSource* self, MetaScreen* value);
static void gala_background_source_set_settings (GalaBackgroundSource* self, GSettings* value);
gint gala_background_source_get_use_count (GalaBackgroundSource* self);
void gala_background_source_set_use_count (GalaBackgroundSource* self, gint value);
static GObject * gala_background_source_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _gala_background_source_settings_changed_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
static void gala_background_source_finalize (GObject * obj);
static void _vala_gala_background_source_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_background_source_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);

static const gchar* GALA_BACKGROUND_SOURCE_options[6] = {"color-shading-type", "picture-opacity", "picture-options", "picture-uri", "primary-color", "secondary-color"};

GalaBackgroundSource* gala_background_source_construct (GType object_type, MetaScreen* screen, const gchar* settings_schema) {
	GalaBackgroundSource * self = NULL;
	MetaScreen* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_val_if_fail (screen != NULL, NULL);
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_val_if_fail (settings_schema != NULL, NULL);
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = screen;
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp1_ = settings_schema;
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp2_ = g_settings_new (_tmp1_);
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp3_ = _tmp2_;
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	self = (GalaBackgroundSource*) g_object_new (object_type, "screen", _tmp0_, "settings", _tmp3_, NULL);
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_object_unref0 (_tmp3_);
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return self;
#line 161 "BackgroundSource.c"
}


GalaBackgroundSource* gala_background_source_new (MetaScreen* screen, const gchar* settings_schema) {
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return gala_background_source_construct (GALA_TYPE_BACKGROUND_SOURCE, screen, settings_schema);
#line 168 "BackgroundSource.c"
}


static void _gala_background_source_background_changed_gala_background_changed (GalaBackground* _sender, gpointer self) {
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gala_background_source_background_changed ((GalaBackgroundSource*) self, _sender);
#line 175 "BackgroundSource.c"
}


static void gala_background_source_monitors_changed (GalaBackgroundSource* self) {
	gint n = 0;
	MetaScreen* _tmp0_;
	gint _tmp1_;
	gint i = 0;
#line 46 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (self != NULL);
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = self->priv->_screen;
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp1_ = meta_screen_get_n_monitors (_tmp0_);
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	n = _tmp1_;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	i = 0;
#line 194 "BackgroundSource.c"
	{
		GeeIterator* _background_it = NULL;
		GeeHashMap* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp2_ = self->priv->backgrounds;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp4_ = _tmp3_;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp5_ = _tmp4_;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp7_ = _tmp6_;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_g_object_unref0 (_tmp5_);
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_background_it = _tmp7_;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		while (TRUE) {
#line 221 "BackgroundSource.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_;
			GalaBackground* background = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			GalaBackground* _tmp15_;
			guint _tmp16_;
			GalaBackground* _tmp17_;
			GeeHashMap* _tmp18_;
			gint _tmp19_;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp8_ = _background_it;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			if (!_tmp9_) {
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
				break;
#line 242 "BackgroundSource.c"
			}
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp10_ = _background_it;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			background = (GalaBackground*) _tmp11_;
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp12_ = i;
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			i = _tmp12_ + 1;
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp13_ = n;
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			if (_tmp12_ < _tmp13_) {
#line 258 "BackgroundSource.c"
				GalaBackground* _tmp14_;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
				_tmp14_ = background;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
				gala_background_update_resolution (_tmp14_);
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
				_g_object_unref0 (background);
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
				continue;
#line 268 "BackgroundSource.c"
			}
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp15_ = background;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			g_signal_parse_name ("changed", GALA_TYPE_BACKGROUND, &_tmp16_, NULL, FALSE);
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			g_signal_handlers_disconnect_matched (_tmp15_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _gala_background_source_background_changed_gala_background_changed, self);
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp17_ = background;
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			gala_background_destroy (_tmp17_);
#line 60 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp18_ = self->priv->backgrounds;
#line 60 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp19_ = i;
#line 60 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) _tmp19_), NULL);
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_g_object_unref0 (background);
#line 288 "BackgroundSource.c"
		}
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_g_object_unref0 (_background_it);
#line 292 "BackgroundSource.c"
	}
}


GalaBackground* gala_background_source_get_background (GalaBackgroundSource* self, gint monitor_index) {
	GalaBackground* result = NULL;
	gchar* filename = NULL;
	gint style = 0;
	GSettings* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	GeeHashMap* _tmp19_;
	gint _tmp20_;
	gboolean _tmp21_;
	GeeHashMap* _tmp31_;
	gint _tmp32_;
	gpointer _tmp33_;
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	filename = NULL;
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = self->priv->_settings;
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp1_ = g_settings_get_enum (_tmp0_, "picture-options");
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	style = _tmp1_;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp2_ = style;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (_tmp2_ != ((gint) G_DESKTOP_BACKGROUND_STYLE_NONE)) {
#line 326 "BackgroundSource.c"
		gchar* uri = NULL;
		GSettings* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp3_ = self->priv->_settings;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp4_ = g_settings_get_string (_tmp3_, "picture-uri");
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		uri = _tmp4_;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp5_ = uri;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp6_ = g_uri_parse_scheme (_tmp5_);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp7_ = _tmp6_;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp8_ = _tmp7_ != NULL;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_g_free0 (_tmp7_);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		if (_tmp8_) {
#line 352 "BackgroundSource.c"
			const gchar* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			gchar* _tmp12_;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp9_ = uri;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp11_ = _tmp10_;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp12_ = g_file_get_path (_tmp11_);
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_g_free0 (filename);
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			filename = _tmp12_;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_g_object_unref0 (_tmp11_);
#line 371 "BackgroundSource.c"
		} else {
			const gchar* _tmp13_;
			gchar* _tmp14_;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp13_ = uri;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_g_free0 (filename);
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			filename = _tmp14_;
#line 383 "BackgroundSource.c"
		}
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_g_free0 (uri);
#line 387 "BackgroundSource.c"
	}
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp16_ = filename;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (_tmp16_ == NULL) {
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp15_ = TRUE;
#line 395 "BackgroundSource.c"
	} else {
		const gchar* _tmp17_;
		gboolean _tmp18_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp17_ = filename;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp18_ = g_str_has_suffix (_tmp17_, ".xml");
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp15_ = !_tmp18_;
#line 405 "BackgroundSource.c"
	}
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (_tmp15_) {
#line 82 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		monitor_index = 0;
#line 411 "BackgroundSource.c"
	}
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp19_ = self->priv->backgrounds;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp20_ = monitor_index;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp21_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp20_));
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (!_tmp21_) {
#line 421 "BackgroundSource.c"
		GalaBackground* background = NULL;
		MetaScreen* _tmp22_;
		gint _tmp23_;
		const gchar* _tmp24_;
		gint _tmp25_;
		GalaBackground* _tmp26_;
		GalaBackground* _tmp27_;
		GeeHashMap* _tmp28_;
		gint _tmp29_;
		GalaBackground* _tmp30_;
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp22_ = self->priv->_screen;
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp23_ = monitor_index;
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp24_ = filename;
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp25_ = style;
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp26_ = gala_background_new (_tmp22_, _tmp23_, _tmp24_, self, (GDesktopBackgroundStyle) _tmp25_);
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		background = _tmp26_;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp27_ = background;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		g_signal_connect_object (_tmp27_, "changed", (GCallback) _gala_background_source_background_changed_gala_background_changed, self, 0);
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp28_ = self->priv->backgrounds;
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp29_ = monitor_index;
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp30_ = background;
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, (gpointer) ((gintptr) _tmp29_), _tmp30_);
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_g_object_unref0 (background);
#line 458 "BackgroundSource.c"
	}
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp31_ = self->priv->backgrounds;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp32_ = monitor_index;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp33_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) _tmp32_));
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	result = (GalaBackground*) _tmp33_;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_free0 (filename);
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return result;
#line 472 "BackgroundSource.c"
}


static void gala_background_source_background_changed (GalaBackgroundSource* self, GalaBackground* background) {
	GalaBackground* _tmp0_;
	guint _tmp1_;
	GalaBackground* _tmp2_;
	GeeHashMap* _tmp3_;
	GalaBackground* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (self != NULL);
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (background != NULL);
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = background;
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_signal_parse_name ("changed", GALA_TYPE_BACKGROUND, &_tmp1_, NULL, FALSE);
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_background_source_background_changed_gala_background_changed, self);
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp2_ = background;
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gala_background_destroy (_tmp2_);
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp3_ = self->priv->backgrounds;
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp4_ = background;
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp5_ = gala_background_get_monitor_index (_tmp4_);
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp6_ = _tmp5_;
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) _tmp6_), NULL);
#line 508 "BackgroundSource.c"
}


static void _gala_background_source_monitors_changed_meta_screen_monitors_changed (MetaScreen* _sender, gpointer self) {
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gala_background_source_monitors_changed ((GalaBackgroundSource*) self);
#line 515 "BackgroundSource.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return self ? g_object_ref (self) : NULL;
#line 522 "BackgroundSource.c"
}


void gala_background_source_destroy (GalaBackgroundSource* self) {
	MetaScreen* _tmp0_;
	guint _tmp1_;
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (self != NULL);
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = self->priv->_screen;
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_signal_parse_name ("monitors-changed", meta_screen_get_type (), &_tmp1_, NULL, FALSE);
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_background_source_monitors_changed_meta_screen_monitors_changed, self);
#line 537 "BackgroundSource.c"
	{
		GeeHashMap* _background_list = NULL;
		GeeHashMap* _tmp2_;
		GeeHashMap* _tmp3_;
		gint _background_size = 0;
		GeeHashMap* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _background_index = 0;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp2_ = self->priv->backgrounds;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_background_list = _tmp3_;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp4_ = _background_list;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp6_ = _tmp5_;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_background_size = _tmp6_;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_background_index = -1;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		while (TRUE) {
#line 565 "BackgroundSource.c"
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			GalaBackground* background = NULL;
			GeeHashMap* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			GalaBackground* _tmp13_;
			guint _tmp14_;
			GalaBackground* _tmp15_;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp7_ = _background_index;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_background_index = _tmp7_ + 1;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp8_ = _background_index;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp9_ = _background_size;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
				break;
#line 588 "BackgroundSource.c"
			}
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp10_ = _background_list;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp11_ = _background_index;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) _tmp11_));
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			background = (GalaBackground*) _tmp12_;
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp13_ = background;
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			g_signal_parse_name ("changed", GALA_TYPE_BACKGROUND, &_tmp14_, NULL, FALSE);
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			g_signal_handlers_disconnect_matched (_tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _gala_background_source_background_changed_gala_background_changed, self);
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_tmp15_ = background;
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			gala_background_destroy (_tmp15_);
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			_g_object_unref0 (background);
#line 610 "BackgroundSource.c"
		}
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_g_object_unref0 (_background_list);
#line 614 "BackgroundSource.c"
	}
}


static gboolean _vala_string_array_contains (const gchar* * stack, int stack_length, const gchar* needle) {
	int i;
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	for (i = 0; i < stack_length; i++) {
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
			return TRUE;
#line 627 "BackgroundSource.c"
		}
	}
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return FALSE;
#line 632 "BackgroundSource.c"
}


static void gala_background_source_settings_changed (GalaBackgroundSource* self, const gchar* key) {
	const gchar* _tmp0_;
	GalaBackgroundSourceSettingsHashCache current = {0};
	GalaBackgroundSourceSettingsHashCache _tmp1_ = {0};
	gint _tmp2_;
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (self != NULL);
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (key != NULL);
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = key;
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (!_vala_string_array_contains (GALA_BACKGROUND_SOURCE_options, G_N_ELEMENTS (GALA_BACKGROUND_SOURCE_options), _tmp0_)) {
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		return;
#line 651 "BackgroundSource.c"
	}
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gala_background_source_get_current_settings_hash_cache (self, &_tmp1_);
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	current = _tmp1_;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp2_ = memcmp (&self->priv->settings_hash_cache, &current, (gsize) sizeof (GalaBackgroundSourceSettingsHashCache));
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (_tmp2_ == 0) {
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		return;
#line 663 "BackgroundSource.c"
	}
#line 142 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	memcpy (&self->priv->settings_hash_cache, &current, (gsize) sizeof (GalaBackgroundSourceSettingsHashCache));
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_signal_emit (self, gala_background_source_signals[GALA_BACKGROUND_SOURCE_CHANGED_SIGNAL], 0);
#line 669 "BackgroundSource.c"
}


static void gala_background_source_get_current_settings_hash_cache (GalaBackgroundSource* self, GalaBackgroundSourceSettingsHashCache* result) {
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	guint _tmp3_;
	GSettings* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	guint _tmp7_;
	GSettings* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	guint _tmp11_;
	GSettings* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	guint _tmp15_;
	GSettings* _tmp16_;
	GVariant* _tmp17_;
	GVariant* _tmp18_;
	guint _tmp19_;
	GSettings* _tmp20_;
	GVariant* _tmp21_;
	GVariant* _tmp22_;
	guint _tmp23_;
	GalaBackgroundSourceSettingsHashCache _tmp24_ = {0};
	GalaBackgroundSourceSettingsHashCache _tmp25_;
#line 147 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (self != NULL);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = self->priv->_settings;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "color-shading-type");
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp2_ = _tmp1_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp3_ = g_variant_hash (_tmp2_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp4_ = self->priv->_settings;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp5_ = g_settings_get_value (_tmp4_, "picture-opacity");
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp6_ = _tmp5_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp7_ = g_variant_hash (_tmp6_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp8_ = self->priv->_settings;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp9_ = g_settings_get_value (_tmp8_, "picture-options");
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp10_ = _tmp9_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp11_ = g_variant_hash (_tmp10_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp12_ = self->priv->_settings;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp13_ = g_settings_get_value (_tmp12_, "picture-uri");
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp14_ = _tmp13_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp15_ = g_variant_hash (_tmp14_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp16_ = self->priv->_settings;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp17_ = g_settings_get_value (_tmp16_, "primary-color");
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp18_ = _tmp17_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp19_ = g_variant_hash (_tmp18_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp20_ = self->priv->_settings;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp21_ = g_settings_get_value (_tmp20_, "secondary-color");
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp22_ = _tmp21_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp23_ = g_variant_hash (_tmp22_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp24_.color_shading_type = _tmp3_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp24_.picture_opacity = _tmp7_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp24_.picture_options = _tmp11_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp24_.picture_uri = _tmp15_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp24_.primar_color = _tmp19_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp24_.secondary_color = _tmp23_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp25_ = _tmp24_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_variant_unref0 (_tmp22_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_variant_unref0 (_tmp18_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_variant_unref0 (_tmp14_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_variant_unref0 (_tmp10_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_variant_unref0 (_tmp6_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_variant_unref0 (_tmp2_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	*result = _tmp25_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return;
#line 780 "BackgroundSource.c"
}


MetaScreen* gala_background_source_get_screen (GalaBackgroundSource* self) {
	MetaScreen* result;
	MetaScreen* _tmp0_;
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = self->priv->_screen;
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	result = _tmp0_;
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return result;
#line 795 "BackgroundSource.c"
}


static void gala_background_source_set_screen (GalaBackgroundSource* self, MetaScreen* value) {
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (self != NULL);
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (gala_background_source_get_screen (self) != value) {
#line 804 "BackgroundSource.c"
		MetaScreen* _tmp0_;
		MetaScreen* _tmp1_;
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp0_ = value;
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_g_object_unref0 (self->priv->_screen);
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		self->priv->_screen = _tmp1_;
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_background_source_properties[GALA_BACKGROUND_SOURCE_SCREEN]);
#line 817 "BackgroundSource.c"
	}
}


GSettings* gala_background_source_get_settings (GalaBackgroundSource* self) {
	GSettings* result;
	GSettings* _tmp0_;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = self->priv->_settings;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return result;
#line 833 "BackgroundSource.c"
}


static void gala_background_source_set_settings (GalaBackgroundSource* self, GSettings* value) {
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (self != NULL);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (gala_background_source_get_settings (self) != value) {
#line 842 "BackgroundSource.c"
		GSettings* _tmp0_;
		GSettings* _tmp1_;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp0_ = value;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_g_object_unref0 (self->priv->_settings);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		self->priv->_settings = _tmp1_;
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_background_source_properties[GALA_BACKGROUND_SOURCE_SETTINGS]);
#line 855 "BackgroundSource.c"
	}
}


gint gala_background_source_get_use_count (GalaBackgroundSource* self) {
	gint result;
	gint _tmp0_;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = self->priv->_use_count;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	result = _tmp0_;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return result;
#line 871 "BackgroundSource.c"
}


void gala_background_source_set_use_count (GalaBackgroundSource* self, gint value) {
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_return_if_fail (self != NULL);
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	if (gala_background_source_get_use_count (self) != value) {
#line 880 "BackgroundSource.c"
		gint _tmp0_;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		_tmp0_ = value;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		self->priv->_use_count = _tmp0_;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_background_source_properties[GALA_BACKGROUND_SOURCE_USE_COUNT]);
#line 888 "BackgroundSource.c"
	}
}


static void _gala_background_source_settings_changed_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gala_background_source_settings_changed ((GalaBackgroundSource*) self, key);
#line 896 "BackgroundSource.c"
}


static GObject * gala_background_source_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GalaBackgroundSource * self;
	GeeHashMap* _tmp0_;
	MetaScreen* _tmp1_;
	GalaBackgroundSourceSettingsHashCache _tmp2_ = {0};
	GSettings* _tmp3_;
#line 36 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	parent_class = G_OBJECT_CLASS (gala_background_source_parent_class);
#line 36 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, GALA_TYPE_BACKGROUND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_object_unref0 (self->priv->backgrounds);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	self->priv->backgrounds = _tmp0_;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp1_ = self->priv->_screen;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_signal_connect_object (_tmp1_, "monitors-changed", (GCallback) _gala_background_source_monitors_changed_meta_screen_monitors_changed, self, 0);
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gala_background_source_get_current_settings_hash_cache (self, &_tmp2_);
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	self->priv->settings_hash_cache = _tmp2_;
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_tmp3_ = self->priv->_settings;
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _gala_background_source_settings_changed_g_settings_changed, self, 0);
#line 36 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return obj;
#line 934 "BackgroundSource.c"
}


static GalaBackgroundSourceSettingsHashCache* gala_background_source_settings_hash_cache_dup (const GalaBackgroundSourceSettingsHashCache* self) {
	GalaBackgroundSourceSettingsHashCache* dup;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	dup = g_new0 (GalaBackgroundSourceSettingsHashCache, 1);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	memcpy (dup, self, sizeof (GalaBackgroundSourceSettingsHashCache));
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	return dup;
#line 946 "BackgroundSource.c"
}


static void gala_background_source_settings_hash_cache_free (GalaBackgroundSourceSettingsHashCache* self) {
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_free (self);
#line 953 "BackgroundSource.c"
}


static GType gala_background_source_settings_hash_cache_get_type (void) {
	static volatile gsize gala_background_source_settings_hash_cache_type_id__volatile = 0;
	if (g_once_init_enter (&gala_background_source_settings_hash_cache_type_id__volatile)) {
		GType gala_background_source_settings_hash_cache_type_id;
		gala_background_source_settings_hash_cache_type_id = g_boxed_type_register_static ("GalaBackgroundSourceSettingsHashCache", (GBoxedCopyFunc) gala_background_source_settings_hash_cache_dup, (GBoxedFreeFunc) gala_background_source_settings_hash_cache_free);
		g_once_init_leave (&gala_background_source_settings_hash_cache_type_id__volatile, gala_background_source_settings_hash_cache_type_id);
	}
	return gala_background_source_settings_hash_cache_type_id__volatile;
}


static void gala_background_source_class_init (GalaBackgroundSourceClass * klass) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gala_background_source_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_type_class_add_private (klass, sizeof (GalaBackgroundSourcePrivate));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_background_source_get_property;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_background_source_set_property;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_background_source_constructor;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_background_source_finalize;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BACKGROUND_SOURCE_SCREEN, gala_background_source_properties[GALA_BACKGROUND_SOURCE_SCREEN] = g_param_spec_object ("screen", "screen", "screen", meta_screen_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BACKGROUND_SOURCE_SETTINGS, gala_background_source_properties[GALA_BACKGROUND_SOURCE_SETTINGS] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BACKGROUND_SOURCE_USE_COUNT, gala_background_source_properties[GALA_BACKGROUND_SOURCE_USE_COUNT] = g_param_spec_int ("use-count", "use-count", "use-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	gala_background_source_signals[GALA_BACKGROUND_SOURCE_CHANGED_SIGNAL] = g_signal_new ("changed", GALA_TYPE_BACKGROUND_SOURCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 989 "BackgroundSource.c"
}


static void gala_background_source_instance_init (GalaBackgroundSource * self) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	self->priv = GALA_BACKGROUND_SOURCE_GET_PRIVATE (self);
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	self->priv->_use_count = 0;
#line 998 "BackgroundSource.c"
}


static void gala_background_source_finalize (GObject * obj) {
	GalaBackgroundSource * self;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource);
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_object_unref0 (self->priv->_screen);
#line 25 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_object_unref0 (self->priv->_settings);
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	_g_object_unref0 (self->priv->backgrounds);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	G_OBJECT_CLASS (gala_background_source_parent_class)->finalize (obj);
#line 1014 "BackgroundSource.c"
}


GType gala_background_source_get_type (void) {
	static volatile gsize gala_background_source_type_id__volatile = 0;
	if (g_once_init_enter (&gala_background_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaBackgroundSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_background_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaBackgroundSource), 0, (GInstanceInitFunc) gala_background_source_instance_init, NULL };
		GType gala_background_source_type_id;
		gala_background_source_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaBackgroundSource", &g_define_type_info, 0);
		g_once_init_leave (&gala_background_source_type_id__volatile, gala_background_source_type_id);
	}
	return gala_background_source_type_id__volatile;
}


static void _vala_gala_background_source_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaBackgroundSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	switch (property_id) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		case GALA_BACKGROUND_SOURCE_SCREEN:
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		g_value_set_object (value, gala_background_source_get_screen (self));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		break;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		case GALA_BACKGROUND_SOURCE_SETTINGS:
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		g_value_set_object (value, gala_background_source_get_settings (self));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		break;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		case GALA_BACKGROUND_SOURCE_USE_COUNT:
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		g_value_set_int (value, gala_background_source_get_use_count (self));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		break;
#line 1053 "BackgroundSource.c"
		default:
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		break;
#line 1059 "BackgroundSource.c"
	}
}


static void _vala_gala_background_source_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaBackgroundSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
	switch (property_id) {
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		case GALA_BACKGROUND_SOURCE_SCREEN:
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		gala_background_source_set_screen (self, g_value_get_object (value));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		break;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		case GALA_BACKGROUND_SOURCE_SETTINGS:
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		gala_background_source_set_settings (self, g_value_get_object (value));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		break;
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		case GALA_BACKGROUND_SOURCE_USE_COUNT:
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		gala_background_source_set_use_count (self, g_value_get_int (value));
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		break;
#line 1087 "BackgroundSource.c"
		default:
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Background/BackgroundSource.vala"
		break;
#line 1093 "BackgroundSource.c"
	}
}



