/* DragDropAction.c generated by valac 0.37.91, the Vala compiler
 * generated from DragDropAction.vala, do not modify */

/**/
/*  Copyright (C) 2013 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gee.h>


#define GALA_TYPE_DRAG_DROP_ACTION_TYPE (gala_drag_drop_action_type_get_type ())

#define GALA_TYPE_DRAG_DROP_ACTION (gala_drag_drop_action_get_type ())
#define GALA_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction))
#define GALA_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))
#define GALA_IS_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_IS_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_DRAG_DROP_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))

typedef struct _GalaDragDropAction GalaDragDropAction;
typedef struct _GalaDragDropActionClass GalaDragDropActionClass;
typedef struct _GalaDragDropActionPrivate GalaDragDropActionPrivate;
enum  {
	GALA_DRAG_DROP_ACTION_DUMMY_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_TYPE,
	GALA_DRAG_DROP_ACTION_DRAG_ID,
	GALA_DRAG_DROP_ACTION_HANDLE,
	GALA_DRAG_DROP_ACTION_DRAGGING,
	GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING,
	GALA_DRAG_DROP_ACTION_LAST_PROPERTY
};
static GParamSpec* gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_LAST_PROPERTY];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
enum  {
	GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL,
	GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL,
	GALA_DRAG_DROP_ACTION_LAST_SIGNAL
};
static guint gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_LAST_SIGNAL] = {0};

typedef enum  {
	GALA_DRAG_DROP_ACTION_TYPE_SOURCE = 0,
	GALA_DRAG_DROP_ACTION_TYPE_DESTINATION
} GalaDragDropActionType;

struct _GalaDragDropAction {
	ClutterAction parent_instance;
	GalaDragDropActionPrivate * priv;
};

struct _GalaDragDropActionClass {
	ClutterActionClass parent_class;
};

struct _GalaDragDropActionPrivate {
	GalaDragDropActionType _drag_type;
	gchar* _drag_id;
	ClutterActor* _handle;
	gboolean _dragging;
	gboolean _allow_bubbling;
	ClutterActor* hovered;
	gboolean clicked;
	gfloat last_x;
	gfloat last_y;
};


static gpointer gala_drag_drop_action_parent_class = NULL;
static GeeHashMap* gala_drag_drop_action_sources;
static GeeHashMap* gala_drag_drop_action_sources = NULL;

GType gala_drag_drop_action_type_get_type (void) G_GNUC_CONST;
GType gala_drag_drop_action_get_type (void) G_GNUC_CONST;
#define GALA_DRAG_DROP_ACTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionPrivate))
static void gala_drag_drop_action_release_actor (GalaDragDropAction* self, ClutterActor* actor);
GalaDragDropAction* gala_drag_drop_action_new (GalaDragDropActionType type, const gchar* id);
GalaDragDropAction* gala_drag_drop_action_construct (GType object_type, GalaDragDropActionType type, const gchar* id);
static void gala_drag_drop_action_real_set_actor (ClutterActorMeta* base, ClutterActor* new_actor);
static void gala_drag_drop_action_connect_actor (GalaDragDropAction* self, ClutterActor* actor);
GalaDragDropActionType gala_drag_drop_action_get_drag_type (GalaDragDropAction* self);
static gboolean gala_drag_drop_action_source_clicked (GalaDragDropAction* self, ClutterButtonEvent* event);
static gboolean _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self);
const gchar* gala_drag_drop_action_get_drag_id (GalaDragDropAction* self);
static void gala_drag_drop_action_emit_crossed (GalaDragDropAction* self, ClutterActor* destination, gboolean hovered);
static GalaDragDropAction* gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self, ClutterActor* actor);
static gboolean gala_drag_drop_action_follow_move (GalaDragDropAction* self, ClutterEvent* event);
static gboolean _gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender, ClutterEvent* event, gpointer self);
gboolean gala_drag_drop_action_get_dragging (GalaDragDropAction* self);
static void gala_drag_drop_action_set_handle (GalaDragDropAction* self, ClutterActor* value);
ClutterActor* gala_drag_drop_action_get_handle (GalaDragDropAction* self);
static void gala_drag_drop_action_set_dragging (GalaDragDropAction* self, gboolean value);
void gala_drag_drop_action_cancel (GalaDragDropAction* self);
gboolean gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self);
static void gala_drag_drop_action_finish (GalaDragDropAction* self);
static void gala_drag_drop_action_cleanup (GalaDragDropAction* self);
void gala_drag_drop_action_cancel_all_by_id (const gchar* id);
static void gala_drag_drop_action_set_drag_type (GalaDragDropAction* self, GalaDragDropActionType value);
static void gala_drag_drop_action_set_drag_id (GalaDragDropAction* self, const gchar* value);
void gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self, gboolean value);
static void g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void gala_drag_drop_action_finalize (GObject * obj);
static void _vala_gala_drag_drop_action_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_drag_drop_action_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType gala_drag_drop_action_type_get_type (void) {
	static volatile gsize gala_drag_drop_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "GALA_DRAG_DROP_ACTION_TYPE_SOURCE", "source"}, {GALA_DRAG_DROP_ACTION_TYPE_DESTINATION, "GALA_DRAG_DROP_ACTION_TYPE_DESTINATION", "destination"}, {0, NULL, NULL}};
		GType gala_drag_drop_action_type_type_id;
		gala_drag_drop_action_type_type_id = g_enum_register_static ("GalaDragDropActionType", values);
		g_once_init_leave (&gala_drag_drop_action_type_type_id__volatile, gala_drag_drop_action_type_type_id);
	}
	return gala_drag_drop_action_type_type_id__volatile;
}


/**
 * Create a new DragDropAction
 *
 * @param type The type of this actor
 * @param id   An ID that marks which sources can be dragged on
 *             which destinations. It has to be the same for all actors that
 *             should be compatible with each other.
 */
GalaDragDropAction* gala_drag_drop_action_construct (GType object_type, GalaDragDropActionType type, const gchar* id) {
	GalaDragDropAction * self = NULL;
	GalaDragDropActionType _tmp0_;
	const gchar* _tmp1_;
	GeeHashMap* _tmp2_;
#line 113 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = type;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = id;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self = (GalaDragDropAction*) g_object_new (object_type, "drag-type", _tmp0_, "drag-id", _tmp1_, NULL);
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp2_ = gala_drag_drop_action_sources;
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp2_ == NULL) {
#line 171 "DragDropAction.c"
		GeeHashMap* _tmp3_;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_g_object_unref0 (gala_drag_drop_action_sources);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_sources = _tmp3_;
#line 179 "DragDropAction.c"
	}
#line 113 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return self;
#line 183 "DragDropAction.c"
}


GalaDragDropAction* gala_drag_drop_action_new (GalaDragDropActionType type, const gchar* id) {
#line 113 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return gala_drag_drop_action_construct (GALA_TYPE_DRAG_DROP_ACTION, type, id);
#line 190 "DragDropAction.c"
}


static void gala_drag_drop_action_real_set_actor (ClutterActorMeta* base, ClutterActor* new_actor) {
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp6_;
#line 127 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self = (GalaDragDropAction*) base;
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp1_ != NULL) {
#line 208 "DragDropAction.c"
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp3_ = _tmp2_;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_release_actor (self, _tmp3_);
#line 217 "DragDropAction.c"
	}
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp4_ = new_actor;
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp4_ != NULL) {
#line 223 "DragDropAction.c"
		ClutterActor* _tmp5_;
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp5_ = new_actor;
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_connect_actor (self, _tmp5_);
#line 229 "DragDropAction.c"
	}
#line 137 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp6_ = new_actor;
#line 137 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	CLUTTER_ACTOR_META_CLASS (gala_drag_drop_action_parent_class)->set_actor ((ClutterActorMeta*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_action_get_type (), ClutterAction), _tmp6_);
#line 235 "DragDropAction.c"
}


static gboolean _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self) {
	gboolean result;
	result = gala_drag_drop_action_source_clicked ((GalaDragDropAction*) self, event);
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 244 "DragDropAction.c"
}


static void gala_drag_drop_action_release_actor (GalaDragDropAction* self, ClutterActor* actor) {
	GalaDragDropActionType _tmp0_;
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 142 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 142 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
#line 258 "DragDropAction.c"
		ClutterActor* _tmp1_;
		guint _tmp2_;
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		gpointer _tmp5_;
		GeeLinkedList* _tmp6_;
		ClutterActor* _tmp7_;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp1_ = actor;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_signal_parse_name ("button-press-event", clutter_actor_get_type (), &_tmp2_, NULL, FALSE);
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self);
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp3_ = gala_drag_drop_action_sources;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp4_ = self->priv->_drag_id;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp4_);
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		source_list = (GeeLinkedList*) _tmp5_;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp6_ = source_list;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp7_ = actor;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 142 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_g_object_unref0 (source_list);
#line 289 "DragDropAction.c"
	}
}


static void gala_drag_drop_action_connect_actor (GalaDragDropAction* self, ClutterActor* actor) {
	GalaDragDropActionType _tmp0_;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (actor != NULL);
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
#line 304 "DragDropAction.c"
		ClutterActor* _tmp1_;
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp2_;
		const gchar* _tmp3_;
		gpointer _tmp4_;
		GeeLinkedList* _tmp5_;
		GeeLinkedList* _tmp10_;
		ClutterActor* _tmp11_;
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp1_ = actor;
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_signal_connect_object (_tmp1_, "button-press-event", (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self, 0);
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp2_ = gala_drag_drop_action_sources;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp3_ = self->priv->_drag_id;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		source_list = (GeeLinkedList*) _tmp4_;
#line 156 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp5_ = source_list;
#line 156 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		if (_tmp5_ == NULL) {
#line 329 "DragDropAction.c"
			GeeLinkedList* _tmp6_;
			GeeHashMap* _tmp7_;
			const gchar* _tmp8_;
			GeeLinkedList* _tmp9_;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp6_ = gee_linked_list_new (clutter_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_g_object_unref0 (source_list);
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			source_list = _tmp6_;
#line 158 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp7_ = gala_drag_drop_action_sources;
#line 158 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp8_ = self->priv->_drag_id;
#line 158 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp9_ = source_list;
#line 158 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, _tmp8_, _tmp9_);
#line 348 "DragDropAction.c"
		}
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp10_ = source_list;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp11_ = actor;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_g_object_unref0 (source_list);
#line 358 "DragDropAction.c"
	}
}


static void gala_drag_drop_action_emit_crossed (GalaDragDropAction* self, ClutterActor* destination, gboolean hovered) {
	ClutterActor* _tmp0_;
	GalaDragDropAction* _tmp1_;
	GalaDragDropAction* _tmp2_;
	gboolean _tmp3_;
	ClutterActor* _tmp4_;
	gboolean _tmp5_;
#line 165 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 165 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (destination != NULL);
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = destination;
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp0_);
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp2_ = _tmp1_;
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp3_ = hovered;
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_signal_emit (_tmp2_, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL], 0, _tmp3_);
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_g_object_unref0 (_tmp2_);
#line 168 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp4_ = destination;
#line 168 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp5_ = hovered;
#line 168 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL], 0, _tmp4_, _tmp5_);
#line 392 "DragDropAction.c"
}


static gboolean _gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender, ClutterEvent* event, gpointer self) {
	gboolean result;
	result = gala_drag_drop_action_follow_move ((GalaDragDropAction*) self, event);
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 401 "DragDropAction.c"
}


static gboolean gala_drag_drop_action_source_clicked (GalaDragDropAction* self, ClutterButtonEvent* event) {
	gboolean result = FALSE;
	ClutterButtonEvent* _tmp0_;
	guint32 _tmp1_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterStage* _tmp6_;
	ClutterButtonEvent* _tmp7_;
	gfloat _tmp8_;
	ClutterButtonEvent* _tmp9_;
	gfloat _tmp10_;
#line 171 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = event;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = _tmp0_->button;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp1_ != ((guint32) 1)) {
#line 426 "DragDropAction.c"
		ClutterButtonEvent* _tmp2_;
		guint32 _tmp3_;
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp2_ = event;
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp3_ = _tmp2_->button;
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, _tmp3_);
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		result = FALSE;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		return result;
#line 439 "DragDropAction.c"
	}
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp4_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp5_ = _tmp4_;
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp6_ = clutter_actor_get_stage (_tmp5_);
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_signal_connect_object ((ClutterActor*) _tmp6_, "captured-event", (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self, 0);
#line 179 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self->priv->clicked = TRUE;
#line 180 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp7_ = event;
#line 180 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp8_ = _tmp7_->x;
#line 180 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self->priv->last_x = _tmp8_;
#line 181 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp9_ = event;
#line 181 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp10_ = _tmp9_->y;
#line 181 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self->priv->last_y = _tmp10_;
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	result = TRUE;
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 467 "DragDropAction.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return self ? g_object_ref (self) : NULL;
#line 474 "DragDropAction.c"
}


static gboolean gala_drag_drop_action_follow_move (GalaDragDropAction* self, ClutterEvent* event) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	ClutterEvent* _tmp76_;
	ClutterEventType _tmp77_;
#line 186 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 189 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->_dragging;
#line 189 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (!_tmp0_) {
#line 491 "DragDropAction.c"
		ClutterEvent* _tmp1_;
		ClutterEventType _tmp2_;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp1_ = event;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp2_ = clutter_event_type (_tmp1_);
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		switch (_tmp2_) {
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			case CLUTTER_MOTION:
#line 502 "DragDropAction.c"
			{
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				ClutterEvent* _tmp3_;
				gfloat _tmp4_ = 0.0F;
				gfloat _tmp5_ = 0.0F;
				gint drag_threshold = 0;
				ClutterSettings* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gboolean _tmp9_ = FALSE;
				gfloat _tmp10_;
				gfloat _tmp11_;
				gfloat _tmp12_;
				gint _tmp13_;
#line 193 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp3_ = event;
#line 193 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				clutter_event_get_coords (_tmp3_, &_tmp4_, &_tmp5_);
#line 193 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				x = _tmp4_;
#line 193 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				y = _tmp5_;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp6_ = clutter_settings_get_default ();
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				g_object_get (_tmp6_, "dnd-drag-threshold", &_tmp7_, NULL);
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp8_ = _tmp7_;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				drag_threshold = _tmp8_;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp10_ = self->priv->last_x;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp11_ = x;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp12_ = fabsf (_tmp10_ - _tmp11_);
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp13_ = drag_threshold;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp12_ > ((gfloat) _tmp13_)) {
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp9_ = TRUE;
#line 546 "DragDropAction.c"
				} else {
					gfloat _tmp14_;
					gfloat _tmp15_;
					gfloat _tmp16_;
					gint _tmp17_;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp14_ = self->priv->last_y;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp15_ = y;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp16_ = fabsf (_tmp14_ - _tmp15_);
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp17_ = drag_threshold;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp9_ = _tmp16_ > ((gfloat) _tmp17_);
#line 562 "DragDropAction.c"
				}
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp9_) {
#line 566 "DragDropAction.c"
					gfloat _tmp18_;
					gfloat _tmp19_;
					ClutterActor* _tmp20_ = NULL;
					ClutterActor* _tmp21_;
					ClutterActor* _tmp22_;
					ClutterActor* _tmp27_;
					GeeLinkedList* source_list = NULL;
					GeeHashMap* _tmp28_;
					const gchar* _tmp29_;
					gpointer _tmp30_;
					GeeLinkedList* _tmp31_;
#line 197 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp18_ = x;
#line 197 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp19_ = y;
#line 197 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL], 0, _tmp18_, _tmp19_, &_tmp20_);
#line 197 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp21_ = _tmp20_;
#line 197 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					gala_drag_drop_action_set_handle (self, _tmp21_);
#line 197 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_g_object_unref0 (_tmp21_);
#line 198 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp22_ = self->priv->_handle;
#line 198 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					if (_tmp22_ == NULL) {
#line 594 "DragDropAction.c"
						ClutterActor* _tmp23_;
						ClutterActor* _tmp24_;
						ClutterStage* _tmp25_;
						guint _tmp26_;
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						_tmp23_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						_tmp24_ = _tmp23_;
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						_tmp25_ = clutter_actor_get_stage (_tmp24_);
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp26_, NULL, FALSE);
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp25_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp26_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 200 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						g_critical ("DragDropAction.vala:200: No handle has been returned by the started si" \
"gnal, aborting drag.");
#line 201 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						result = FALSE;
#line 201 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						return result;
#line 615 "DragDropAction.c"
					}
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp27_ = self->priv->_handle;
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					clutter_actor_set_reactive (_tmp27_, FALSE);
#line 206 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					self->priv->clicked = FALSE;
#line 207 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					gala_drag_drop_action_set_dragging (self, TRUE);
#line 209 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp28_ = gala_drag_drop_action_sources;
#line 209 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp29_ = self->priv->_drag_id;
#line 209 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp30_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp28_, _tmp29_);
#line 209 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					source_list = (GeeLinkedList*) _tmp30_;
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp31_ = source_list;
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					if (_tmp31_ != NULL) {
#line 637 "DragDropAction.c"
						{
							GeeLinkedList* _actor_list = NULL;
							GeeLinkedList* _tmp32_;
							GeeLinkedList* _tmp33_;
							gint _actor_size = 0;
							GeeLinkedList* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gint _actor_index = 0;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp32_ = source_list;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp33_ = _g_object_ref0 (_tmp32_);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_actor_list = _tmp33_;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp34_ = _actor_list;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp36_ = _tmp35_;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_actor_size = _tmp36_;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_actor_index = -1;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							while (TRUE) {
#line 665 "DragDropAction.c"
								gint _tmp37_;
								gint _tmp38_;
								gint _tmp39_;
								ClutterActor* actor = NULL;
								GeeLinkedList* _tmp40_;
								gint _tmp41_;
								gpointer _tmp42_;
								ClutterActor* _tmp43_;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_tmp37_ = _actor_index;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_actor_index = _tmp37_ + 1;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_tmp38_ = _actor_index;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_tmp39_ = _actor_size;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								if (!(_tmp38_ < _tmp39_)) {
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
									break;
#line 686 "DragDropAction.c"
								}
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_tmp40_ = _actor_list;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_tmp41_ = _actor_index;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, _tmp41_);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								actor = (ClutterActor*) _tmp42_;
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_tmp43_ = actor;
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								clutter_actor_set_reactive (_tmp43_, FALSE);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
								_g_object_unref0 (actor);
#line 702 "DragDropAction.c"
							}
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_g_object_unref0 (_actor_list);
#line 706 "DragDropAction.c"
						}
					}
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_g_object_unref0 (source_list);
#line 711 "DragDropAction.c"
				}
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				result = TRUE;
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				return result;
#line 717 "DragDropAction.c"
			}
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			case CLUTTER_BUTTON_RELEASE:
#line 721 "DragDropAction.c"
			{
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				gfloat ex = 0.0F;
				gfloat ey = 0.0F;
				ClutterEvent* _tmp44_;
				gfloat _tmp45_ = 0.0F;
				gfloat _tmp46_ = 0.0F;
				ClutterActor* _tmp47_;
				ClutterActor* _tmp48_;
				gfloat _tmp49_ = 0.0F;
				gfloat _tmp50_ = 0.0F;
				gboolean _tmp51_ = FALSE;
				gboolean _tmp52_ = FALSE;
				gboolean _tmp53_ = FALSE;
				gfloat _tmp54_;
				gfloat _tmp55_;
				ClutterActor* _tmp72_;
				ClutterActor* _tmp73_;
				ClutterStage* _tmp74_;
				guint _tmp75_;
#line 219 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp44_ = event;
#line 219 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				clutter_event_get_coords (_tmp44_, &_tmp45_, &_tmp46_);
#line 219 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				ex = _tmp45_;
#line 219 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				ey = _tmp46_;
#line 220 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp47_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 220 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp48_ = _tmp47_;
#line 220 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				clutter_actor_get_transformed_position (_tmp48_, &_tmp49_, &_tmp50_);
#line 220 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				x = _tmp49_;
#line 220 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				y = _tmp50_;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp54_ = x;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp55_ = ex;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp54_ < _tmp55_) {
#line 767 "DragDropAction.c"
					gfloat _tmp56_;
					ClutterActor* _tmp57_;
					ClutterActor* _tmp58_;
					gfloat _tmp59_;
					gfloat _tmp60_;
					gfloat _tmp61_;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp56_ = x;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp57_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp58_ = _tmp57_;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp59_ = clutter_actor_get_width (_tmp58_);
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp60_ = _tmp59_;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp61_ = ex;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp53_ = (_tmp56_ + _tmp60_) > _tmp61_;
#line 788 "DragDropAction.c"
				} else {
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp53_ = FALSE;
#line 792 "DragDropAction.c"
				}
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp53_) {
#line 796 "DragDropAction.c"
					gfloat _tmp62_;
					gfloat _tmp63_;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp62_ = y;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp63_ = ey;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp52_ = _tmp62_ < _tmp63_;
#line 805 "DragDropAction.c"
				} else {
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp52_ = FALSE;
#line 809 "DragDropAction.c"
				}
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp52_) {
#line 813 "DragDropAction.c"
					gfloat _tmp64_;
					ClutterActor* _tmp65_;
					ClutterActor* _tmp66_;
					gfloat _tmp67_;
					gfloat _tmp68_;
					gfloat _tmp69_;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp64_ = y;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp65_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp66_ = _tmp65_;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp67_ = clutter_actor_get_height (_tmp66_);
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp68_ = _tmp67_;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp69_ = ey;
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp51_ = (_tmp64_ + _tmp68_) > _tmp69_;
#line 834 "DragDropAction.c"
				} else {
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp51_ = FALSE;
#line 838 "DragDropAction.c"
				}
#line 223 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp51_) {
#line 842 "DragDropAction.c"
					ClutterEvent* _tmp70_;
					guint32 _tmp71_;
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp70_ = event;
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp71_ = clutter_event_get_button (_tmp70_);
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, _tmp71_);
#line 851 "DragDropAction.c"
				}
#line 227 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp72_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 227 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp73_ = _tmp72_;
#line 227 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp74_ = clutter_actor_get_stage (_tmp73_);
#line 227 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp75_, NULL, FALSE);
#line 227 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp74_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp75_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				self->priv->clicked = FALSE;
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				gala_drag_drop_action_set_dragging (self, FALSE);
#line 230 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				result = TRUE;
#line 230 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				return result;
#line 871 "DragDropAction.c"
			}
			default:
			{
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				result = TRUE;
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				return result;
#line 879 "DragDropAction.c"
			}
		}
	}
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp76_ = event;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp77_ = clutter_event_type (_tmp76_);
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	switch (_tmp77_) {
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case CLUTTER_KEY_PRESS:
#line 891 "DragDropAction.c"
		{
			ClutterEvent* _tmp78_;
			guint16 _tmp79_;
#line 238 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp78_ = event;
#line 238 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp79_ = clutter_event_get_key_code (_tmp78_);
#line 238 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (((gint) _tmp79_) == CLUTTER_KEY_Escape) {
#line 239 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				gala_drag_drop_action_cancel (self);
#line 903 "DragDropAction.c"
			}
#line 241 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			result = TRUE;
#line 241 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			return result;
#line 909 "DragDropAction.c"
		}
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case CLUTTER_MOTION:
#line 913 "DragDropAction.c"
		{
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			ClutterEvent* _tmp80_;
			gfloat _tmp81_ = 0.0F;
			gfloat _tmp82_ = 0.0F;
			ClutterActor* _tmp83_;
			ClutterActor* _tmp84_;
			gfloat _tmp85_;
			gfloat _tmp86_;
			gfloat _tmp87_;
			gfloat _tmp88_;
			ClutterActor* _tmp89_;
			ClutterActor* _tmp90_;
			gfloat _tmp91_;
			gfloat _tmp92_;
			gfloat _tmp93_;
			gfloat _tmp94_;
			gfloat _tmp95_;
			gfloat _tmp96_;
			ClutterStage* stage = NULL;
			ClutterActor* _tmp97_;
			ClutterActor* _tmp98_;
			ClutterStage* _tmp99_;
			ClutterStage* _tmp100_;
			ClutterActor* actor = NULL;
			ClutterStage* _tmp101_;
			gfloat _tmp102_;
			gfloat _tmp103_;
			ClutterActor* _tmp104_;
			ClutterActor* _tmp105_;
			GalaDragDropAction* action = NULL;
			gboolean _tmp106_ = FALSE;
			gboolean _tmp107_ = FALSE;
			ClutterActor* _tmp108_;
			ClutterActor* _tmp121_;
			ClutterActor* _tmp122_;
			GalaDragDropAction* _tmp123_;
			ClutterActor* _tmp126_;
			ClutterActor* _tmp128_;
			ClutterActor* _tmp129_;
			ClutterActor* _tmp130_;
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp80_ = event;
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			clutter_event_get_coords (_tmp80_, &_tmp81_, &_tmp82_);
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			x = _tmp81_;
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			y = _tmp82_;
#line 245 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp83_ = self->priv->_handle;
#line 245 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp84_ = self->priv->_handle;
#line 245 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp85_ = clutter_actor_get_x (_tmp84_);
#line 245 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp86_ = _tmp85_;
#line 245 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp87_ = self->priv->last_x;
#line 245 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp88_ = x;
#line 245 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			clutter_actor_set_x (_tmp84_, _tmp86_ - (_tmp87_ - _tmp88_));
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp89_ = self->priv->_handle;
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp90_ = self->priv->_handle;
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp91_ = clutter_actor_get_y (_tmp90_);
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp92_ = _tmp91_;
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp93_ = self->priv->last_y;
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp94_ = y;
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			clutter_actor_set_y (_tmp90_, _tmp92_ - (_tmp93_ - _tmp94_));
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp95_ = x;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			self->priv->last_x = _tmp95_;
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp96_ = y;
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			self->priv->last_y = _tmp96_;
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp97_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp98_ = _tmp97_;
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp99_ = clutter_actor_get_stage (_tmp98_);
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp100_ = _g_object_ref0 (_tmp99_);
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			stage = _tmp100_;
#line 251 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp101_ = stage;
#line 251 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp102_ = x;
#line 251 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp103_ = y;
#line 251 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp104_ = clutter_stage_get_actor_at_pos (_tmp101_, CLUTTER_PICK_REACTIVE, (gint) _tmp102_, (gint) _tmp103_);
#line 251 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp105_ = _g_object_ref0 (_tmp104_);
#line 251 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			actor = _tmp105_;
#line 252 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			action = NULL;
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp108_ = actor;
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (_tmp108_ != NULL) {
#line 1028 "DragDropAction.c"
				ClutterActor* _tmp109_;
				GalaDragDropAction* _tmp110_;
				GalaDragDropAction* _tmp111_;
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp109_ = actor;
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp110_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp109_);
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (action);
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				action = _tmp110_;
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp111_ = action;
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp107_ = _tmp111_ == NULL;
#line 1044 "DragDropAction.c"
			} else {
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp107_ = FALSE;
#line 1048 "DragDropAction.c"
			}
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (_tmp107_) {
#line 1052 "DragDropAction.c"
				gboolean _tmp112_;
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp112_ = self->priv->_allow_bubbling;
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp106_ = _tmp112_;
#line 1058 "DragDropAction.c"
			} else {
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp106_ = FALSE;
#line 1062 "DragDropAction.c"
			}
#line 254 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (_tmp106_) {
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				while (TRUE) {
#line 1068 "DragDropAction.c"
					ClutterActor* _tmp113_;
					ClutterActor* _tmp114_;
					ClutterActor* _tmp115_;
					ClutterActor* _tmp116_;
					ClutterStage* _tmp117_;
					ClutterActor* _tmp118_;
					GalaDragDropAction* _tmp119_;
					GalaDragDropAction* _tmp120_;
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp113_ = actor;
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp114_ = clutter_actor_get_parent (_tmp113_);
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp115_ = _g_object_ref0 (_tmp114_);
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_g_object_unref0 (actor);
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					actor = _tmp115_;
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp116_ = actor;
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp117_ = stage;
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					if (!(_tmp116_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp117_, clutter_actor_get_type (), ClutterActor))) {
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						break;
#line 1095 "DragDropAction.c"
					}
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp118_ = actor;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp119_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp118_);
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_g_object_unref0 (action);
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					action = _tmp119_;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp120_ = action;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					if (_tmp120_ != NULL) {
#line 257 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						break;
#line 1111 "DragDropAction.c"
					}
				}
			}
#line 262 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp121_ = actor;
#line 262 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp122_ = self->priv->hovered;
#line 262 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (_tmp121_ == _tmp122_) {
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				result = TRUE;
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (action);
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (actor);
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (stage);
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				return result;
#line 1131 "DragDropAction.c"
			}
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp123_ = action;
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (_tmp123_ == NULL) {
#line 1137 "DragDropAction.c"
				ClutterActor* _tmp124_;
#line 267 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp124_ = self->priv->hovered;
#line 267 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp124_ != NULL) {
#line 1143 "DragDropAction.c"
					ClutterActor* _tmp125_;
#line 268 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp125_ = self->priv->hovered;
#line 268 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					gala_drag_drop_action_emit_crossed (self, _tmp125_, FALSE);
#line 269 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_g_object_unref0 (self->priv->hovered);
#line 269 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					self->priv->hovered = NULL;
#line 1153 "DragDropAction.c"
				}
#line 272 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				result = TRUE;
#line 272 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (action);
#line 272 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (actor);
#line 272 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (stage);
#line 272 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				return result;
#line 1165 "DragDropAction.c"
			}
#line 276 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp126_ = self->priv->hovered;
#line 276 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (_tmp126_ != NULL) {
#line 1171 "DragDropAction.c"
				ClutterActor* _tmp127_;
#line 277 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp127_ = self->priv->hovered;
#line 277 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				gala_drag_drop_action_emit_crossed (self, _tmp127_, FALSE);
#line 1177 "DragDropAction.c"
			}
#line 281 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp128_ = actor;
#line 281 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp129_ = _g_object_ref0 (_tmp128_);
#line 281 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_g_object_unref0 (self->priv->hovered);
#line 281 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			self->priv->hovered = _tmp129_;
#line 282 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp130_ = self->priv->hovered;
#line 282 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			gala_drag_drop_action_emit_crossed (self, _tmp130_, TRUE);
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			result = TRUE;
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_g_object_unref0 (action);
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_g_object_unref0 (actor);
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_g_object_unref0 (stage);
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			return result;
#line 1201 "DragDropAction.c"
		}
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case CLUTTER_BUTTON_RELEASE:
#line 1205 "DragDropAction.c"
		{
			ClutterActor* _tmp131_;
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp131_ = self->priv->hovered;
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (_tmp131_ != NULL) {
#line 287 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				gala_drag_drop_action_finish (self);
#line 1214 "DragDropAction.c"
			} else {
#line 289 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				gala_drag_drop_action_cancel (self);
#line 1218 "DragDropAction.c"
			}
#line 291 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			result = TRUE;
#line 291 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			return result;
#line 1224 "DragDropAction.c"
		}
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case CLUTTER_ENTER:
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case CLUTTER_LEAVE:
#line 1230 "DragDropAction.c"
		{
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			result = TRUE;
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			return result;
#line 1236 "DragDropAction.c"
		}
		default:
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 1241 "DragDropAction.c"
	}
#line 297 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	result = FALSE;
#line 297 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 1247 "DragDropAction.c"
}


/**
 * Looks for a DragDropAction instance if this actor has one or NULL.
 * It also checks if it is a DESTINATION and if the id matches
 *
 * @return the DragDropAction instance on this actor or NULL
 */
static GalaDragDropAction* gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self, ClutterActor* actor) {
	GalaDragDropAction* result = NULL;
	GalaDragDropAction* drop_action = NULL;
	ClutterActor* _tmp0_;
	GList* _tmp1_;
#line 306 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 306 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 308 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	drop_action = NULL;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = actor;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = clutter_actor_get_actions (_tmp0_);
#line 1272 "DragDropAction.c"
	{
		GList* action_collection = NULL;
		GList* action_it = NULL;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		action_collection = _tmp1_;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
#line 1280 "DragDropAction.c"
			ClutterAction* action = NULL;
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			action = (ClutterAction*) action_it->data;
#line 1284 "DragDropAction.c"
			{
				ClutterAction* _tmp2_;
				GalaDragDropAction* _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				GalaDragDropAction* _tmp6_;
#line 311 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp2_ = action;
#line 311 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp2_) : NULL);
#line 311 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (drop_action);
#line 311 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				drop_action = _tmp3_;
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp6_ = drop_action;
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp6_ == NULL) {
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp5_ = TRUE;
#line 1305 "DragDropAction.c"
				} else {
					GalaDragDropAction* _tmp7_;
					GalaDragDropActionType _tmp8_;
#line 313 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp7_ = drop_action;
#line 313 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp8_ = _tmp7_->priv->_drag_type;
#line 313 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp5_ = _tmp8_ != GALA_DRAG_DROP_ACTION_TYPE_DESTINATION;
#line 1315 "DragDropAction.c"
				}
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp5_) {
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp4_ = TRUE;
#line 1321 "DragDropAction.c"
				} else {
					GalaDragDropAction* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
#line 314 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp9_ = drop_action;
#line 314 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp10_ = _tmp9_->priv->_drag_id;
#line 314 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp11_ = self->priv->_drag_id;
#line 314 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					_tmp4_ = g_strcmp0 (_tmp10_, _tmp11_) != 0;
#line 1334 "DragDropAction.c"
				}
#line 312 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (_tmp4_) {
#line 315 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					continue;
#line 1340 "DragDropAction.c"
				}
#line 317 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				result = drop_action;
#line 317 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_list_free0 (action_collection);
#line 317 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				return result;
#line 1348 "DragDropAction.c"
			}
		}
#line 310 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_g_list_free0 (action_collection);
#line 1353 "DragDropAction.c"
	}
#line 320 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	result = NULL;
#line 320 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_g_object_unref0 (drop_action);
#line 320 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 1361 "DragDropAction.c"
}


/**
 * Abort the drag
 */
void gala_drag_drop_action_cancel (GalaDragDropAction* self) {
#line 326 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 328 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_cleanup (self);
#line 330 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL], 0);
#line 1375 "DragDropAction.c"
}


/**
 * Allows you to abort all drags currently running for a given drag-id
 */
void gala_drag_drop_action_cancel_all_by_id (const gchar* id) {
	GeeLinkedList* actors = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	GeeLinkedList* _tmp3_;
#line 336 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (id != NULL);
#line 338 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 338 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = id;
#line 338 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 338 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	actors = (GeeLinkedList*) _tmp2_;
#line 339 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp3_ = actors;
#line 339 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp3_ == NULL) {
#line 340 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_g_object_unref0 (actors);
#line 340 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		return;
#line 1406 "DragDropAction.c"
	}
	{
		GeeLinkedList* _actor_list = NULL;
		GeeLinkedList* _tmp4_;
		GeeLinkedList* _tmp5_;
		gint _actor_size = 0;
		GeeLinkedList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _actor_index = 0;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp4_ = actors;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_actor_list = _tmp5_;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp6_ = _actor_list;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp8_ = _tmp7_;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_actor_size = _tmp8_;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_actor_index = -1;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		while (TRUE) {
#line 1435 "DragDropAction.c"
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			ClutterActor* actor = NULL;
			GeeLinkedList* _tmp12_;
			gint _tmp13_;
			gpointer _tmp14_;
			ClutterActor* _tmp15_;
			GList* _tmp16_;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp9_ = _actor_index;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_actor_index = _tmp9_ + 1;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp10_ = _actor_index;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp11_ = _actor_size;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				break;
#line 1457 "DragDropAction.c"
			}
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp12_ = _actor_list;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp13_ = _actor_index;
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			actor = (ClutterActor*) _tmp14_;
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp15_ = actor;
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp16_ = clutter_actor_get_actions (_tmp15_);
#line 1471 "DragDropAction.c"
			{
				GList* action_collection = NULL;
				GList* action_it = NULL;
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				action_collection = _tmp16_;
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
#line 1479 "DragDropAction.c"
					ClutterAction* action = NULL;
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					action = (ClutterAction*) action_it->data;
#line 1483 "DragDropAction.c"
					{
						GalaDragDropAction* drag_action = NULL;
						ClutterAction* _tmp17_;
						GalaDragDropAction* _tmp18_;
						gboolean _tmp19_ = FALSE;
						GalaDragDropAction* _tmp20_;
#line 344 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						_tmp17_ = action;
#line 344 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp17_) : NULL);
#line 344 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						drag_action = _tmp18_;
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						_tmp20_ = drag_action;
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						if (_tmp20_ != NULL) {
#line 1500 "DragDropAction.c"
							GalaDragDropAction* _tmp21_;
							gboolean _tmp22_;
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp21_ = drag_action;
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp22_ = _tmp21_->priv->_dragging;
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp19_ = _tmp22_;
#line 1509 "DragDropAction.c"
						} else {
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp19_ = FALSE;
#line 1513 "DragDropAction.c"
						}
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						if (_tmp19_) {
#line 1517 "DragDropAction.c"
							GalaDragDropAction* _tmp23_;
#line 346 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_tmp23_ = drag_action;
#line 346 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							gala_drag_drop_action_cancel (_tmp23_);
#line 347 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							_g_object_unref0 (drag_action);
#line 347 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
							break;
#line 1527 "DragDropAction.c"
						}
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
						_g_object_unref0 (drag_action);
#line 1531 "DragDropAction.c"
					}
				}
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_list_free0 (action_collection);
#line 1536 "DragDropAction.c"
			}
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_g_object_unref0 (actor);
#line 1540 "DragDropAction.c"
		}
#line 342 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_g_object_unref0 (_actor_list);
#line 1544 "DragDropAction.c"
	}
#line 336 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_g_object_unref0 (actors);
#line 1548 "DragDropAction.c"
}


static void gala_drag_drop_action_finish (GalaDragDropAction* self) {
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 353 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 356 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->hovered;
#line 356 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_emit_crossed (self, _tmp0_, FALSE);
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_cleanup (self);
#line 360 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = self->priv->hovered;
#line 360 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL], 0, _tmp1_);
#line 1567 "DragDropAction.c"
}


static void gala_drag_drop_action_cleanup (GalaDragDropAction* self) {
	GeeLinkedList* source_list = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	GeeLinkedList* _tmp3_;
	gboolean _tmp16_;
#line 363 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 365 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = gala_drag_drop_action_sources;
#line 365 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = self->priv->_drag_id;
#line 365 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 365 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	source_list = (GeeLinkedList*) _tmp2_;
#line 366 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp3_ = source_list;
#line 366 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp3_ != NULL) {
#line 1592 "DragDropAction.c"
		{
			GeeLinkedList* _actor_list = NULL;
			GeeLinkedList* _tmp4_;
			GeeLinkedList* _tmp5_;
			gint _actor_size = 0;
			GeeLinkedList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _actor_index = 0;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp4_ = source_list;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_actor_list = _tmp5_;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp6_ = _actor_list;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_tmp8_ = _tmp7_;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_actor_size = _tmp8_;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_actor_index = -1;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			while (TRUE) {
#line 1620 "DragDropAction.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				ClutterActor* actor = NULL;
				GeeLinkedList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				ClutterActor* _tmp15_;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp9_ = _actor_index;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_actor_index = _tmp9_ + 1;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp10_ = _actor_index;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp11_ = _actor_size;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
					break;
#line 1641 "DragDropAction.c"
				}
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp12_ = _actor_list;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp13_ = _actor_index;
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				actor = (ClutterActor*) _tmp14_;
#line 368 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_tmp15_ = actor;
#line 368 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				clutter_actor_set_reactive (_tmp15_, TRUE);
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
				_g_object_unref0 (actor);
#line 1657 "DragDropAction.c"
			}
#line 367 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
			_g_object_unref0 (_actor_list);
#line 1661 "DragDropAction.c"
		}
	}
#line 372 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp16_ = self->priv->_dragging;
#line 372 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp16_) {
#line 1668 "DragDropAction.c"
		ClutterActor* _tmp17_;
		ClutterActor* _tmp18_;
		ClutterStage* _tmp19_;
		guint _tmp20_;
#line 373 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp17_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 373 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp18_ = _tmp17_;
#line 373 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp19_ = clutter_actor_get_stage (_tmp18_);
#line 373 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp20_, NULL, FALSE);
#line 373 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
#line 1683 "DragDropAction.c"
	}
#line 375 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_set_dragging (self, FALSE);
#line 363 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_g_object_unref0 (source_list);
#line 1689 "DragDropAction.c"
}


GalaDragDropActionType gala_drag_drop_action_get_drag_type (GalaDragDropAction* self) {
	GalaDragDropActionType result;
	GalaDragDropActionType _tmp0_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_type;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	result = _tmp0_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 1704 "DragDropAction.c"
}


static void gala_drag_drop_action_set_drag_type (GalaDragDropAction* self, GalaDragDropActionType value) {
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (gala_drag_drop_action_get_drag_type (self) != value) {
#line 1713 "DragDropAction.c"
		GalaDragDropActionType _tmp0_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp0_ = value;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		self->priv->_drag_type = _tmp0_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE]);
#line 1721 "DragDropAction.c"
	}
}


const gchar* gala_drag_drop_action_get_drag_id (GalaDragDropAction* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->_drag_id;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	result = _tmp0_;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 1737 "DragDropAction.c"
}


static void gala_drag_drop_action_set_drag_id (GalaDragDropAction* self, const gchar* value) {
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (g_strcmp0 (value, gala_drag_drop_action_get_drag_id (self)) != 0) {
#line 1746 "DragDropAction.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp0_ = value;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_g_free0 (self->priv->_drag_id);
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		self->priv->_drag_id = _tmp1_;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID]);
#line 1759 "DragDropAction.c"
	}
}


ClutterActor* gala_drag_drop_action_get_handle (GalaDragDropAction* self) {
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->_handle;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	result = _tmp0_;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 1775 "DragDropAction.c"
}


static void gala_drag_drop_action_set_handle (GalaDragDropAction* self, ClutterActor* value) {
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (gala_drag_drop_action_get_handle (self) != value) {
#line 1784 "DragDropAction.c"
		ClutterActor* _tmp0_;
		ClutterActor* _tmp1_;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp0_ = value;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_g_object_unref0 (self->priv->_handle);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		self->priv->_handle = _tmp1_;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE]);
#line 1797 "DragDropAction.c"
	}
}


gboolean gala_drag_drop_action_get_dragging (GalaDragDropAction* self) {
	gboolean result;
	gboolean _tmp0_;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->_dragging;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	result = _tmp0_;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 1813 "DragDropAction.c"
}


static void gala_drag_drop_action_set_dragging (GalaDragDropAction* self, gboolean value) {
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (gala_drag_drop_action_get_dragging (self) != value) {
#line 1822 "DragDropAction.c"
		gboolean _tmp0_;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp0_ = value;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		self->priv->_dragging = _tmp0_;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING]);
#line 1830 "DragDropAction.c"
	}
}


gboolean gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self) {
	gboolean result;
	gboolean _tmp0_;
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = self->priv->_allow_bubbling;
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	result = _tmp0_;
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	return result;
#line 1846 "DragDropAction.c"
}


void gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self, gboolean value) {
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (self != NULL);
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (gala_drag_drop_action_get_allow_bubbling (self) != value) {
#line 1855 "DragDropAction.c"
		gboolean _tmp0_;
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp0_ = value;
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		self->priv->_allow_bubbling = _tmp0_;
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING]);
#line 1863 "DragDropAction.c"
	}
}


static void g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef gpointer (*GMarshalFunc_OBJECT__FLOAT_FLOAT) (gpointer data1, gfloat arg_1, gfloat arg_2, gpointer data2);
	register GMarshalFunc_OBJECT__FLOAT_FLOAT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gpointer v_return;
	cc = (GCClosure *) closure;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (return_value != NULL);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		data1 = closure->data;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 1886 "DragDropAction.c"
	} else {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		data2 = closure->data;
#line 1892 "DragDropAction.c"
	}
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	callback = (GMarshalFunc_OBJECT__FLOAT_FLOAT) (marshal_data ? marshal_data : cc->callback);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	v_return = callback (data1, g_value_get_float (param_values + 1), g_value_get_float (param_values + 2), data2);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_value_take_object (return_value, v_return);
#line 1900 "DragDropAction.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_return_if_fail (n_param_values == 3);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		data1 = closure->data;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		data2 = param_values->data[0].v_pointer;
#line 1919 "DragDropAction.c"
	} else {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		data1 = param_values->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		data2 = closure->data;
#line 1925 "DragDropAction.c"
	}
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 1931 "DragDropAction.c"
}


static void gala_drag_drop_action_class_init (GalaDragDropActionClass * klass) {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_type_class_add_private (klass, sizeof (GalaDragDropActionPrivate));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	((ClutterActorMetaClass *) klass)->set_actor = (void (*) (ClutterActorMeta *, ClutterActor*)) gala_drag_drop_action_real_set_actor;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_drag_drop_action_get_property;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_drag_drop_action_set_property;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_drag_drop_action_finalize;
#line 1948 "DragDropAction.c"
	/**
	 * The type of the action
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_TYPE, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE] = g_param_spec_enum ("drag-type", "drag-type", "drag-type", GALA_TYPE_DRAG_DROP_ACTION_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1954 "DragDropAction.c"
	/**
	 * The unique id given to this drag-drop-group
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_ID, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID] = g_param_spec_string ("drag-id", "drag-id", "drag-id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_HANDLE, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE] = g_param_spec_object ("handle", "handle", "handle", clutter_actor_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1962 "DragDropAction.c"
	/**
	 * Indicates whether a drag action is currently active
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAGGING, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING] = g_param_spec_boolean ("dragging", "dragging", "dragging", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1968 "DragDropAction.c"
	/**
	 * Allow checking the parents of reactive children if they are valid destinations
	 * if the child is none
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING] = g_param_spec_boolean ("allow-bubbling", "allow-bubbling", "allow-bubbling", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1975 "DragDropAction.c"
	/**
	 * A drag has been started. You have to connect to this signal and
	 * return an actor that is transformed during the drag operation.
	 *
	 * @param x The global x coordinate where the action was activated
	 * @param y The global y coordinate where the action was activated
	 * @return  A ClutterActor that serves as handle
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL] = g_signal_new ("drag-begin", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT, clutter_actor_get_type (), 2, G_TYPE_FLOAT, G_TYPE_FLOAT);
#line 1986 "DragDropAction.c"
	/**
	 * A drag has been canceled. You may want to consider cleaning up
	 * your handle.
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL] = g_signal_new ("drag-canceled", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1993 "DragDropAction.c"
	/**
	 * A drag action has successfully been finished.
	 *
	 * @param actor The actor on which the drag finished
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL] = g_signal_new ("drag-end", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, clutter_actor_get_type ());
#line 2001 "DragDropAction.c"
	/**
	 * The destination has been crossed
	 *
	 * @param hovered indicates whether the actor is now hovered or not
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL] = g_signal_new ("crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 2009 "DragDropAction.c"
	/**
	 * Emitted on the source when a destination is crossed.
	 *
	 * @param destination The destination actor that has been crossed
	 * @param hovered     Whether the actor is now hovered or has just been left
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL] = g_signal_new ("destination-crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, clutter_actor_get_type (), G_TYPE_BOOLEAN);
#line 2018 "DragDropAction.c"
	/**
	 * The source has been clicked, but the movement was not larger than
	 * the drag threshold. Useful if the source is also activable.
	 *
	 * @param button The button which was pressed
	 */
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL] = g_signal_new ("actor-clicked", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 2027 "DragDropAction.c"
}


static void gala_drag_drop_action_instance_init (GalaDragDropAction * self) {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self->priv = GALA_DRAG_DROP_ACTION_GET_PRIVATE (self);
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self->priv->_dragging = FALSE;
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self->priv->_allow_bubbling = TRUE;
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self->priv->hovered = NULL;
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self->priv->clicked = FALSE;
#line 2042 "DragDropAction.c"
}


static void gala_drag_drop_action_finalize (GObject * obj) {
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_tmp1_ = _tmp0_;
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	if (_tmp1_ != NULL) {
#line 2058 "DragDropAction.c"
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		_tmp3_ = _tmp2_;
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_release_actor (self, _tmp3_);
#line 2067 "DragDropAction.c"
	}
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_g_free0 (self->priv->_drag_id);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_g_object_unref0 (self->priv->_handle);
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	_g_object_unref0 (self->priv->hovered);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	G_OBJECT_CLASS (gala_drag_drop_action_parent_class)->finalize (obj);
#line 2077 "DragDropAction.c"
}


GType gala_drag_drop_action_get_type (void) {
	static volatile gsize gala_drag_drop_action_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaDragDropActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_drag_drop_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDragDropAction), 0, (GInstanceInitFunc) gala_drag_drop_action_instance_init, NULL };
		GType gala_drag_drop_action_type_id;
		gala_drag_drop_action_type_id = g_type_register_static (clutter_action_get_type (), "GalaDragDropAction", &g_define_type_info, 0);
		g_once_init_leave (&gala_drag_drop_action_type_id__volatile, gala_drag_drop_action_type_id);
	}
	return gala_drag_drop_action_type_id__volatile;
}


static void _vala_gala_drag_drop_action_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_value_set_enum (value, gala_drag_drop_action_get_drag_type (self));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_ID:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_value_set_string (value, gala_drag_drop_action_get_drag_id (self));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HANDLE:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_value_set_object (value, gala_drag_drop_action_get_handle (self));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAGGING:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_value_set_boolean (value, gala_drag_drop_action_get_dragging (self));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		g_value_set_boolean (value, gala_drag_drop_action_get_allow_bubbling (self));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 2128 "DragDropAction.c"
		default:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 2134 "DragDropAction.c"
	}
}


static void _vala_gala_drag_drop_action_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_set_drag_type (self, g_value_get_enum (value));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAG_ID:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_set_drag_id (self, g_value_get_string (value));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_HANDLE:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_set_handle (self, g_value_get_object (value));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_DRAGGING:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_set_dragging (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		gala_drag_drop_action_set_allow_bubbling (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 2174 "DragDropAction.c"
		default:
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/DragDropAction.vala"
		break;
#line 2180 "DragDropAction.c"
	}
}



