/* PluginManager.c generated by valac 0.37.91, the Vala compiler
 * generated from PluginManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include "gala.h"
#include <X11/Xlib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <gmodule.h>
#include "config.h"
#include <meta/boxes.h>


#define GALA_TYPE_PLUGIN_MANAGER (gala_plugin_manager_get_type ())
#define GALA_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager))
#define GALA_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))
#define GALA_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))

typedef struct _GalaPluginManager GalaPluginManager;
typedef struct _GalaPluginManagerClass GalaPluginManagerClass;
typedef struct _GalaPluginManagerPrivate GalaPluginManagerPrivate;
enum  {
	GALA_PLUGIN_MANAGER_DUMMY_PROPERTY,
	GALA_PLUGIN_MANAGER_INITIALIZED,
	GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER,
	GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER,
	GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER,
	GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER,
	GALA_PLUGIN_MANAGER_LAST_PROPERTY
};
static GParamSpec* gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_LAST_PROPERTY];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
#define __vala_GalaPluginInfo_free0(var) ((var == NULL) ? NULL : (var = (_vala_GalaPluginInfo_free (var), NULL)))
typedef struct _Block3Data Block3Data;
enum  {
	GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL,
	GALA_PLUGIN_MANAGER_LAST_SIGNAL
};
static guint gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_LAST_SIGNAL] = {0};

typedef void (*GalaRegisterPluginFunction) (GalaPluginInfo* result, void* user_data);
struct _GalaPluginManager {
	GObject parent_instance;
	GalaPluginManagerPrivate * priv;
};

struct _GalaPluginManagerClass {
	GObjectClass parent_class;
};

struct _GalaPluginManagerPrivate {
	gboolean _initialized;
	XRectangle* _regions;
	gint _regions_length1;
	gint __regions_size_;
	gchar* _window_switcher_provider;
	gchar* _desktop_provider;
	gchar* _window_overview_provider;
	gchar* _workspace_view_provider;
	GHashTable* plugins;
	GFile* plugin_dir;
	GalaWindowManager* wm;
	GeeLinkedList* load_later_plugins;
};

struct _Block3Data {
	int _ref_count_;
	GalaPluginManager* self;
	XRectangle* regions;
	gint regions_length1;
	gint _regions_size_;
};


static gpointer gala_plugin_manager_parent_class = NULL;
static GalaPluginManager* gala_plugin_manager_instance;
static GalaPluginManager* gala_plugin_manager_instance = NULL;

GType gala_plugin_manager_get_type (void) G_GNUC_CONST;
#define GALA_PLUGIN_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerPrivate))
GalaPluginManager* gala_plugin_manager_get_default (void);
static GalaPluginManager* gala_plugin_manager_new (void);
static GalaPluginManager* gala_plugin_manager_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static GalaPluginInfo* _gala_plugin_info_dup (GalaPluginInfo* self);
static void _vala_GalaPluginInfo_free (GalaPluginInfo* self);
static gboolean gala_plugin_manager_load_module (GalaPluginManager* self, const gchar* plugin_name);
static void ___lambda31_ (GalaPluginManager* self, GFile* file, GFile* other_file, GFileMonitorEvent type);
static void ____lambda31__g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static gboolean gala_plugin_manager_check_provides (GalaPluginManager* self, const gchar* name, GalaPluginFunction provides);
gboolean gala_plugin_manager_get_initialized (GalaPluginManager* self);
static void gala_plugin_manager_load_plugin_class (GalaPluginManager* self, GalaPluginInfo* info);
static void gala_plugin_manager_initialize_plugin (GalaPluginManager* self, const gchar* plugin_name, GalaPlugin* plugin);
static void gala_plugin_manager_recalculate_regions (GalaPluginManager* self);
static void _gala_plugin_manager_recalculate_regions_gala_plugin_region_changed (GalaPlugin* _sender, gpointer self);
const gchar* gala_plugin_manager_get_workspace_view_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_workspace_view_provider (GalaPluginManager* self, const gchar* value);
const gchar* gala_plugin_manager_get_window_overview_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_window_overview_provider (GalaPluginManager* self, const gchar* value);
const gchar* gala_plugin_manager_get_desktop_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_desktop_provider (GalaPluginManager* self, const gchar* value);
const gchar* gala_plugin_manager_get_window_switcher_provider (GalaPluginManager* self);
static void gala_plugin_manager_set_window_switcher_provider (GalaPluginManager* self, const gchar* value);
void gala_plugin_manager_initialize (GalaPluginManager* self, GalaWindowManager* _wm);
static void _gala_plugin_manager_initialize_plugin_gh_func (gconstpointer key, gconstpointer value, gpointer self);
static void gala_plugin_manager_set_initialized (GalaPluginManager* self, gboolean value);
void gala_plugin_manager_load_waiting_plugins (GalaPluginManager* self);
GalaPlugin* gala_plugin_manager_get_plugin (GalaPluginManager* self, const gchar* id);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda30_ (Block3Data* _data3_, const gchar* name, GalaPlugin* plugin);
static void _vala_array_add3 (XRectangle* * array, int* length, int* size, XRectangle value);
static void ___lambda30__gh_func (gconstpointer key, gconstpointer value, gpointer self);
static void gala_plugin_manager_set_regions (GalaPluginManager* self, XRectangle* value, int value_length1);
XRectangle* gala_plugin_manager_get_regions (GalaPluginManager* self, int* result_length1);
static XRectangle* _vala_array_dup1 (XRectangle* self, int length);
static void gala_plugin_manager_finalize (GObject * obj);
static void _vala_gala_plugin_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_plugin_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GalaPluginManager* gala_plugin_manager_get_default (void) {
	GalaPluginManager* result = NULL;
	GalaPluginManager* _tmp0_;
	GalaPluginManager* _tmp2_;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = gala_plugin_manager_instance;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (_tmp0_ == NULL) {
#line 158 "PluginManager.c"
		GalaPluginManager* _tmp1_;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp1_ = gala_plugin_manager_new ();
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_object_unref0 (gala_plugin_manager_instance);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_instance = _tmp1_;
#line 166 "PluginManager.c"
	}
#line 30 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2_ = gala_plugin_manager_instance;
#line 30 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = _tmp2_;
#line 30 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 174 "PluginManager.c"
}


static void _g_free0_ (gpointer var) {
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	var = (g_free (var), NULL);
#line 181 "PluginManager.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 188 "PluginManager.c"
}


static GalaPluginInfo* _gala_plugin_info_dup (GalaPluginInfo* self) {
	GalaPluginInfo* dup;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	dup = g_new0 (GalaPluginInfo, 1);
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_info_copy (self, dup);
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return dup;
#line 200 "PluginManager.c"
}


static void _vala_GalaPluginInfo_free (GalaPluginInfo* self) {
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_info_destroy (self);
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_free (self);
#line 209 "PluginManager.c"
}


static void ___lambda31_ (GalaPluginManager* self, GFile* file, GFile* other_file, GFileMonitorEvent type) {
	GFileMonitorEvent _tmp0_;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (file != NULL);
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = type;
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (_tmp0_ == G_FILE_MONITOR_EVENT_CREATED) {
#line 221 "PluginManager.c"
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp1_ = file;
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp2_ = g_file_get_basename (_tmp1_);
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp3_ = _tmp2_;
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_load_module (self, _tmp3_);
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (_tmp3_);
#line 235 "PluginManager.c"
	}
}


static void ____lambda31__g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	___lambda31_ ((GalaPluginManager*) self, file, other_file, event_type);
#line 243 "PluginManager.c"
}


static GalaPluginManager* gala_plugin_manager_construct (GType object_type) {
	GalaPluginManager * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GeeLinkedList* _tmp3_;
	gboolean _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	gboolean _tmp7_;
	GError * _inner_error_ = NULL;
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self = (GalaPluginManager*) g_object_new (object_type, NULL);
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = g_str_hash;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = g_str_equal;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_hash_table_unref0 (self->priv->plugins);
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->plugins = _tmp2_;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp3_ = gee_linked_list_new (GALA_TYPE_PLUGIN_INFO, (GBoxedCopyFunc) _gala_plugin_info_dup, (GDestroyNotify) _vala_GalaPluginInfo_free, NULL, NULL, NULL);
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_object_unref0 (self->priv->load_later_plugins);
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->load_later_plugins = _tmp3_;
#line 56 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp4_ = g_module_supported ();
#line 56 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (!_tmp4_) {
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_warning ("PluginManager.vala:57: Modules are not supported on this platform");
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		return self;
#line 284 "PluginManager.c"
	}
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp5_ = g_file_new_for_path (PLUGINDIR);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_object_unref0 (self->priv->plugin_dir);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->plugin_dir = _tmp5_;
#line 62 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp6_ = self->priv->plugin_dir;
#line 62 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp7_ = g_file_query_exists (_tmp6_, NULL);
#line 62 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (!_tmp7_) {
#line 63 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		return self;
#line 300 "PluginManager.c"
	}
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp8_;
		GFileEnumerator* _tmp9_;
		GFileInfo* info = NULL;
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp8_ = self->priv->plugin_dir;
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp9_ = g_file_enumerate_children (_tmp8_, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error_);
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		enumerator = _tmp9_;
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 315 "PluginManager.c"
			goto __catch10_g_error;
		}
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		while (TRUE) {
#line 320 "PluginManager.c"
			GFileInfo* _tmp10_ = NULL;
			GFileEnumerator* _tmp11_;
			GFileInfo* _tmp12_;
			GFileInfo* _tmp13_;
			GFileInfo* _tmp14_;
			GFileInfo* _tmp15_;
			const gchar* _tmp16_;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp11_ = enumerator;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp12_ = g_file_enumerator_next_file (_tmp11_, NULL, &_inner_error_);
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp10_ = _tmp12_;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_g_object_unref0 (info);
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_g_object_unref0 (enumerator);
#line 340 "PluginManager.c"
				goto __catch10_g_error;
			}
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp13_ = _tmp10_;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp10_ = NULL;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_g_object_unref0 (info);
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			info = _tmp13_;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp14_ = info;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			if (!(_tmp14_ != NULL)) {
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_g_object_unref0 (_tmp10_);
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				break;
#line 359 "PluginManager.c"
			}
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp15_ = info;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp16_ = g_file_info_get_content_type (_tmp15_);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			if (g_strcmp0 (_tmp16_, "application/x-sharedlib") == 0) {
#line 367 "PluginManager.c"
				GFileInfo* _tmp17_;
				const gchar* _tmp18_;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp17_ = info;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp18_ = g_file_info_get_name (_tmp17_);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				gala_plugin_manager_load_module (self, _tmp18_);
#line 376 "PluginManager.c"
			}
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_g_object_unref0 (_tmp10_);
#line 380 "PluginManager.c"
		}
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_object_unref0 (info);
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_object_unref0 (enumerator);
#line 386 "PluginManager.c"
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		e = _inner_error_;
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp19_ = e;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp20_ = _tmp19_->message;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_warning ("PluginManager.vala:74: %s", _tmp20_);
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_error_free0 (e);
#line 406 "PluginManager.c"
	}
	__finally10:
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_clear_error (&_inner_error_);
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		return NULL;
#line 417 "PluginManager.c"
	}
	{
		GFileMonitor* _tmp21_ = NULL;
		GFile* _tmp22_;
		GFileMonitor* _tmp23_;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp22_ = self->priv->plugin_dir;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp23_ = g_file_monitor_directory (_tmp22_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp21_ = _tmp23_;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 431 "PluginManager.c"
			goto __catch11_g_error;
		}
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_signal_connect_object (_tmp21_, "changed", (GCallback) ____lambda31__g_file_monitor_changed, self, 0);
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_object_unref0 (_tmp21_);
#line 438 "PluginManager.c"
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		e = _inner_error_;
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_inner_error_ = NULL;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp24_ = e;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp25_ = _tmp24_->message;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_warning ("PluginManager.vala:84: %s", _tmp25_);
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_error_free0 (e);
#line 458 "PluginManager.c"
	}
	__finally11:
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_clear_error (&_inner_error_);
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		return NULL;
#line 469 "PluginManager.c"
	}
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return self;
#line 473 "PluginManager.c"
}


static GalaPluginManager* gala_plugin_manager_new (void) {
#line 51 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return gala_plugin_manager_construct (GALA_TYPE_PLUGIN_MANAGER);
#line 480 "PluginManager.c"
}


static gboolean gala_plugin_manager_load_module (GalaPluginManager* self, const gchar* plugin_name) {
	gboolean result = FALSE;
	gchar* path = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GModule* module = NULL;
	const gchar* _tmp6_;
	GModule* _tmp7_;
	GModule* _tmp8_;
	void* function = NULL;
	GModule* _tmp10_;
	void* _tmp11_ = NULL;
	void* _tmp12_;
	GalaRegisterPluginFunction _register_ = NULL;
	void* _tmp14_;
	void* _register__target;
	GalaPluginInfo info = {0};
	GalaRegisterPluginFunction _tmp15_;
	void* _tmp15__target;
	GalaPluginInfo _tmp16_ = {0};
	GalaPluginInfo _tmp17_;
	GType _tmp18_;
	gboolean _tmp19_;
	GalaPluginInfo _tmp21_;
	const gchar* _tmp22_;
	GalaPluginInfo _tmp23_;
	GalaPluginFunction _tmp24_;
	gboolean _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	GModule* _tmp28_;
	gboolean _tmp29_ = FALSE;
	GalaPluginInfo _tmp30_;
	GalaLoadPriority _tmp31_;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (plugin_name != NULL, FALSE);
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = self->priv->plugin_dir;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2_ = _tmp1_;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp3_ = plugin_name;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp4_ = g_module_build_path (_tmp2_, _tmp3_);
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp5_ = _tmp4_;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_free0 (_tmp2_);
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	path = _tmp5_;
#line 91 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp6_ = path;
#line 91 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp7_ = g_module_open (_tmp6_, G_MODULE_BIND_LOCAL);
#line 91 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	module = _tmp7_;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp8_ = module;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (_tmp8_ == NULL) {
#line 552 "PluginManager.c"
		const gchar* _tmp9_;
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp9_ = g_module_error ();
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_warning ("PluginManager.vala:93: %s", _tmp9_);
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		result = FALSE;
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_module_close0 (module);
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (path);
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		return result;
#line 566 "PluginManager.c"
	}
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp10_ = module;
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_module_symbol (_tmp10_, "register_plugin", &_tmp11_);
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	function = _tmp11_;
#line 99 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp12_ = function;
#line 99 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (_tmp12_ == NULL) {
#line 578 "PluginManager.c"
		const gchar* _tmp13_;
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp13_ = plugin_name;
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_warning ("PluginManager.vala:100: %s failed to register: register_plugin() funct" \
"ion not found", _tmp13_);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		result = FALSE;
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_module_close0 (module);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (path);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		return result;
#line 592 "PluginManager.c"
	}
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp14_ = function;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_register_ = (GalaRegisterPluginFunction) _tmp14_;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_register__target = NULL;
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp15_ = _register_;
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp15__target = _register__target;
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp15_ (&_tmp16_, _tmp15__target);
#line 105 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	info = _tmp16_;
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp17_ = info;
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp18_ = _tmp17_.plugin_type;
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp19_ = g_type_is_a (_tmp18_, GALA_TYPE_PLUGIN);
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (_tmp19_ == FALSE) {
#line 616 "PluginManager.c"
		const gchar* _tmp20_;
#line 107 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp20_ = plugin_name;
#line 107 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_warning ("PluginManager.vala:107: %s does not return a class of type Plugin", _tmp20_);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		result = FALSE;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_info_destroy (&info);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_module_close0 (module);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (path);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		return result;
#line 632 "PluginManager.c"
	}
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp21_ = info;
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp22_ = _tmp21_.name;
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp23_ = info;
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp24_ = _tmp23_.provides;
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp25_ = gala_plugin_manager_check_provides (self, _tmp22_, _tmp24_);
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (!_tmp25_) {
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		result = FALSE;
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_info_destroy (&info);
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_module_close0 (module);
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (path);
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		return result;
#line 656 "PluginManager.c"
	}
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp26_ = plugin_name;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp27_ = g_strdup (_tmp26_);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_free0 (info.module_name);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	info.module_name = _tmp27_;
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp28_ = module;
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_module_make_resident (_tmp28_);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp30_ = info;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp31_ = _tmp30_.load_priority;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (_tmp31_ == GALA_LOAD_PRIORITY_DEFERRED) {
#line 676 "PluginManager.c"
		gboolean _tmp32_;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp32_ = self->priv->_initialized;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp29_ = !_tmp32_;
#line 682 "PluginManager.c"
	} else {
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp29_ = FALSE;
#line 686 "PluginManager.c"
	}
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (_tmp29_) {
#line 690 "PluginManager.c"
		GeeLinkedList* _tmp33_;
		GalaPluginInfo _tmp34_;
#line 119 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp33_ = self->priv->load_later_plugins;
#line 119 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp34_ = info;
#line 119 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp33_, &_tmp34_);
#line 699 "PluginManager.c"
	} else {
		GalaPluginInfo _tmp35_;
#line 121 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp35_ = info;
#line 121 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_load_plugin_class (self, &_tmp35_);
#line 706 "PluginManager.c"
	}
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = TRUE;
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_info_destroy (&info);
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_module_close0 (module);
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_free0 (path);
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 718 "PluginManager.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 725 "PluginManager.c"
}


static void gala_plugin_manager_load_plugin_class (GalaPluginManager* self, GalaPluginInfo* info) {
	GalaPlugin* plugin = NULL;
	GalaPluginInfo _tmp0_;
	GType _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_;
	GHashTable* _tmp4_;
	GalaPluginInfo _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GalaPlugin* _tmp8_;
	GalaPlugin* _tmp9_;
	GalaPluginInfo _tmp10_;
	const gchar* _tmp11_;
	GalaPluginInfo _tmp12_;
	const gchar* _tmp13_;
	gboolean _tmp14_;
#line 127 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 127 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (info != NULL);
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = *info;
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = _tmp0_.plugin_type;
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2_ = g_object_new (_tmp1_, NULL);
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp3_ = G_IS_INITIALLY_UNOWNED (_tmp2_) ? g_object_ref_sink (_tmp2_) : _tmp2_;
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	plugin = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GALA_TYPE_PLUGIN, GalaPlugin);
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp4_ = self->priv->plugins;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp5_ = *info;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp6_ = _tmp5_.module_name;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp8_ = plugin;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_hash_table_insert (_tmp4_, _tmp7_, _tmp9_);
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp10_ = *info;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp11_ = _tmp10_.name;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp12_ = *info;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp13_ = _tmp12_.module_name;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_debug ("PluginManager.vala:132: Loaded plugin %s (%s)", _tmp11_, _tmp13_);
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp14_ = self->priv->_initialized;
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (_tmp14_) {
#line 788 "PluginManager.c"
		GalaPluginInfo _tmp15_;
		const gchar* _tmp16_;
		GalaPlugin* _tmp17_;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp15_ = *info;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp16_ = _tmp15_.module_name;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp17_ = plugin;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_initialize_plugin (self, _tmp16_, _tmp17_);
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_recalculate_regions (self);
#line 802 "PluginManager.c"
	}
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_object_unref0 (plugin);
#line 806 "PluginManager.c"
}


static void _gala_plugin_manager_recalculate_regions_gala_plugin_region_changed (GalaPlugin* _sender, gpointer self) {
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_manager_recalculate_regions ((GalaPluginManager*) self);
#line 813 "PluginManager.c"
}


static void gala_plugin_manager_initialize_plugin (GalaPluginManager* self, const gchar* plugin_name, GalaPlugin* plugin) {
	GalaPlugin* _tmp0_;
	GalaWindowManager* _tmp1_;
	GalaPlugin* _tmp2_;
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (plugin_name != NULL);
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (plugin != NULL);
#line 142 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = plugin;
#line 142 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = self->priv->wm;
#line 142 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_initialize (_tmp0_, _tmp1_);
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2_ = plugin;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_signal_connect_object (_tmp2_, "region-changed", (GCallback) _gala_plugin_manager_recalculate_regions_gala_plugin_region_changed, self, 0);
#line 837 "PluginManager.c"
}


static gboolean gala_plugin_manager_check_provides (GalaPluginManager* self, const gchar* name, GalaPluginFunction provides) {
	gboolean result = FALSE;
	gchar* message = NULL;
	gchar* _tmp0_;
	GalaPluginFunction _tmp1_;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = g_strdup ("Plugins %s and %s both provide %s functionality, using first one only");
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	message = _tmp0_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = provides;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	switch (_tmp1_) {
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_WORKSPACE_VIEW:
#line 860 "PluginManager.c"
		{
			const gchar* _tmp2_;
			const gchar* _tmp6_;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp2_ = self->priv->_workspace_view_provider;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			if (_tmp2_ != NULL) {
#line 868 "PluginManager.c"
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				const gchar* _tmp5_;
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp3_ = message;
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp4_ = self->priv->_workspace_view_provider;
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp5_ = name;
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				g_warning (_tmp3_, _tmp4_, _tmp5_, "workspace view");
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				result = FALSE;
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_g_free0 (message);
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				return result;
#line 886 "PluginManager.c"
			}
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp6_ = name;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			gala_plugin_manager_set_workspace_view_provider (self, _tmp6_);
#line 156 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			result = TRUE;
#line 156 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_g_free0 (message);
#line 156 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			return result;
#line 898 "PluginManager.c"
		}
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_WINDOW_OVERVIEW:
#line 902 "PluginManager.c"
		{
			const gchar* _tmp7_;
			const gchar* _tmp11_;
#line 158 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp7_ = self->priv->_window_overview_provider;
#line 158 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			if (_tmp7_ != NULL) {
#line 910 "PluginManager.c"
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp8_ = message;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp9_ = self->priv->_window_overview_provider;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp10_ = name;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				g_warning (_tmp8_, _tmp9_, _tmp10_, "window overview");
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				result = FALSE;
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_g_free0 (message);
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				return result;
#line 928 "PluginManager.c"
			}
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp11_ = name;
#line 162 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			gala_plugin_manager_set_window_overview_provider (self, _tmp11_);
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			result = TRUE;
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_g_free0 (message);
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			return result;
#line 940 "PluginManager.c"
		}
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_DESKTOP:
#line 944 "PluginManager.c"
		{
			const gchar* _tmp12_;
			const gchar* _tmp16_;
#line 165 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp12_ = self->priv->_desktop_provider;
#line 165 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			if (_tmp12_ != NULL) {
#line 952 "PluginManager.c"
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 166 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp13_ = message;
#line 166 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp14_ = self->priv->_desktop_provider;
#line 166 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp15_ = name;
#line 166 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				g_warning (_tmp13_, _tmp14_, _tmp15_, "desktop");
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				result = FALSE;
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_g_free0 (message);
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				return result;
#line 970 "PluginManager.c"
			}
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp16_ = name;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			gala_plugin_manager_set_desktop_provider (self, _tmp16_);
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			result = TRUE;
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_g_free0 (message);
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			return result;
#line 982 "PluginManager.c"
		}
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_FUNCTION_WINDOW_SWITCHER:
#line 986 "PluginManager.c"
		{
			const gchar* _tmp17_;
			const gchar* _tmp21_;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp17_ = self->priv->_window_switcher_provider;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			if (_tmp17_ != NULL) {
#line 994 "PluginManager.c"
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp18_ = message;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp19_ = self->priv->_window_switcher_provider;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp20_ = name;
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				g_warning (_tmp18_, _tmp19_, _tmp20_, "window switcher");
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				result = FALSE;
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_g_free0 (message);
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				return result;
#line 1012 "PluginManager.c"
			}
#line 176 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp21_ = name;
#line 176 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			gala_plugin_manager_set_window_switcher_provider (self, _tmp21_);
#line 177 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			result = TRUE;
#line 177 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_g_free0 (message);
#line 177 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			return result;
#line 1024 "PluginManager.c"
		}
		default:
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 1029 "PluginManager.c"
	}
#line 180 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = TRUE;
#line 180 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_free0 (message);
#line 180 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 1037 "PluginManager.c"
}


static void _gala_plugin_manager_initialize_plugin_gh_func (gconstpointer key, gconstpointer value, gpointer self) {
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_manager_initialize_plugin ((GalaPluginManager*) self, (const gchar*) key, (GalaPlugin*) value);
#line 1044 "PluginManager.c"
}


void gala_plugin_manager_initialize (GalaPluginManager* self, GalaWindowManager* _wm) {
	GalaWindowManager* _tmp0_;
	GalaWindowManager* _tmp1_;
	GHashTable* _tmp2_;
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (_wm != NULL);
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = _wm;
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_object_unref0 (self->priv->wm);
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->wm = _tmp1_;
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2_ = self->priv->plugins;
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_hash_table_foreach (_tmp2_, _gala_plugin_manager_initialize_plugin_gh_func, self);
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_manager_recalculate_regions (self);
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_manager_set_initialized (self, TRUE);
#line 1072 "PluginManager.c"
}


void gala_plugin_manager_load_waiting_plugins (GalaPluginManager* self) {
	GeeLinkedList* _tmp13_;
#line 193 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 1080 "PluginManager.c"
	{
		GeeLinkedList* _info_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _info_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _info_index = 0;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp0_ = self->priv->load_later_plugins;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_info_list = _tmp1_;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp2_ = _info_list;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp4_ = _tmp3_;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_info_size = _tmp4_;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_info_index = -1;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		while (TRUE) {
#line 1108 "PluginManager.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GalaPluginInfo* info = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			GalaPluginInfo* _tmp11_;
			GalaPluginInfo _tmp12_;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp5_ = _info_index;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_info_index = _tmp5_ + 1;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp6_ = _info_index;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp7_ = _info_size;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				break;
#line 1130 "PluginManager.c"
			}
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp8_ = _info_list;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp9_ = _info_index;
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			info = (GalaPluginInfo*) _tmp10_;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp11_ = info;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			_tmp12_ = *_tmp11_;
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			gala_plugin_manager_load_plugin_class (self, &_tmp12_);
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			__vala_GalaPluginInfo_free0 (info);
#line 1148 "PluginManager.c"
		}
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_object_unref0 (_info_list);
#line 1152 "PluginManager.c"
	}
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp13_ = self->priv->load_later_plugins;
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp13_);
#line 1158 "PluginManager.c"
}


GalaPlugin* gala_plugin_manager_get_plugin (GalaPluginManager* self, const gchar* id) {
	GalaPlugin* result = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	gconstpointer _tmp2_;
	GalaPlugin* _tmp3_;
#line 202 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 202 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = self->priv->plugins;
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = id;
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2_ = g_hash_table_lookup (_tmp0_, _tmp1_);
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp3_ = _g_object_ref0 ((GalaPlugin*) _tmp2_);
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = _tmp3_;
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 1184 "PluginManager.c"
}


/**
 * Iterate over all plugins and grab their regions, update the regions
 * array accordingly and emit the regions_changed signal.
 */
static Block3Data* block3_data_ref (Block3Data* _data3_) {
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return _data3_;
#line 1197 "PluginManager.c"
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1206 "PluginManager.c"
		GalaPluginManager* self;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		self = _data3_->self;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_data3_->regions = (g_free (_data3_->regions), NULL);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_object_unref0 (self);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_slice_free (Block3Data, _data3_);
#line 1216 "PluginManager.c"
	}
}


static void _vala_array_add3 (XRectangle* * array, int* length, int* size, XRectangle value) {
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if ((*length) == (*size)) {
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		*array = g_renew (XRectangle, *array, *size);
#line 1228 "PluginManager.c"
	}
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	(*array)[(*length)++] = value;
#line 1232 "PluginManager.c"
}


static void __lambda30_ (Block3Data* _data3_, const gchar* name, GalaPlugin* plugin) {
	GalaPluginManager* self;
	GalaPlugin* _tmp0_;
	MetaRectangle* _tmp1_;
	gint _tmp1__length1;
	MetaRectangle* _tmp2_;
	gint _tmp2__length1;
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self = _data3_->self;
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (name != NULL);
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (plugin != NULL);
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = plugin;
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = gala_plugin_get_region (_tmp0_, &_tmp1__length1);
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2_ = _tmp1_;
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp2__length1 = _tmp1__length1;
#line 1257 "PluginManager.c"
	{
		MetaRectangle* region_collection = NULL;
		gint region_collection_length1 = 0;
		gint _region_collection_size_ = 0;
		gint region_it = 0;
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		region_collection = _tmp2_;
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		region_collection_length1 = _tmp2__length1;
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		for (region_it = 0; region_it < _tmp2__length1; region_it = region_it + 1) {
#line 1269 "PluginManager.c"
			MetaRectangle region = {0};
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
			region = region_collection[region_it];
#line 1273 "PluginManager.c"
			{
				XRectangle rect = {0};
				MetaRectangle _tmp3_;
				gint _tmp4_;
				MetaRectangle _tmp5_;
				gint _tmp6_;
				MetaRectangle _tmp7_;
				gint _tmp8_;
				MetaRectangle _tmp9_;
				gint _tmp10_;
				XRectangle _tmp11_ = {0};
				XRectangle _tmp12_;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp3_ = region;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp4_ = _tmp3_.x;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp5_ = region;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp6_ = _tmp5_.y;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp7_ = region;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp8_ = _tmp7_.width;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp9_ = region;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp10_ = _tmp9_.height;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp11_.x = (gshort) _tmp4_;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp11_.y = (gshort) _tmp6_;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp11_.width = (gushort) _tmp8_;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp11_.height = (gushort) _tmp10_;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				rect = _tmp11_;
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_tmp12_ = rect;
#line 224 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
				_vala_array_add3 (&_data3_->regions, &_data3_->regions_length1, &_data3_->_regions_size_, _tmp12_);
#line 1316 "PluginManager.c"
			}
		}
	}
}


static void ___lambda30__gh_func (gconstpointer key, gconstpointer value, gpointer self) {
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	__lambda30_ (self, (const gchar*) key, (GalaPlugin*) value);
#line 1326 "PluginManager.c"
}


static void gala_plugin_manager_recalculate_regions (GalaPluginManager* self) {
	Block3Data* _data3_;
	XRectangle* _tmp0_;
	GHashTable* _tmp1_;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_data3_->_ref_count_ = 1;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_data3_->self = g_object_ref (self);
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = g_new0 (XRectangle, 0);
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_data3_->regions = _tmp0_;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_data3_->regions_length1 = 0;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_data3_->_regions_size_ = _data3_->regions_length1;
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = self->priv->plugins;
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_hash_table_foreach (_tmp1_, ___lambda30__gh_func, _data3_);
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_manager_set_regions (self, _data3_->regions, _data3_->regions_length1);
#line 229 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_signal_emit (self, gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL], 0);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	block3_data_unref (_data3_);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_data3_ = NULL;
#line 1362 "PluginManager.c"
}


gboolean gala_plugin_manager_get_initialized (GalaPluginManager* self) {
	gboolean result;
	gboolean _tmp0_;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = self->priv->_initialized;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 1377 "PluginManager.c"
}


static void gala_plugin_manager_set_initialized (GalaPluginManager* self, gboolean value) {
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (gala_plugin_manager_get_initialized (self) != value) {
#line 1386 "PluginManager.c"
		gboolean _tmp0_;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp0_ = value;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		self->priv->_initialized = _tmp0_;
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_INITIALIZED]);
#line 1394 "PluginManager.c"
	}
}


XRectangle* gala_plugin_manager_get_regions (GalaPluginManager* self, int* result_length1) {
	XRectangle* result;
	XRectangle* _tmp0_;
	gint _tmp0__length1;
	XRectangle* _tmp1_;
	gint _tmp1__length1;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = self->priv->_regions;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0__length1 = self->priv->_regions_length1;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = _tmp0_;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1__length1 = _tmp0__length1;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (result_length1) {
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		*result_length1 = _tmp1__length1;
#line 1419 "PluginManager.c"
	}
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = _tmp1_;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 1425 "PluginManager.c"
}


static XRectangle* _vala_array_dup1 (XRectangle* self, int length) {
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return g_memdup (self, length * sizeof (XRectangle));
#line 1432 "PluginManager.c"
}


static void gala_plugin_manager_set_regions (GalaPluginManager* self, XRectangle* value, int value_length1) {
	XRectangle* _tmp0_;
	gint _tmp0__length1;
	XRectangle* _tmp1_;
	gint _tmp1__length1;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0__length1 = value_length1;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp1__length1 = _tmp0__length1;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_regions = (g_free (self->priv->_regions), NULL);
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_regions = _tmp1_;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_regions_length1 = _tmp1__length1;
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->__regions_size_ = self->priv->_regions_length1;
#line 1459 "PluginManager.c"
}


const gchar* gala_plugin_manager_get_window_switcher_provider (GalaPluginManager* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = self->priv->_window_switcher_provider;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = _tmp0_;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 1474 "PluginManager.c"
}


static void gala_plugin_manager_set_window_switcher_provider (GalaPluginManager* self, const gchar* value) {
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (g_strcmp0 (value, gala_plugin_manager_get_window_switcher_provider (self)) != 0) {
#line 1483 "PluginManager.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp0_ = value;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (self->priv->_window_switcher_provider);
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		self->priv->_window_switcher_provider = _tmp1_;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER]);
#line 1496 "PluginManager.c"
	}
}


const gchar* gala_plugin_manager_get_desktop_provider (GalaPluginManager* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = self->priv->_desktop_provider;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = _tmp0_;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 1512 "PluginManager.c"
}


static void gala_plugin_manager_set_desktop_provider (GalaPluginManager* self, const gchar* value) {
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (g_strcmp0 (value, gala_plugin_manager_get_desktop_provider (self)) != 0) {
#line 1521 "PluginManager.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp0_ = value;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (self->priv->_desktop_provider);
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		self->priv->_desktop_provider = _tmp1_;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER]);
#line 1534 "PluginManager.c"
	}
}


const gchar* gala_plugin_manager_get_window_overview_provider (GalaPluginManager* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = self->priv->_window_overview_provider;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = _tmp0_;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 1550 "PluginManager.c"
}


static void gala_plugin_manager_set_window_overview_provider (GalaPluginManager* self, const gchar* value) {
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (g_strcmp0 (value, gala_plugin_manager_get_window_overview_provider (self)) != 0) {
#line 1559 "PluginManager.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp0_ = value;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (self->priv->_window_overview_provider);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		self->priv->_window_overview_provider = _tmp1_;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER]);
#line 1572 "PluginManager.c"
	}
}


const gchar* gala_plugin_manager_get_workspace_view_provider (GalaPluginManager* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_tmp0_ = self->priv->_workspace_view_provider;
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	result = _tmp0_;
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	return result;
#line 1588 "PluginManager.c"
}


static void gala_plugin_manager_set_workspace_view_provider (GalaPluginManager* self, const gchar* value) {
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_return_if_fail (self != NULL);
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	if (g_strcmp0 (value, gala_plugin_manager_get_workspace_view_provider (self)) != 0) {
#line 1597 "PluginManager.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp0_ = value;
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		_g_free0 (self->priv->_workspace_view_provider);
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		self->priv->_workspace_view_provider = _tmp1_;
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER]);
#line 1610 "PluginManager.c"
	}
}


static void gala_plugin_manager_class_init (GalaPluginManagerClass * klass) {
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_type_class_add_private (klass, sizeof (GalaPluginManagerPrivate));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_plugin_manager_get_property;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_plugin_manager_set_property;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_plugin_manager_finalize;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_INITIALIZED, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_INITIALIZED] = g_param_spec_boolean ("initialized", "initialized", "initialized", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER] = g_param_spec_string ("window-switcher-provider", "window-switcher-provider", "window-switcher-provider", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER] = g_param_spec_string ("desktop-provider", "desktop-provider", "desktop-provider", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER] = g_param_spec_string ("window-overview-provider", "window-overview-provider", "window-overview-provider", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER, gala_plugin_manager_properties[GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER] = g_param_spec_string ("workspace-view-provider", "workspace-view-provider", "workspace-view-provider", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	gala_plugin_manager_signals[GALA_PLUGIN_MANAGER_REGIONS_CHANGED_SIGNAL] = g_signal_new ("regions-changed", GALA_TYPE_PLUGIN_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1638 "PluginManager.c"
}


static void gala_plugin_manager_instance_init (GalaPluginManager * self) {
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv = GALA_PLUGIN_MANAGER_GET_PRIVATE (self);
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_initialized = FALSE;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_window_switcher_provider = NULL;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_desktop_provider = NULL;
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_window_overview_provider = NULL;
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_workspace_view_provider = NULL;
#line 47 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->wm = NULL;
#line 1657 "PluginManager.c"
}


static void gala_plugin_manager_finalize (GObject * obj) {
	GalaPluginManager * self;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	self->priv->_regions = (g_free (self->priv->_regions), NULL);
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_free0 (self->priv->_window_switcher_provider);
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_free0 (self->priv->_desktop_provider);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_free0 (self->priv->_window_overview_provider);
#line 42 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_free0 (self->priv->_workspace_view_provider);
#line 44 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_hash_table_unref0 (self->priv->plugins);
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_object_unref0 (self->priv->plugin_dir);
#line 47 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_object_unref0 (self->priv->wm);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	_g_object_unref0 (self->priv->load_later_plugins);
#line 127 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	G_OBJECT_CLASS (gala_plugin_manager_parent_class)->finalize (obj);
#line 1685 "PluginManager.c"
}


GType gala_plugin_manager_get_type (void) {
	static volatile gsize gala_plugin_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gala_plugin_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaPluginManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_plugin_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPluginManager), 0, (GInstanceInitFunc) gala_plugin_manager_instance_init, NULL };
		GType gala_plugin_manager_type_id;
		gala_plugin_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaPluginManager", &g_define_type_info, 0);
		g_once_init_leave (&gala_plugin_manager_type_id__volatile, gala_plugin_manager_type_id);
	}
	return gala_plugin_manager_type_id__volatile;
}


static void _vala_gala_plugin_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaPluginManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	switch (property_id) {
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_INITIALIZED:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_value_set_boolean (value, gala_plugin_manager_get_initialized (self));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_window_switcher_provider (self));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_desktop_provider (self));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_window_overview_provider (self));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		g_value_set_string (value, gala_plugin_manager_get_workspace_view_provider (self));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 1736 "PluginManager.c"
		default:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 1742 "PluginManager.c"
	}
}


static void _vala_gala_plugin_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaPluginManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
	switch (property_id) {
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_INITIALIZED:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_set_initialized (self, g_value_get_boolean (value));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_SWITCHER_PROVIDER:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_set_window_switcher_provider (self, g_value_get_string (value));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_DESKTOP_PROVIDER:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_set_desktop_provider (self, g_value_get_string (value));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WINDOW_OVERVIEW_PROVIDER:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_set_window_overview_provider (self, g_value_get_string (value));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		case GALA_PLUGIN_MANAGER_WORKSPACE_VIEW_PROVIDER:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		gala_plugin_manager_set_workspace_view_provider (self, g_value_get_string (value));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 1782 "PluginManager.c"
		default:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/PluginManager.vala"
		break;
#line 1788 "PluginManager.c"
	}
}



