/* WindowListener.c generated by valac 0.37.91, the Vala compiler
 * generated from WindowListener.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <meta/boxes.h>
#include <string.h>
#include <gee.h>
#include <meta/window.h>
#include <meta/screen.h>
#include <meta/compositor-mutter.h>
#include <meta/meta-window-actor.h>
#include <meta/display.h>


#define GALA_TYPE_WINDOW_GEOMETRY (gala_window_geometry_get_type ())
typedef struct _GalaWindowGeometry GalaWindowGeometry;

#define GALA_TYPE_WINDOW_LISTENER (gala_window_listener_get_type ())
#define GALA_WINDOW_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_LISTENER, GalaWindowListener))
#define GALA_WINDOW_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerClass))
#define GALA_IS_WINDOW_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_LISTENER))
#define GALA_IS_WINDOW_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_LISTENER))
#define GALA_WINDOW_LISTENER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerClass))

typedef struct _GalaWindowListener GalaWindowListener;
typedef struct _GalaWindowListenerClass GalaWindowListenerClass;
typedef struct _GalaWindowListenerPrivate GalaWindowListenerPrivate;
enum  {
	GALA_WINDOW_LISTENER_DUMMY_PROPERTY,
	GALA_WINDOW_LISTENER_LAST_PROPERTY
};
static GParamSpec* gala_window_listener_properties[GALA_WINDOW_LISTENER_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GALA_WINDOW_LISTENER_WINDOW_NO_LONGER_ON_ALL_WORKSPACES_SIGNAL,
	GALA_WINDOW_LISTENER_LAST_SIGNAL
};
static guint gala_window_listener_signals[GALA_WINDOW_LISTENER_LAST_SIGNAL] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWindowGeometry {
	MetaRectangle inner;
	MetaRectangle outer;
};

struct _GalaWindowListener {
	GObject parent_instance;
	GalaWindowListenerPrivate * priv;
};

struct _GalaWindowListenerClass {
	GObjectClass parent_class;
};

struct _GalaWindowListenerPrivate {
	GeeHashMap* unmaximized_state_geometry;
};


static gpointer gala_window_listener_parent_class = NULL;
static GalaWindowListener* gala_window_listener_instance;
static GalaWindowListener* gala_window_listener_instance = NULL;

GType gala_window_geometry_get_type (void) G_GNUC_CONST;
GalaWindowGeometry* gala_window_geometry_dup (const GalaWindowGeometry* self);
void gala_window_geometry_free (GalaWindowGeometry* self);
GType gala_window_listener_get_type (void) G_GNUC_CONST;
#define GALA_WINDOW_LISTENER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerPrivate))
void gala_window_listener_init (MetaScreen* screen);
static GalaWindowListener* gala_window_listener_new (void);
static GalaWindowListener* gala_window_listener_construct (GType object_type);
static void gala_window_listener_monitor_window (GalaWindowListener* self, MetaWindow* window);
static void __lambda45_ (MetaWindow* window);
static void ___lambda45__meta_display_window_created (MetaDisplay* _sender, MetaWindow* object, gpointer self);
GalaWindowListener* gala_window_listener_get_default (void);
static void gala_window_listener_window_notify (GalaWindowListener* self, GObject* object, GParamSpec* pspec);
static void _gala_window_listener_window_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void gala_window_listener_window_removed (GalaWindowListener* self, MetaWindow* window);
static void _gala_window_listener_window_removed_meta_window_unmanaged (MetaWindow* _sender, gpointer self);
static void gala_window_listener_window_maximized_changed (GalaWindowListener* self, MetaWindow* window);
static void gala_window_listener_window_on_all_workspaces_changed (GalaWindowListener* self, MetaWindow* window);
GalaWindowGeometry* gala_window_listener_get_unmaximized_state_geometry (GalaWindowListener* self, MetaWindow* window);
static void gala_window_listener_finalize (GObject * obj);


GalaWindowGeometry* gala_window_geometry_dup (const GalaWindowGeometry* self) {
	GalaWindowGeometry* dup;
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	dup = g_new0 (GalaWindowGeometry, 1);
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	memcpy (dup, self, sizeof (GalaWindowGeometry));
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	return dup;
#line 116 "WindowListener.c"
}


void gala_window_geometry_free (GalaWindowGeometry* self) {
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_free (self);
#line 123 "WindowListener.c"
}


GType gala_window_geometry_get_type (void) {
	static volatile gsize gala_window_geometry_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_geometry_type_id__volatile)) {
		GType gala_window_geometry_type_id;
		gala_window_geometry_type_id = g_boxed_type_register_static ("GalaWindowGeometry", (GBoxedCopyFunc) gala_window_geometry_dup, (GBoxedFreeFunc) gala_window_geometry_free);
		g_once_init_leave (&gala_window_geometry_type_id__volatile, gala_window_geometry_type_id);
	}
	return gala_window_geometry_type_id__volatile;
}


static void __lambda45_ (MetaWindow* window) {
	MetaWindow* _tmp0_;
	MetaWindowType _tmp1_;
	MetaWindowType _tmp2_;
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (window != NULL);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = window;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp1_ = meta_window_get_window_type (_tmp0_);
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp2_ = _tmp1_;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	if (_tmp2_ == META_WINDOW_NORMAL) {
#line 152 "WindowListener.c"
		GalaWindowListener* _tmp3_;
		MetaWindow* _tmp4_;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		_tmp3_ = gala_window_listener_instance;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		_tmp4_ = window;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		gala_window_listener_monitor_window (_tmp3_, _tmp4_);
#line 161 "WindowListener.c"
	}
}


static void ___lambda45__meta_display_window_created (MetaDisplay* _sender, MetaWindow* object, gpointer self) {
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	__lambda45_ (object);
#line 169 "WindowListener.c"
}


void gala_window_listener_init (MetaScreen* screen) {
	GalaWindowListener* _tmp0_;
	GalaWindowListener* _tmp1_;
	MetaScreen* _tmp2_;
	GList* _tmp3_;
	MetaScreen* _tmp13_;
	MetaDisplay* _tmp14_;
#line 32 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (screen != NULL);
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = gala_window_listener_instance;
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	if (_tmp0_ != NULL) {
#line 35 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		return;
#line 188 "WindowListener.c"
	}
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp1_ = gala_window_listener_new ();
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_g_object_unref0 (gala_window_listener_instance);
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	gala_window_listener_instance = _tmp1_;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp2_ = screen;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp3_ = meta_get_window_actors (_tmp2_);
#line 200 "WindowListener.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		actor_collection = _tmp3_;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 208 "WindowListener.c"
			MetaWindowActor* actor = NULL;
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
			actor = (MetaWindowActor*) actor_it->data;
#line 212 "WindowListener.c"
			{
				MetaWindowActor* _tmp4_;
				gboolean _tmp5_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp6_;
				MetaWindow* _tmp7_;
				MetaWindow* _tmp8_;
				MetaWindowType _tmp9_;
				MetaWindowType _tmp10_;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp4_ = actor;
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp5_ = meta_window_actor_is_destroyed (_tmp4_);
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				if (_tmp5_) {
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
					continue;
#line 230 "WindowListener.c"
				}
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp6_ = actor;
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp7_ = meta_window_actor_get_meta_window (_tmp6_);
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				window = _tmp7_;
#line 44 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp8_ = window;
#line 44 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp9_ = meta_window_get_window_type (_tmp8_);
#line 44 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp10_ = _tmp9_;
#line 44 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				if (_tmp10_ == META_WINDOW_NORMAL) {
#line 246 "WindowListener.c"
					GalaWindowListener* _tmp11_;
					MetaWindow* _tmp12_;
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
					_tmp11_ = gala_window_listener_instance;
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
					_tmp12_ = window;
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
					gala_window_listener_monitor_window (_tmp11_, _tmp12_);
#line 255 "WindowListener.c"
				}
			}
		}
	}
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp13_ = screen;
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp14_ = meta_screen_get_display (_tmp13_);
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_signal_connect (_tmp14_, "window-created", (GCallback) ___lambda45__meta_display_window_created, NULL);
#line 266 "WindowListener.c"
}


GalaWindowListener* gala_window_listener_get_default (void) {
	GalaWindowListener* result = NULL;
	GalaWindowListener* _tmp0_;
	GalaWindowListener* _tmp1_;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = gala_window_listener_instance;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp1_ = gala_window_listener_instance;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	result = _tmp1_;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	return result;
#line 284 "WindowListener.c"
}


static GalaWindowListener* gala_window_listener_construct (GType object_type) {
	GalaWindowListener * self = NULL;
	GeeHashMap* _tmp0_;
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	self = (GalaWindowListener*) g_object_new (object_type, NULL);
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = gee_hash_map_new (meta_window_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GALA_TYPE_WINDOW_GEOMETRY, (GBoxedCopyFunc) gala_window_geometry_dup, (GDestroyNotify) gala_window_geometry_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_g_object_unref0 (self->priv->unmaximized_state_geometry);
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	self->priv->unmaximized_state_geometry = _tmp0_;
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	return self;
#line 301 "WindowListener.c"
}


static GalaWindowListener* gala_window_listener_new (void) {
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	return gala_window_listener_construct (GALA_TYPE_WINDOW_LISTENER);
#line 308 "WindowListener.c"
}


static void _gala_window_listener_window_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	gala_window_listener_window_notify ((GalaWindowListener*) self, _sender, pspec);
#line 315 "WindowListener.c"
}


static void _gala_window_listener_window_removed_meta_window_unmanaged (MetaWindow* _sender, gpointer self) {
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	gala_window_listener_window_removed ((GalaWindowListener*) self, _sender);
#line 322 "WindowListener.c"
}


static void gala_window_listener_monitor_window (GalaWindowListener* self, MetaWindow* window) {
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (self != NULL);
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (window != NULL);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = window;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify", (GCallback) _gala_window_listener_window_notify_g_object_notify, self, 0);
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp1_ = window;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_signal_connect_object (_tmp1_, "unmanaged", (GCallback) _gala_window_listener_window_removed_meta_window_unmanaged, self, 0);
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp2_ = window;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	gala_window_listener_window_maximized_changed (self, _tmp2_);
#line 346 "WindowListener.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	return self ? g_object_ref (self) : NULL;
#line 353 "WindowListener.c"
}


static void gala_window_listener_window_notify (GalaWindowListener* self, GObject* object, GParamSpec* pspec) {
	MetaWindow* window = NULL;
	GObject* _tmp0_;
	MetaWindow* _tmp1_;
	GParamSpec* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	static GQuark _tmp5_label0 = 0;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	static GQuark _tmp5_label1 = 0;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	static GQuark _tmp5_label2 = 0;
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (self != NULL);
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (object != NULL);
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (pspec != NULL);
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = object;
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, meta_window_get_type (), MetaWindow));
#line 79 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	window = _tmp1_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp2_ = pspec;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp3_ = _tmp2_->name;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp4_ = _tmp3_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	if ((_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("maximized-horizontally")))) || (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("maximized-vertically"))))) {
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		switch (0) {
#line 395 "WindowListener.c"
			default:
			{
				MetaWindow* _tmp7_;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp7_ = window;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				gala_window_listener_window_maximized_changed (self, _tmp7_);
#line 85 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				break;
#line 405 "WindowListener.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("on-all-workspaces")))) {
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		switch (0) {
#line 411 "WindowListener.c"
			default:
			{
				MetaWindow* _tmp8_;
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				_tmp8_ = window;
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				gala_window_listener_window_on_all_workspaces_changed (self, _tmp8_);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
				break;
#line 421 "WindowListener.c"
			}
		}
	}
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_g_object_unref0 (window);
#line 427 "WindowListener.c"
}


static void gala_window_listener_window_on_all_workspaces_changed (GalaWindowListener* self, MetaWindow* window) {
	MetaWindow* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	MetaWindow* _tmp3_;
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (self != NULL);
#line 92 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (window != NULL);
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = window;
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_object_get (_tmp0_, "on-all-workspaces", &_tmp1_, NULL);
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp2_ = _tmp1_;
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	if (_tmp2_) {
#line 95 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		return;
#line 450 "WindowListener.c"
	}
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp3_ = window;
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_signal_emit (self, gala_window_listener_signals[GALA_WINDOW_LISTENER_WINDOW_NO_LONGER_ON_ALL_WORKSPACES_SIGNAL], 0, _tmp3_);
#line 456 "WindowListener.c"
}


static void gala_window_listener_window_maximized_changed (GalaWindowListener* self, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	MetaWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GalaWindowGeometry window_geometry = {0};
	GalaWindowGeometry _tmp7_ = {0};
	MetaWindow* _tmp8_;
	MetaRectangle _tmp9_ = {0};
	MetaWindow* _tmp10_;
	MetaRectangle _tmp11_ = {0};
	GeeHashMap* _tmp12_;
	MetaWindow* _tmp13_;
	GalaWindowGeometry _tmp14_;
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (self != NULL);
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (window != NULL);
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp1_ = window;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_object_get (_tmp1_, "maximized-vertically", &_tmp2_, NULL);
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp3_ = _tmp2_;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	if (!_tmp3_) {
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		_tmp0_ = TRUE;
#line 488 "WindowListener.c"
	} else {
		MetaWindow* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		_tmp4_ = window;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		g_object_get (_tmp4_, "maximized-horizontally", &_tmp5_, NULL);
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		_tmp6_ = _tmp5_;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		_tmp0_ = !_tmp6_;
#line 501 "WindowListener.c"
	}
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	if (_tmp0_) {
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
		return;
#line 507 "WindowListener.c"
	}
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	window_geometry = _tmp7_;
#line 107 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp8_ = window;
#line 107 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	meta_window_get_frame_rect (_tmp8_, &_tmp9_);
#line 107 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	window_geometry.inner = _tmp9_;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp10_ = window;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	meta_window_get_buffer_rect (_tmp10_, &_tmp11_);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	window_geometry.outer = _tmp11_;
#line 110 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp12_ = self->priv->unmaximized_state_geometry;
#line 110 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp13_ = window;
#line 110 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp14_ = window_geometry;
#line 110 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, &_tmp14_);
#line 531 "WindowListener.c"
}


GalaWindowGeometry* gala_window_listener_get_unmaximized_state_geometry (GalaWindowListener* self, MetaWindow* window) {
	GalaWindowGeometry* result = NULL;
	GeeHashMap* _tmp0_;
	MetaWindow* _tmp1_;
	gpointer _tmp2_;
#line 113 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = self->priv->unmaximized_state_geometry;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp1_ = window;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	result = (GalaWindowGeometry*) _tmp2_;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	return result;
#line 554 "WindowListener.c"
}


static void gala_window_listener_window_removed (GalaWindowListener* self, MetaWindow* window) {
	MetaWindow* _tmp0_;
	guint _tmp1_;
	MetaWindow* _tmp2_;
	guint _tmp3_;
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (self != NULL);
#line 118 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_return_if_fail (window != NULL);
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp0_ = window;
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_window_listener_window_notify_g_object_notify, self);
#line 121 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_tmp2_ = window;
#line 121 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_signal_parse_name ("unmanaged", meta_window_get_type (), &_tmp3_, NULL, FALSE);
#line 121 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_window_listener_window_removed_meta_window_unmanaged, self);
#line 579 "WindowListener.c"
}


static void gala_window_listener_class_init (GalaWindowListenerClass * klass) {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	gala_window_listener_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	g_type_class_add_private (klass, sizeof (GalaWindowListenerPrivate));
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_listener_finalize;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	gala_window_listener_signals[GALA_WINDOW_LISTENER_WINDOW_NO_LONGER_ON_ALL_WORKSPACES_SIGNAL] = g_signal_new ("window-no-longer-on-all-workspaces", GALA_TYPE_WINDOW_LISTENER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, meta_window_get_type ());
#line 592 "WindowListener.c"
}


static void gala_window_listener_instance_init (GalaWindowListener * self) {
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	self->priv = GALA_WINDOW_LISTENER_GET_PRIVATE (self);
#line 599 "WindowListener.c"
}


static void gala_window_listener_finalize (GObject * obj) {
	GalaWindowListener * self;
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_LISTENER, GalaWindowListener);
#line 62 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	_g_object_unref0 (self->priv->unmaximized_state_geometry);
#line 28 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WindowListener.vala"
	G_OBJECT_CLASS (gala_window_listener_parent_class)->finalize (obj);
#line 611 "WindowListener.c"
}


GType gala_window_listener_get_type (void) {
	static volatile gsize gala_window_listener_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_listener_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWindowListenerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_listener_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowListener), 0, (GInstanceInitFunc) gala_window_listener_instance_init, NULL };
		GType gala_window_listener_type_id;
		gala_window_listener_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWindowListener", &g_define_type_info, 0);
		g_once_init_leave (&gala_window_listener_type_id__volatile, gala_window_listener_type_id);
	}
	return gala_window_listener_type_id__volatile;
}



