/* WorkspaceManager.c generated by valac 0.37.91, the Vala compiler
 * generated from WorkspaceManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include "gala.h"
#include <gee.h>
#include <meta/workspace.h>
#include <meta/screen.h>
#include <meta/meta-plugin.h>
#include <meta/prefs.h>
#include <meta/common.h>
#include <meta/window.h>
#include <meta/display.h>


#define GALA_TYPE_WORKSPACE_MANAGER (gala_workspace_manager_get_type ())
#define GALA_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager))
#define GALA_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))
#define GALA_IS_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_IS_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_WORKSPACE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))

typedef struct _GalaWorkspaceManager GalaWorkspaceManager;
typedef struct _GalaWorkspaceManagerClass GalaWorkspaceManagerClass;
typedef struct _GalaWorkspaceManagerPrivate GalaWorkspaceManagerPrivate;
enum  {
	GALA_WORKSPACE_MANAGER_DUMMY_PROPERTY,
	GALA_WORKSPACE_MANAGER_WM,
	GALA_WORKSPACE_MANAGER_LAST_PROPERTY
};
static GParamSpec* gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWorkspaceManager {
	GObject parent_instance;
	GalaWorkspaceManagerPrivate * priv;
};

struct _GalaWorkspaceManagerClass {
	GObjectClass parent_class;
};

struct _GalaWorkspaceManagerPrivate {
	GalaWindowManager* _wm;
	GeeLinkedList* workspaces_marked_removed;
	gint remove_freeze_count;
};


static gpointer gala_workspace_manager_parent_class = NULL;
static GalaWorkspaceManager* gala_workspace_manager_instance;
static GalaWorkspaceManager* gala_workspace_manager_instance = NULL;

GType gala_workspace_manager_get_type (void) G_GNUC_CONST;
#define GALA_WORKSPACE_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerPrivate))
GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self);
static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self, MetaPreference pref);
static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref, gpointer self);
static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self, MetaScreen* screen, gint index);
static void _gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender, gint object, gpointer self);
static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self, MetaScreen* screen, gint from, gint to, MetaMotionDirection direction);
static void _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender, gint object, gint p0, MetaMotionDirection p1, gpointer self);
static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self, MetaScreen* screen, gint index);
static void _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender, gint object, gpointer self);
static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self, MetaScreen* screen, gint monitor, MetaWindow* window);
static void _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender, gint object, MetaWindow* p0, gpointer self);
static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self, MetaScreen* screen, gint monitor, MetaWindow* window);
static void _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender, gint object, MetaWindow* p0, gpointer self);
void gala_workspace_manager_init (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type, GalaWindowManager* wm);
GalaWorkspaceManager* gala_workspace_manager_get_default (void);
static void gala_workspace_manager_window_added (GalaWorkspaceManager* self, MetaWorkspace* workspace, MetaWindow* window);
static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender, MetaWindow* object, gpointer self);
static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self, MetaWorkspace* workspace, MetaWindow* window);
static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender, MetaWindow* object, gpointer self);
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self, MetaWorkspace* workspace);
static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self);
gboolean gala_internal_utils_workspaces_only_on_primary (void);
void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_cleanup (GalaWorkspaceManager* self);
static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self, GalaWindowManager* value);
static GObject * gala_workspace_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void gala_workspace_manager_finalize (GObject * obj);
static void _vala_gala_workspace_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_workspace_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref, gpointer self) {
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_prefs_listener ((GalaWorkspaceManager*) self, pref);
#line 116 "WorkspaceManager.c"
}


static void _gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender, gint object, gpointer self) {
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_added ((GalaWorkspaceManager*) self, _sender, object);
#line 123 "WorkspaceManager.c"
}


static void _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender, gint object, gint p0, MetaMotionDirection p1, gpointer self) {
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_switched ((GalaWorkspaceManager*) self, _sender, object, p0, p1);
#line 130 "WorkspaceManager.c"
}


static void _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender, gint object, gpointer self) {
#line 82 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_workspace_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 137 "WorkspaceManager.c"
}


static void _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender, gint object, MetaWindow* p0, gpointer self) {
#line 83 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_window_entered_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 144 "WorkspaceManager.c"
}


static void _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender, gint object, MetaWindow* p0, gpointer self) {
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_window_left_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
#line 151 "WorkspaceManager.c"
}


void gala_workspace_manager_init (GalaWindowManager* wm) {
	GalaWorkspaceManager* _tmp0_;
	GalaWindowManager* _tmp1_;
	GalaWorkspaceManager* _tmp2_;
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (wm != NULL);
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 24 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_vala_return_if_fail (_tmp0_ == NULL, "instance == null");
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = wm;
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = gala_workspace_manager_new (_tmp1_);
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_g_object_unref0 (gala_workspace_manager_instance);
#line 27 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_instance = _tmp2_;
#line 173 "WorkspaceManager.c"
}


GalaWorkspaceManager* gala_workspace_manager_get_default (void) {
	GalaWorkspaceManager* result = NULL;
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
#line 30 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = gala_workspace_manager_instance;
#line 30 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = gala_workspace_manager_instance;
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	result = _tmp1_;
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	return result;
#line 191 "WorkspaceManager.c"
}


static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type, GalaWindowManager* wm) {
	GalaWorkspaceManager * self = NULL;
	GalaWindowManager* _tmp0_;
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = wm;
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	self = (GalaWorkspaceManager*) g_object_new (object_type, "wm", _tmp0_, NULL);
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	return self;
#line 206 "WorkspaceManager.c"
}


static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm) {
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	return gala_workspace_manager_construct (GALA_TYPE_WORKSPACE_MANAGER, wm);
#line 213 "WorkspaceManager.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 89 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 220 "WorkspaceManager.c"
}


static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender, MetaWindow* object, gpointer self) {
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_window_added ((GalaWorkspaceManager*) self, _sender, object);
#line 227 "WorkspaceManager.c"
}


static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender, MetaWindow* object, gpointer self) {
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_window_removed ((GalaWorkspaceManager*) self, _sender, object);
#line 234 "WorkspaceManager.c"
}


static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self, MetaScreen* screen, gint index) {
	MetaWorkspace* workspace = NULL;
	MetaScreen* _tmp0_;
	gint _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	MetaWorkspace* _tmp6_;
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 89 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = screen;
#line 89 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = index;
#line 89 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = meta_screen_get_workspace_by_index (_tmp0_, _tmp1_);
#line 89 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 89 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	workspace = _tmp3_;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp4_ = workspace;
#line 90 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp4_ == NULL) {
#line 91 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_g_object_unref0 (workspace);
#line 91 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		return;
#line 269 "WorkspaceManager.c"
	}
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp5_ = workspace;
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp5_, "window-added", (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self, 0);
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp6_ = workspace;
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp6_, "window-removed", (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self, 0);
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_g_object_unref0 (workspace);
#line 281 "WorkspaceManager.c"
}


static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self, MetaScreen* screen, gint index) {
	GList* existing_workspaces = NULL;
	MetaScreen* _tmp0_;
	GList* _tmp1_;
	GeeIterator* it = NULL;
	GeeLinkedList* _tmp2_;
	GeeIterator* _tmp3_;
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 99 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = screen;
#line 99 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = meta_screen_get_workspaces (_tmp0_);
#line 99 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	existing_workspaces = _tmp1_;
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = self->priv->workspaces_marked_removed;
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp2_);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	it = _tmp3_;
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	while (TRUE) {
#line 310 "WorkspaceManager.c"
		GeeIterator* _tmp4_;
		gboolean _tmp5_;
		GList* _tmp6_;
		GeeIterator* _tmp7_;
		gpointer _tmp8_;
		MetaWorkspace* _tmp9_;
		gint _tmp10_;
		gboolean _tmp11_;
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp4_ = it;
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp5_ = gee_iterator_next (_tmp4_);
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		if (!_tmp5_) {
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			break;
#line 327 "WorkspaceManager.c"
		}
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp6_ = existing_workspaces;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp7_ = it;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp8_ = gee_iterator_get (_tmp7_);
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp9_ = (MetaWorkspace*) _tmp8_;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp10_ = g_list_index (_tmp6_, _tmp9_);
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp11_ = _tmp10_ < 0;
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_g_object_unref0 (_tmp9_);
#line 103 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		if (_tmp11_) {
#line 345 "WorkspaceManager.c"
			GeeIterator* _tmp12_;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp12_ = it;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			gee_iterator_remove (_tmp12_);
#line 351 "WorkspaceManager.c"
		}
	}
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_g_object_unref0 (it);
#line 356 "WorkspaceManager.c"
}


static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self, MetaScreen* screen, gint from, gint to, MetaMotionDirection direction) {
	gboolean _tmp0_;
	MetaWorkspace* prev_workspace = NULL;
	MetaScreen* _tmp1_;
	gint _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
	gboolean _tmp5_ = FALSE;
	MetaWorkspace* _tmp6_;
	guint _tmp7_;
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 110 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = meta_prefs_get_dynamic_workspaces ();
#line 110 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (!_tmp0_) {
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		return;
#line 380 "WorkspaceManager.c"
	}
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = screen;
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = from;
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = meta_screen_get_workspace_by_index (_tmp1_, _tmp2_);
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	prev_workspace = _tmp4_;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp6_ = prev_workspace;
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp7_ = gala_utils_get_n_windows (_tmp6_);
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp7_ < ((guint) 1)) {
#line 398 "WorkspaceManager.c"
		gint _tmp8_;
		MetaScreen* _tmp9_;
		gint _tmp10_;
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp8_ = from;
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp9_ = screen;
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp10_ = meta_screen_get_n_workspaces (_tmp9_);
#line 116 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp5_ = _tmp8_ != (_tmp10_ - 1);
#line 410 "WorkspaceManager.c"
	} else {
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp5_ = FALSE;
#line 414 "WorkspaceManager.c"
	}
#line 115 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp5_) {
#line 418 "WorkspaceManager.c"
		MetaWorkspace* _tmp11_;
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp11_ = prev_workspace;
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, _tmp11_);
#line 424 "WorkspaceManager.c"
	}
#line 108 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_g_object_unref0 (prev_workspace);
#line 428 "WorkspaceManager.c"
}


static void gala_workspace_manager_window_added (GalaWorkspaceManager* self, MetaWorkspace* workspace, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaWorkspace* _tmp2_;
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp7_;
	MetaScreen* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	MetaWindow* _tmp12_;
	MetaWindowType _tmp13_;
	MetaWindowType _tmp14_;
#line 121 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 121 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = workspace;
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp2_ == NULL) {
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp1_ = TRUE;
#line 455 "WorkspaceManager.c"
	} else {
		gboolean _tmp3_;
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp3_ = meta_prefs_get_dynamic_workspaces ();
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp1_ = !_tmp3_;
#line 462 "WorkspaceManager.c"
	}
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp1_) {
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = TRUE;
#line 468 "WorkspaceManager.c"
	} else {
		MetaWindow* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp4_ = window;
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		g_object_get (_tmp4_, "on-all-workspaces", &_tmp5_, NULL);
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp6_ = _tmp5_;
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = _tmp6_;
#line 481 "WorkspaceManager.c"
	}
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 125 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		return;
#line 487 "WorkspaceManager.c"
	}
#line 127 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp7_ = workspace;
#line 127 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp8_ = meta_workspace_get_screen (_tmp7_);
#line 127 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	screen = _tmp8_;
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp12_ = window;
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp13_ = meta_window_get_window_type (_tmp12_);
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp14_ = _tmp13_;
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp14_ == META_WINDOW_NORMAL) {
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp11_ = TRUE;
#line 505 "WorkspaceManager.c"
	} else {
		MetaWindow* _tmp15_;
		MetaWindowType _tmp16_;
		MetaWindowType _tmp17_;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp15_ = window;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp16_ = meta_window_get_window_type (_tmp15_);
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp17_ = _tmp16_;
#line 130 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp11_ = _tmp17_ == META_WINDOW_DIALOG;
#line 518 "WorkspaceManager.c"
	}
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp11_) {
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp10_ = TRUE;
#line 524 "WorkspaceManager.c"
	} else {
		MetaWindow* _tmp18_;
		MetaWindowType _tmp19_;
		MetaWindowType _tmp20_;
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp18_ = window;
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp19_ = meta_window_get_window_type (_tmp18_);
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp20_ = _tmp19_;
#line 131 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp10_ = _tmp20_ == META_WINDOW_MODAL_DIALOG;
#line 537 "WorkspaceManager.c"
	}
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp10_) {
#line 541 "WorkspaceManager.c"
		MetaWorkspace* _tmp21_;
		gint _tmp22_;
		MetaScreen* _tmp23_;
		gint _tmp24_;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp21_ = workspace;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp22_ = meta_workspace_index (_tmp21_);
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp23_ = screen;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp24_ = meta_screen_get_n_workspaces (_tmp23_);
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp9_ = _tmp22_ == (_tmp24_ - 1);
#line 556 "WorkspaceManager.c"
	} else {
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp9_ = FALSE;
#line 560 "WorkspaceManager.c"
	}
#line 129 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp9_) {
#line 133 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 566 "WorkspaceManager.c"
	}
}


static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self, MetaWorkspace* workspace, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	MetaWorkspace* _tmp1_;
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp3_;
	MetaScreen* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	MetaWindow* _tmp7_;
	MetaWindowType _tmp8_;
	MetaWindowType _tmp9_;
	gint index = 0;
	MetaScreen* _tmp16_;
	GList* _tmp17_;
	MetaWorkspace* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gboolean is_active_workspace = FALSE;
	MetaWorkspace* _tmp21_;
	MetaScreen* _tmp22_;
	MetaWorkspace* _tmp23_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_;
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = workspace;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp1_ == NULL) {
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = TRUE;
#line 607 "WorkspaceManager.c"
	} else {
		gboolean _tmp2_;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp2_ = meta_prefs_get_dynamic_workspaces ();
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = !_tmp2_;
#line 614 "WorkspaceManager.c"
	}
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		return;
#line 620 "WorkspaceManager.c"
	}
#line 141 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = workspace;
#line 141 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp4_ = meta_workspace_get_screen (_tmp3_);
#line 141 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	screen = _tmp4_;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp7_ = window;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp8_ = meta_window_get_window_type (_tmp7_);
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp9_ = _tmp8_;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp9_ != META_WINDOW_NORMAL) {
#line 636 "WorkspaceManager.c"
		MetaWindow* _tmp10_;
		MetaWindowType _tmp11_;
		MetaWindowType _tmp12_;
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp10_ = window;
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp11_ = meta_window_get_window_type (_tmp10_);
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp12_ = _tmp11_;
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp6_ = _tmp12_ != META_WINDOW_DIALOG;
#line 648 "WorkspaceManager.c"
	} else {
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp6_ = FALSE;
#line 652 "WorkspaceManager.c"
	}
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp6_) {
#line 656 "WorkspaceManager.c"
		MetaWindow* _tmp13_;
		MetaWindowType _tmp14_;
		MetaWindowType _tmp15_;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp13_ = window;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp14_ = meta_window_get_window_type (_tmp13_);
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp15_ = _tmp14_;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp5_ = _tmp15_ != META_WINDOW_MODAL_DIALOG;
#line 668 "WorkspaceManager.c"
	} else {
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp5_ = FALSE;
#line 672 "WorkspaceManager.c"
	}
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp5_) {
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		return;
#line 678 "WorkspaceManager.c"
	}
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp16_ = screen;
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp17_ = meta_screen_get_workspaces (_tmp16_);
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp18_ = workspace;
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp19_ = g_list_index (_tmp17_, _tmp18_);
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	index = _tmp19_;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp20_ = index;
#line 150 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp20_ < 0) {
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		return;
#line 696 "WorkspaceManager.c"
	}
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp21_ = workspace;
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp22_ = screen;
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp23_ = meta_screen_get_active_workspace (_tmp22_);
#line 153 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	is_active_workspace = _tmp21_ == _tmp23_;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp28_ = is_active_workspace;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (!_tmp28_) {
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp27_ = TRUE;
#line 712 "WorkspaceManager.c"
	} else {
		GalaWindowManager* _tmp29_;
		gboolean _tmp30_;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp29_ = self->priv->_wm;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp30_ = gala_window_manager_is_modal (_tmp29_);
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp27_ = _tmp30_;
#line 722 "WorkspaceManager.c"
	}
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp27_) {
#line 726 "WorkspaceManager.c"
		gint _tmp31_;
#line 158 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp31_ = self->priv->remove_freeze_count;
#line 158 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp26_ = _tmp31_ < 1;
#line 732 "WorkspaceManager.c"
	} else {
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp26_ = FALSE;
#line 736 "WorkspaceManager.c"
	}
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp26_) {
#line 740 "WorkspaceManager.c"
		MetaWorkspace* _tmp32_;
		guint _tmp33_;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp32_ = workspace;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp33_ = gala_utils_get_n_windows (_tmp32_);
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp25_ = _tmp33_ < ((guint) 1);
#line 749 "WorkspaceManager.c"
	} else {
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp25_ = FALSE;
#line 753 "WorkspaceManager.c"
	}
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp25_) {
#line 757 "WorkspaceManager.c"
		gint _tmp34_;
		MetaScreen* _tmp35_;
		gint _tmp36_;
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp34_ = index;
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp35_ = screen;
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp36_ = meta_screen_get_n_workspaces (_tmp35_);
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp24_ = _tmp34_ != (_tmp36_ - 1);
#line 769 "WorkspaceManager.c"
	} else {
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp24_ = FALSE;
#line 773 "WorkspaceManager.c"
	}
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp24_) {
#line 777 "WorkspaceManager.c"
		MetaWorkspace* _tmp37_;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp37_ = workspace;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		gala_workspace_manager_remove_workspace (self, _tmp37_);
#line 783 "WorkspaceManager.c"
	}
}


static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self, MetaScreen* screen, gint monitor, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 165 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 165 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 165 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = gala_internal_utils_workspaces_only_on_primary ();
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp1_) {
#line 801 "WorkspaceManager.c"
		gint _tmp2_;
		MetaScreen* _tmp3_;
		gint _tmp4_;
#line 168 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp2_ = monitor;
#line 168 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp3_ = screen;
#line 168 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp4_ = meta_screen_get_primary_monitor (_tmp3_);
#line 168 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = _tmp2_ == _tmp4_;
#line 813 "WorkspaceManager.c"
	} else {
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 817 "WorkspaceManager.c"
	}
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 821 "WorkspaceManager.c"
		MetaWindow* _tmp5_;
		MetaWorkspace* _tmp6_;
		MetaWindow* _tmp7_;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp5_ = window;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp6_ = meta_window_get_workspace (_tmp5_);
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp7_ = window;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		gala_workspace_manager_window_added (self, _tmp6_, _tmp7_);
#line 833 "WorkspaceManager.c"
	}
}


static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self, MetaScreen* screen, gint monitor, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (screen != NULL);
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (window != NULL);
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = gala_internal_utils_workspaces_only_on_primary ();
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp1_) {
#line 851 "WorkspaceManager.c"
		gint _tmp2_;
		MetaScreen* _tmp3_;
		gint _tmp4_;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp2_ = monitor;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp3_ = screen;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp4_ = meta_screen_get_primary_monitor (_tmp3_);
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = _tmp2_ == _tmp4_;
#line 863 "WorkspaceManager.c"
	} else {
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = FALSE;
#line 867 "WorkspaceManager.c"
	}
#line 174 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp0_) {
#line 871 "WorkspaceManager.c"
		MetaWindow* _tmp5_;
		MetaWorkspace* _tmp6_;
		MetaWindow* _tmp7_;
#line 176 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp5_ = window;
#line 176 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp6_ = meta_window_get_workspace (_tmp5_);
#line 176 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp7_ = window;
#line 176 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		gala_workspace_manager_window_removed (self, _tmp6_, _tmp7_);
#line 883 "WorkspaceManager.c"
	}
}


static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self, MetaPreference pref) {
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaPreference _tmp3_;
#line 179 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 181 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 181 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 181 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = pref;
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp3_ == META_PREF_DYNAMIC_WORKSPACES) {
#line 906 "WorkspaceManager.c"
		gboolean _tmp4_;
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp4_ = meta_prefs_get_dynamic_workspaces ();
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp2_ = _tmp4_;
#line 912 "WorkspaceManager.c"
	} else {
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp2_ = FALSE;
#line 916 "WorkspaceManager.c"
	}
#line 183 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp2_) {
#line 920 "WorkspaceManager.c"
		MetaScreen* _tmp5_;
		MetaScreen* _tmp6_;
		gint _tmp7_;
		MetaWorkspace* _tmp8_;
		guint _tmp9_;
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp5_ = screen;
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp6_ = screen;
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp7_ = meta_screen_get_n_workspaces (_tmp6_);
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp8_ = meta_screen_get_workspace_by_index (_tmp5_, _tmp7_ - 1);
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp9_ = gala_utils_get_n_windows (_tmp8_);
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		if (_tmp9_ > ((guint) 0)) {
#line 186 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			gala_workspace_manager_append_workspace (self);
#line 940 "WorkspaceManager.c"
		}
	}
}


static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self) {
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	guint32 _tmp3_;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 192 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 192 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 192 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = meta_screen_get_display (screen);
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = meta_display_get_current_time (_tmp2_);
#line 194 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	meta_screen_append_new_workspace (screen, FALSE, _tmp3_);
#line 966 "WorkspaceManager.c"
}


/**
 * Make sure we switch to a different workspace and remove the given one
 *
 * @param workspace The workspace to remove
 */
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self, MetaWorkspace* workspace) {
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp0_;
	MetaScreen* _tmp1_;
	guint32 time = 0U;
	MetaScreen* _tmp2_;
	MetaDisplay* _tmp3_;
	guint32 _tmp4_;
	MetaWorkspace* _tmp5_;
	MetaScreen* _tmp6_;
	MetaWorkspace* _tmp7_;
	GeeLinkedList* _tmp21_;
	MetaWorkspace* _tmp22_;
	gboolean _tmp23_;
	MetaWorkspace* _tmp24_;
	guint _tmp25_;
	MetaWorkspace* _tmp26_;
	guint _tmp27_;
	GeeLinkedList* _tmp28_;
	MetaWorkspace* _tmp29_;
	MetaScreen* _tmp30_;
	MetaWorkspace* _tmp31_;
	guint32 _tmp32_;
#line 202 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 202 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (workspace != NULL);
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = workspace;
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = meta_workspace_get_screen (_tmp0_);
#line 204 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 206 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = screen;
#line 206 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = meta_screen_get_display (_tmp2_);
#line 206 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp4_ = meta_display_get_current_time (_tmp3_);
#line 206 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	time = _tmp4_;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp5_ = workspace;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp6_ = screen;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp7_ = meta_screen_get_active_workspace (_tmp6_);
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp5_ == _tmp7_) {
#line 1024 "WorkspaceManager.c"
		MetaWorkspace* next = NULL;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp9_;
		MetaWorkspace* _tmp10_;
		gboolean _tmp11_ = FALSE;
		MetaWorkspace* _tmp12_;
		MetaWorkspace* _tmp13_;
		MetaWorkspace* _tmp18_;
#line 209 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		next = NULL;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp8_ = workspace;
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp9_ = meta_workspace_get_neighbor (_tmp8_, META_MOTION_LEFT);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 211 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		next = _tmp10_;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp12_ = next;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp13_ = workspace;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		if (_tmp12_ == _tmp13_) {
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp11_ = TRUE;
#line 1053 "WorkspaceManager.c"
		} else {
			MetaWorkspace* _tmp14_;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp14_ = next;
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp11_ = _tmp14_ == NULL;
#line 1060 "WorkspaceManager.c"
		}
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		if (_tmp11_) {
#line 1064 "WorkspaceManager.c"
			MetaWorkspace* _tmp15_;
			MetaWorkspace* _tmp16_;
			MetaWorkspace* _tmp17_;
#line 214 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp15_ = workspace;
#line 214 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp16_ = meta_workspace_get_neighbor (_tmp15_, META_MOTION_RIGHT);
#line 214 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 214 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_g_object_unref0 (next);
#line 214 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			next = _tmp17_;
#line 1078 "WorkspaceManager.c"
		}
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp18_ = next;
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		if (_tmp18_ != NULL) {
#line 1084 "WorkspaceManager.c"
			MetaWorkspace* _tmp19_;
			guint32 _tmp20_;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp19_ = next;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp20_ = time;
#line 217 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			meta_workspace_activate (_tmp19_, _tmp20_);
#line 1093 "WorkspaceManager.c"
		}
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_g_object_unref0 (next);
#line 1097 "WorkspaceManager.c"
	}
#line 221 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp21_ = self->priv->workspaces_marked_removed;
#line 221 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp22_ = workspace;
#line 221 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp23_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 221 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp23_) {
#line 222 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		return;
#line 1109 "WorkspaceManager.c"
	}
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp24_ = workspace;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp25_, NULL, FALSE);
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self);
#line 226 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp26_ = workspace;
#line 226 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp27_, NULL, FALSE);
#line 226 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, 0, NULL, (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self);
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp28_ = self->priv->workspaces_marked_removed;
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp29_ = workspace;
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 230 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp30_ = screen;
#line 230 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp31_ = workspace;
#line 230 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp32_ = time;
#line 230 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	meta_screen_remove_workspace (_tmp30_, _tmp31_, _tmp32_);
#line 1137 "WorkspaceManager.c"
}


/**
 * Temporarily disables removing workspaces when they are empty
 */
void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self) {
	gint _tmp0_;
#line 236 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 238 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 238 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ + 1;
#line 1152 "WorkspaceManager.c"
}


/**
 * Undo the effect of freeze_remove()
 */
void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self) {
	gint _tmp0_;
	gint _tmp1_;
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->remove_freeze_count;
#line 246 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = _tmp0_ - 1;
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = self->priv->remove_freeze_count;
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_vala_assert (_tmp1_ >= 0, "remove_freeze_count >= 0");
#line 1172 "WorkspaceManager.c"
}


/**
 * If workspaces are dynamic, checks if there are empty workspaces that should
 * be removed. Particularily useful in conjunction with freeze/thaw_remove to
 * cleanup after an operation that required stable workspace/window indices
 */
void gala_workspace_manager_cleanup (GalaWorkspaceManager* self) {
	gboolean _tmp0_;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp1_;
	MetaScreen* _tmp2_;
	MetaScreen* _tmp3_;
	gint last_index = 0;
	MetaScreen* _tmp4_;
	gint _tmp5_;
	MetaScreen* _tmp6_;
	GList* _tmp7_;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 258 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = meta_prefs_get_dynamic_workspaces ();
#line 258 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (!_tmp0_) {
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		return;
#line 1200 "WorkspaceManager.c"
	}
#line 261 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = self->priv->_wm;
#line 261 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = meta_plugin_get_screen ((MetaPlugin*) _tmp1_);
#line 261 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 261 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	screen = _tmp3_;
#line 262 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp4_ = screen;
#line 262 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp5_ = meta_screen_get_n_workspaces (_tmp4_);
#line 262 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	last_index = _tmp5_ - 1;
#line 264 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp6_ = screen;
#line 264 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp7_ = meta_screen_get_workspaces (_tmp6_);
#line 1220 "WorkspaceManager.c"
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
#line 264 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		workspace_collection = _tmp7_;
#line 264 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
#line 1228 "WorkspaceManager.c"
			MetaWorkspace* _tmp8_;
			MetaWorkspace* workspace = NULL;
#line 264 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp8_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
#line 264 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			workspace = _tmp8_;
#line 1235 "WorkspaceManager.c"
			{
				gboolean _tmp9_ = FALSE;
				MetaWorkspace* _tmp10_;
				guint _tmp11_;
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_tmp10_ = workspace;
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_tmp11_ = gala_utils_get_n_windows (_tmp10_);
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				if (_tmp11_ < ((guint) 1)) {
#line 1246 "WorkspaceManager.c"
					MetaWorkspace* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 266 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					_tmp12_ = workspace;
#line 266 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					_tmp13_ = meta_workspace_index (_tmp12_);
#line 266 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					_tmp14_ = last_index;
#line 266 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					_tmp9_ = _tmp13_ != _tmp14_;
#line 1258 "WorkspaceManager.c"
				} else {
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					_tmp9_ = FALSE;
#line 1262 "WorkspaceManager.c"
				}
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				if (_tmp9_) {
#line 1266 "WorkspaceManager.c"
					MetaWorkspace* _tmp15_;
#line 267 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					_tmp15_ = workspace;
#line 267 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					gala_workspace_manager_remove_workspace (self, _tmp15_);
#line 1272 "WorkspaceManager.c"
				}
#line 264 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_g_object_unref0 (workspace);
#line 1276 "WorkspaceManager.c"
			}
		}
	}
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_g_object_unref0 (screen);
#line 1282 "WorkspaceManager.c"
}


GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self) {
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	return result;
#line 1297 "WorkspaceManager.c"
}


static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self, GalaWindowManager* value) {
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (gala_workspace_manager_get_wm (self) != value) {
#line 1306 "WorkspaceManager.c"
		GalaWindowManager* _tmp0_;
		GalaWindowManager* _tmp1_;
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp0_ = value;
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_g_object_unref0 (self->priv->_wm);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		self->priv->_wm = _tmp1_;
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM]);
#line 1319 "WorkspaceManager.c"
	}
}


static GObject * gala_workspace_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GeeLinkedList* _tmp2_;
	gboolean _tmp3_;
	MetaScreen* _tmp12_;
	MetaScreen* _tmp13_;
	MetaScreen* _tmp14_;
	MetaScreen* _tmp15_;
	MetaScreen* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_;
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	parent_class = G_OBJECT_CLASS (gala_workspace_manager_parent_class);
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = gee_linked_list_new (meta_workspace_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 52 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	self->priv->workspaces_marked_removed = _tmp2_;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp3_ = meta_prefs_get_dynamic_workspaces ();
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp3_) {
#line 1362 "WorkspaceManager.c"
		MetaScreen* _tmp4_;
#line 55 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp4_ = screen;
#line 55 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		meta_screen_override_workspace_layout (_tmp4_, META_SCREEN_TOPLEFT, FALSE, 1, -1);
#line 1368 "WorkspaceManager.c"
	}
	{
		gint i = 0;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		i = 0;
#line 1374 "WorkspaceManager.c"
		{
			gboolean _tmp5_ = FALSE;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			_tmp5_ = TRUE;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
			while (TRUE) {
#line 1381 "WorkspaceManager.c"
				gint _tmp7_;
				MetaScreen* _tmp8_;
				gint _tmp9_;
				MetaScreen* _tmp10_;
				gint _tmp11_;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				if (!_tmp5_) {
#line 1389 "WorkspaceManager.c"
					gint _tmp6_;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					_tmp6_ = i;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					i = _tmp6_ + 1;
#line 1395 "WorkspaceManager.c"
				}
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_tmp5_ = FALSE;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_tmp7_ = i;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_tmp8_ = screen;
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_tmp9_ = meta_screen_get_n_workspaces (_tmp8_);
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				if (!(_tmp7_ < _tmp9_)) {
#line 57 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
					break;
#line 1409 "WorkspaceManager.c"
				}
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_tmp10_ = screen;
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				_tmp11_ = i;
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
				gala_workspace_manager_workspace_added (self, _tmp10_, _tmp11_);
#line 1417 "WorkspaceManager.c"
			}
		}
	}
#line 60 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	meta_prefs_add_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 62 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp12_ = screen;
#line 62 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp12_, "workspace-switched", (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self, G_CONNECT_AFTER);
#line 63 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp13_ = screen;
#line 63 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp13_, "workspace-added", (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self, 0);
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp14_ = screen;
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp14_, "workspace-removed", (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self, G_CONNECT_AFTER);
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp15_ = screen;
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp15_, "window-entered-monitor", (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self, 0);
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp16_ = screen;
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_connect_object (_tmp16_, "window-left-monitor", (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self, 0);
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp18_ = meta_prefs_get_dynamic_workspaces ();
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp18_) {
#line 1447 "WorkspaceManager.c"
		MetaScreen* _tmp19_;
		MetaScreen* _tmp20_;
		gint _tmp21_;
		MetaWorkspace* _tmp22_;
		guint _tmp23_;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp19_ = screen;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp20_ = screen;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp21_ = meta_screen_get_n_workspaces (_tmp20_);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp22_ = meta_screen_get_workspace_by_index (_tmp19_, _tmp21_ - 1);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp23_ = gala_utils_get_n_windows (_tmp22_);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp17_ = _tmp23_ > ((guint) 0);
#line 1465 "WorkspaceManager.c"
	} else {
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		_tmp17_ = FALSE;
#line 1469 "WorkspaceManager.c"
	}
#line 69 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	if (_tmp17_) {
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		gala_workspace_manager_append_workspace (self);
#line 1475 "WorkspaceManager.c"
	}
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	return obj;
#line 1479 "WorkspaceManager.c"
}


static void gala_workspace_manager_class_init (GalaWorkspaceManagerClass * klass) {
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	gala_workspace_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_type_class_add_private (klass, sizeof (GalaWorkspaceManagerPrivate));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_workspace_manager_get_property;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_workspace_manager_set_property;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_workspace_manager_constructor;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_workspace_manager_finalize;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WORKSPACE_MANAGER_WM, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1498 "WorkspaceManager.c"
}


static void gala_workspace_manager_instance_init (GalaWorkspaceManager * self) {
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	self->priv = GALA_WORKSPACE_MANAGER_GET_PRIVATE (self);
#line 41 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	self->priv->remove_freeze_count = 0;
#line 1507 "WorkspaceManager.c"
}


static void gala_workspace_manager_finalize (GObject * obj) {
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	guint _tmp3_;
	MetaScreen* _tmp4_;
	guint _tmp5_;
	MetaScreen* _tmp6_;
	guint _tmp7_;
	MetaScreen* _tmp8_;
	guint _tmp9_;
	MetaScreen* _tmp10_;
	guint _tmp11_;
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 76 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp0_ = self->priv->_wm;
#line 76 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 76 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	screen = _tmp1_;
#line 78 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	meta_prefs_remove_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp2_ = screen;
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-added", meta_screen_get_type (), &_tmp3_, NULL, FALSE);
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp4_ = screen;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-switched", meta_screen_get_type (), &_tmp5_, NULL, FALSE);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self);
#line 82 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp6_ = screen;
#line 82 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_parse_name ("workspace-removed", meta_screen_get_type (), &_tmp7_, NULL, FALSE);
#line 82 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self);
#line 83 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp8_ = screen;
#line 83 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_parse_name ("window-entered-monitor", meta_screen_get_type (), &_tmp9_, NULL, FALSE);
#line 83 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self);
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_tmp10_ = screen;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_parse_name ("window-left-monitor", meta_screen_get_type (), &_tmp11_, NULL, FALSE);
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->_wm);
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	_g_object_unref0 (self->priv->workspaces_marked_removed);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	G_OBJECT_CLASS (gala_workspace_manager_parent_class)->finalize (obj);
#line 1572 "WorkspaceManager.c"
}


GType gala_workspace_manager_get_type (void) {
	static volatile gsize gala_workspace_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gala_workspace_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWorkspaceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_workspace_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWorkspaceManager), 0, (GInstanceInitFunc) gala_workspace_manager_instance_init, NULL };
		GType gala_workspace_manager_type_id;
		gala_workspace_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWorkspaceManager", &g_define_type_info, 0);
		g_once_init_leave (&gala_workspace_manager_type_id__volatile, gala_workspace_manager_type_id);
	}
	return gala_workspace_manager_type_id__volatile;
}


static void _vala_gala_workspace_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	switch (property_id) {
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		g_value_set_object (value, gala_workspace_manager_get_wm (self));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		break;
#line 1599 "WorkspaceManager.c"
		default:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		break;
#line 1605 "WorkspaceManager.c"
	}
}


static void _vala_gala_workspace_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
	switch (property_id) {
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		case GALA_WORKSPACE_MANAGER_WM:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		gala_workspace_manager_set_wm (self, g_value_get_object (value));
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		break;
#line 1621 "WorkspaceManager.c"
		default:
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/WorkspaceManager.vala"
		break;
#line 1627 "WorkspaceManager.c"
	}
}



