/* WindowSwitcher.c generated by valac 0.37.91, the Vala compiler
 * generated from WindowSwitcher.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include "gala.h"
#include <meta/meta-window-actor.h>
#include <plank.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <meta/meta-plugin.h>
#include <meta/screen.h>
#include <meta/boxes.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <meta/display.h>
#include <gdk/gdk.h>
#include <meta/window.h>
#include <meta/keybindings.h>
#include <meta/workspace.h>
#include <stdlib.h>
#include <string.h>
#include <meta/compositor-mutter.h>
#include <granite.h>


#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;
typedef struct _GalaWindowSwitcherPrivate GalaWindowSwitcherPrivate;
enum  {
	GALA_WINDOW_SWITCHER_DUMMY_PROPERTY,
	GALA_WINDOW_SWITCHER_WM,
	GALA_WINDOW_SWITCHER_LAST_PROPERTY
};
static GParamSpec* gala_window_switcher_properties[GALA_WINDOW_SWITCHER_LAST_PROPERTY];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GALA_TYPE_SAFE_WINDOW_CLONE (gala_safe_window_clone_get_type ())
#define GALA_SAFE_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone))
#define GALA_SAFE_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowCloneClass))
#define GALA_IS_SAFE_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SAFE_WINDOW_CLONE))
#define GALA_IS_SAFE_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SAFE_WINDOW_CLONE))
#define GALA_SAFE_WINDOW_CLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowCloneClass))

typedef struct _GalaSafeWindowClone GalaSafeWindowClone;
typedef struct _GalaSafeWindowCloneClass GalaSafeWindowCloneClass;
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

#define GALA_TYPE_BEHAVIOR_SETTINGS (gala_behavior_settings_get_type ())
#define GALA_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettings))
#define GALA_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))
#define GALA_IS_BEHAVIOR_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_IS_BEHAVIOR_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BEHAVIOR_SETTINGS))
#define GALA_BEHAVIOR_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BEHAVIOR_SETTINGS, GalaBehaviorSettingsClass))

typedef struct _GalaBehaviorSettings GalaBehaviorSettings;
typedef struct _GalaBehaviorSettingsClass GalaBehaviorSettingsClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block40Data Block40Data;

struct _GalaWindowSwitcher {
	ClutterActor parent_instance;
	GalaWindowSwitcherPrivate * priv;
};

struct _GalaWindowSwitcherClass {
	ClutterActorClass parent_class;
};

struct _GalaWindowSwitcherPrivate {
	GalaWindowManager* _wm;
	GalaWindowIcon* current_window;
	ClutterActor* window_clones;
	GList* clone_sort_order;
	MetaWindowActor* dock_window;
	ClutterActor* dock;
	PlankSurface* dock_surface;
	PlankDockTheme* dock_theme;
	PlankDockPreferences* dock_settings;
	gfloat dock_y_offset;
	gfloat dock_height_offset;
	GFileMonitor* monitor;
	ClutterActor* background;
	guint modifier_mask;
	gint64 last_switch;
	gboolean closing;
	GalaModalProxy* modal_proxy;
	gfloat dock_width;
	gint n_dock_items;
};

struct _Block40Data {
	int _ref_count_;
	GalaWindowSwitcher* self;
	ClutterCanvas* dock_canvas;
};


static gpointer gala_window_switcher_parent_class = NULL;

GType gala_window_switcher_get_type (void) G_GNUC_CONST;
#define GALA_WINDOW_SWITCHER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherPrivate))
GalaWindowManager* gala_window_switcher_get_wm (GalaWindowSwitcher* self);
static void gala_window_switcher_update_actors (GalaWindowSwitcher* self);
static void _gala_window_switcher_update_actors_meta_screen_monitors_changed (MetaScreen* _sender, gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
#define GALA_WINDOW_SWITCHER_MIN_DELTA 100
#define GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY 155.0f
#define GALA_WINDOW_SWITCHER_DIM_WINDOW_BRIGHTNESS ((-GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY) / 255.0f)
GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm);
GalaWindowSwitcher* gala_window_switcher_construct (GType object_type, GalaWindowManager* wm);
static void gala_window_switcher_load_dock_theme (GalaWindowSwitcher* self);
static void gala_window_switcher_update_dock (GalaWindowSwitcher* self);
static void _gala_window_switcher_update_dock_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void gala_window_switcher_update_background (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_draw_dock_background (GalaWindowSwitcher* self, cairo_t* cr);
static void gala_window_switcher_place_dock (GalaWindowSwitcher* self);
static void gala_window_switcher_animate_dock_width (GalaWindowSwitcher* self);
static void gala_window_switcher_show_background (GalaWindowSwitcher* self);
static void gala_window_switcher_hide_background (GalaWindowSwitcher* self);
static gboolean gala_window_switcher_clicked_icon (GalaWindowSwitcher* self, ClutterButtonEvent* event);
static void gala_window_switcher_dim_windows (GalaWindowSwitcher* self);
static gboolean ___lambda32_ (GalaWindowSwitcher* self);
static void gala_window_switcher_close (GalaWindowSwitcher* self, guint time);
static gboolean ____lambda32__gsource_func (gpointer self);
static void gala_window_switcher_window_removed (GalaWindowSwitcher* self, ClutterActor* actor);
static void gala_window_switcher_icon_removed (GalaWindowSwitcher* self, ClutterActor* actor);
static gboolean gala_window_switcher_real_key_release_event (ClutterActor* base, ClutterKeyEvent* event);
static GdkModifierType gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self);
static void gala_window_switcher_real_key_focus_out (ClutterActor* base);
void gala_window_switcher_handle_switch_windows (MetaDisplay* display, MetaScreen* screen, MetaWindow* window, ClutterKeyEvent* event, MetaKeyBinding* binding, GalaWindowSwitcher* self);
static void gala_window_switcher_close_cleanup (GalaWindowSwitcher* self);
static GalaWindowIcon* gala_window_switcher_next_window (GalaWindowSwitcher* self, MetaWorkspace* workspace, gboolean backward);
static gboolean gala_window_switcher_collect_windows (GalaWindowSwitcher* self, MetaWorkspace* workspace);
static void gala_window_switcher_set_primary_modifier (GalaWindowSwitcher* self, guint mask);
static gboolean __lambda34_ (GalaWindowSwitcher* self, MetaKeyBinding* binding);
static gboolean ___lambda34__gala_keybinding_filter (MetaKeyBinding* binding, gpointer self);
GType gala_safe_window_clone_get_type (void) G_GNUC_CONST;
MetaWindow* gala_safe_window_clone_get_window (GalaSafeWindowClone* self);
static void ___lambda33_ (GalaWindowSwitcher* self);
static void ____lambda33__clutter_timeline_completed (ClutterTimeline* _sender, gpointer self);
static GalaWindowIcon* gala_window_switcher_add_window (GalaWindowSwitcher* self, MetaWindow* window);
GalaSafeWindowClone* gala_safe_window_clone_new (MetaWindow* window, gboolean destroy_on_unmanaged);
GalaSafeWindowClone* gala_safe_window_clone_construct (GType object_type, MetaWindow* window, gboolean destroy_on_unmanaged);
static gboolean _gala_window_switcher_clicked_icon_clutter_actor_button_release_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self);
GType gala_behavior_settings_get_type (void) G_GNUC_CONST;
GalaBehaviorSettings* gala_behavior_settings_get_default (void);
gchar** gala_behavior_settings_get_dock_names (GalaBehaviorSettings* self, int* result_length1);
static gboolean _vala_string_array_contains (gchar* * stack, int stack_length, gchar* needle);
static void gala_window_switcher_update_n_dock_items (GalaWindowSwitcher* self, GFile* folder, GFile* other_file, GFileMonitorEvent event);
static void gala_window_switcher_set_wm (GalaWindowSwitcher* self, GalaWindowManager* value);
static GObject * gala_window_switcher_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static Block40Data* block40_data_ref (Block40Data* _data40_);
static void block40_data_unref (void * _userdata_);
static void _gala_window_switcher_load_dock_theme_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _gala_window_switcher_update_n_dock_items_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static gboolean _gala_window_switcher_draw_dock_background_clutter_canvas_draw (ClutterCanvas* _sender, cairo_t* cr, gint width, gint height, gpointer self);
static void _gala_window_switcher_icon_removed_clutter_container_actor_removed (ClutterContainer* _sender, ClutterActor* actor, gpointer self);
static void _gala_window_switcher___lambda35_ (Block40Data* _data40_);
static void __gala_window_switcher___lambda35__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _gala_window_switcher_window_removed_clutter_container_actor_removed (ClutterContainer* _sender, ClutterActor* actor, gpointer self);
static void gala_window_switcher_finalize (GObject * obj);
static void _vala_gala_window_switcher_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_window_switcher_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _gala_window_switcher_update_actors_meta_screen_monitors_changed (MetaScreen* _sender, gpointer self) {
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_actors ((GalaWindowSwitcher*) self);
#line 200 "WindowSwitcher.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 207 "WindowSwitcher.c"
}


static inline void _g_list_free__g_object_unref0_ (GList* self) {
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 214 "WindowSwitcher.c"
}


GalaWindowSwitcher* gala_window_switcher_construct (GType object_type, GalaWindowManager* wm) {
	GalaWindowSwitcher * self = NULL;
	GalaWindowManager* _tmp0_;
#line 56 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = wm;
#line 58 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) g_object_new (object_type, "wm", _tmp0_, NULL);
#line 56 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return self;
#line 229 "WindowSwitcher.c"
}


GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm) {
#line 56 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return gala_window_switcher_construct (GALA_TYPE_WINDOW_SWITCHER, wm);
#line 236 "WindowSwitcher.c"
}


static void _gala_window_switcher_update_dock_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_dock ((GalaWindowSwitcher*) self);
#line 243 "WindowSwitcher.c"
}


static void gala_window_switcher_load_dock_theme (GalaWindowSwitcher* self) {
	PlankDockTheme* _tmp0_;
	PlankDockPreferences* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	PlankDockTheme* _tmp6_;
	PlankDockTheme* _tmp7_;
	PlankDockTheme* _tmp8_;
#line 117 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 119 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock_theme;
#line 119 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 261 "WindowSwitcher.c"
		PlankDockTheme* _tmp1_;
		guint _tmp2_;
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp1_ = self->priv->dock_theme;
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE);
#line 120 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_window_switcher_update_dock_g_object_notify, self);
#line 270 "WindowSwitcher.c"
	}
#line 122 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->dock_settings;
#line 122 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = plank_dock_preferences_get_Theme (_tmp3_);
#line 122 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _tmp4_;
#line 122 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = plank_dock_theme_new (_tmp5_);
#line 122 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_theme);
#line 122 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->dock_theme = _tmp6_;
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = self->priv->dock_theme;
#line 123 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	plank_theme_load ((PlankTheme*) _tmp7_, "dock");
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = self->priv->dock_theme;
#line 124 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify", (GCallback) _gala_window_switcher_update_dock_g_object_notify, self, 0);
#line 126 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_dock (self);
#line 294 "WindowSwitcher.c"
}


/**
 * set the values which don't get set every time and need to be updated when the theme changes
 */
static gpointer _g_object_ref0 (gpointer self) {
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 304 "WindowSwitcher.c"
}


static void gala_window_switcher_update_dock (GalaWindowSwitcher* self) {
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaRectangle geometry = {0};
	MetaScreen* _tmp3_;
	MetaScreen* _tmp4_;
	gint _tmp5_;
	MetaRectangle _tmp6_ = {0};
	ClutterBoxLayout* layout = NULL;
	ClutterActor* _tmp7_;
	ClutterLayoutManager* _tmp8_;
	ClutterLayoutManager* _tmp9_;
	ClutterBoxLayout* _tmp10_;
	GtkPositionType position = 0;
	PlankDockPreferences* _tmp11_;
	GtkPositionType _tmp12_;
	GtkPositionType _tmp13_;
	gint icon_size = 0;
	PlankDockPreferences* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gfloat scaled_icon_size = 0.0F;
	gint _tmp17_;
	gboolean horizontal = FALSE;
	PlankDockPreferences* _tmp18_;
	gboolean _tmp19_;
	gfloat top_padding = 0.0F;
	PlankDockTheme* _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gfloat _tmp23_;
	gfloat bottom_padding = 0.0F;
	PlankDockTheme* _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	gfloat _tmp27_;
	gfloat item_padding = 0.0F;
	PlankDockTheme* _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gfloat _tmp31_;
	gint line_width = 0;
	PlankDockTheme* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gfloat top_offset = 0.0F;
	gint _tmp35_;
	gfloat _tmp36_;
	gint _tmp37_ = 0;
	PlankDockTheme* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	gfloat bottom_offset = 0.0F;
	gfloat _tmp42_;
	ClutterBoxLayout* _tmp43_;
	gfloat _tmp44_;
	ClutterOrientation _tmp45_ = 0;
	gboolean _tmp46_;
	ClutterBoxLayout* _tmp47_;
	gfloat _tmp48_;
	gfloat _tmp49_;
	gfloat _tmp50_;
	gfloat _tmp51_ = 0.0F;
	gfloat _tmp52_;
	gfloat height = 0.0F;
	gint _tmp54_;
	gfloat _tmp55_;
	gboolean _tmp56_;
	GtkPositionType _tmp73_;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 134 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	screen = _tmp2_;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = screen;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = screen;
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = meta_screen_get_primary_monitor (_tmp4_);
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	meta_screen_get_monitor_geometry (_tmp3_, _tmp5_, &_tmp6_);
#line 135 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	geometry = _tmp6_;
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = self->priv->dock;
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = clutter_actor_get_layout_manager (_tmp7_);
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp9_ = _tmp8_;
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, clutter_box_layout_get_type (), ClutterBoxLayout));
#line 136 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	layout = _tmp10_;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp11_ = self->priv->dock_settings;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp12_ = plank_dock_preferences_get_Position (_tmp11_);
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp13_ = _tmp12_;
#line 138 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	position = _tmp13_;
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp14_ = self->priv->dock_settings;
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp15_ = plank_dock_preferences_get_IconSize (_tmp14_);
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp16_ = _tmp15_;
#line 139 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	icon_size = _tmp16_;
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp17_ = icon_size;
#line 140 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	scaled_icon_size = _tmp17_ / 10.0f;
#line 141 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp18_ = self->priv->dock_settings;
#line 141 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp19_ = plank_dock_preferences_is_horizontal_dock (_tmp18_);
#line 141 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	horizontal = _tmp19_;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp20_ = self->priv->dock_theme;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp21_ = plank_dock_theme_get_TopPadding (_tmp20_);
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp22_ = _tmp21_;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp23_ = scaled_icon_size;
#line 143 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	top_padding = ((gfloat) _tmp22_) * _tmp23_;
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp24_ = self->priv->dock_theme;
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp25_ = plank_dock_theme_get_BottomPadding (_tmp24_);
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp26_ = _tmp25_;
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp27_ = scaled_icon_size;
#line 144 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	bottom_padding = ((gfloat) _tmp26_) * _tmp27_;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp28_ = self->priv->dock_theme;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp29_ = plank_dock_theme_get_ItemPadding (_tmp28_);
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp30_ = _tmp29_;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp31_ = scaled_icon_size;
#line 145 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	item_padding = ((gfloat) _tmp30_) * _tmp31_;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp32_ = self->priv->dock_theme;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp33_ = plank_theme_get_LineWidth ((PlankTheme*) _tmp32_);
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp34_ = _tmp33_;
#line 146 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	line_width = _tmp34_;
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp35_ = line_width;
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp36_ = top_padding;
#line 148 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	top_offset = (2 * _tmp35_) + _tmp36_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp38_ = self->priv->dock_theme;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp39_ = plank_theme_get_BottomRoundness ((PlankTheme*) _tmp38_);
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp40_ = _tmp39_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp40_ > 0) {
#line 487 "WindowSwitcher.c"
		gint _tmp41_;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp41_ = line_width;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp37_ = 2 * _tmp41_;
#line 493 "WindowSwitcher.c"
	} else {
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp37_ = 0;
#line 497 "WindowSwitcher.c"
	}
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp42_ = bottom_padding;
#line 149 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	bottom_offset = _tmp37_ + _tmp42_;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp43_ = layout;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp44_ = item_padding;
#line 151 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_box_layout_set_spacing (_tmp43_, (guint) _tmp44_);
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp46_ = horizontal;
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp46_) {
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp45_ = CLUTTER_ORIENTATION_HORIZONTAL;
#line 515 "WindowSwitcher.c"
	} else {
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp45_ = CLUTTER_ORIENTATION_VERTICAL;
#line 519 "WindowSwitcher.c"
	}
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp47_ = layout;
#line 152 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_box_layout_set_orientation (_tmp47_, _tmp45_);
#line 154 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp48_ = top_offset;
#line 154 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->dock_y_offset = -_tmp48_;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp49_ = top_offset;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp50_ = bottom_offset;
#line 155 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->dock_height_offset = _tmp49_ + _tmp50_;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp52_ = top_offset;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp52_ > ((gfloat) 0)) {
#line 539 "WindowSwitcher.c"
		gfloat _tmp53_;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp53_ = top_offset;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp51_ = _tmp53_;
#line 545 "WindowSwitcher.c"
	} else {
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp51_ = (gfloat) 0;
#line 549 "WindowSwitcher.c"
	}
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp54_ = icon_size;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp55_ = bottom_offset;
#line 157 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	height = (_tmp54_ + _tmp51_) + _tmp55_;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp56_ = horizontal;
#line 159 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp56_) {
#line 561 "WindowSwitcher.c"
		ClutterActor* _tmp57_;
		gfloat _tmp58_;
		ClutterActor* _tmp59_;
		MetaRectangle _tmp60_;
		gint _tmp61_;
		MetaRectangle _tmp62_;
		gint _tmp63_;
		gfloat _tmp64_;
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp57_ = self->priv->dock;
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp58_ = height;
#line 160 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_height (_tmp57_, _tmp58_);
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp59_ = self->priv->dock;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp60_ = geometry;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp61_ = _tmp60_.x;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp62_ = geometry;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp63_ = _tmp62_.width;
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp64_ = ceilf (_tmp61_ + (_tmp63_ / 2.0f));
#line 161 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_x (_tmp59_, _tmp64_);
#line 590 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp65_;
		gfloat _tmp66_;
		ClutterActor* _tmp67_;
		MetaRectangle _tmp68_;
		gint _tmp69_;
		MetaRectangle _tmp70_;
		gint _tmp71_;
		gfloat _tmp72_;
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp65_ = self->priv->dock;
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp66_ = height;
#line 163 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp65_, _tmp66_);
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp67_ = self->priv->dock;
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp68_ = geometry;
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp69_ = _tmp68_.y;
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp70_ = geometry;
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp71_ = _tmp70_.height;
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp72_ = ceilf (_tmp69_ + (_tmp71_ / 2.0f));
#line 164 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_y (_tmp67_, _tmp72_);
#line 620 "WindowSwitcher.c"
	}
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp73_ = position;
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	switch (_tmp73_) {
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_TOP:
#line 628 "WindowSwitcher.c"
		{
			ClutterActor* _tmp74_;
			MetaRectangle _tmp75_;
			gint _tmp76_;
			gfloat _tmp77_;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp74_ = self->priv->dock;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp75_ = geometry;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp76_ = _tmp75_.y;
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp77_ = ceilf ((gfloat) _tmp76_);
#line 169 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			clutter_actor_set_y (_tmp74_, _tmp77_);
#line 170 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 646 "WindowSwitcher.c"
		}
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_BOTTOM:
#line 650 "WindowSwitcher.c"
		{
			ClutterActor* _tmp78_;
			MetaRectangle _tmp79_;
			gint _tmp80_;
			MetaRectangle _tmp81_;
			gint _tmp82_;
			gfloat _tmp83_;
			gfloat _tmp84_;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp78_ = self->priv->dock;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp79_ = geometry;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp80_ = _tmp79_.y;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp81_ = geometry;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp82_ = _tmp81_.height;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp83_ = height;
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp84_ = ceilf ((_tmp80_ + _tmp82_) - _tmp83_);
#line 172 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			clutter_actor_set_y (_tmp78_, _tmp84_);
#line 173 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 677 "WindowSwitcher.c"
		}
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_LEFT:
#line 681 "WindowSwitcher.c"
		{
			ClutterActor* _tmp85_;
			MetaRectangle _tmp86_;
			gint _tmp87_;
			gfloat _tmp88_;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp85_ = self->priv->dock;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp86_ = geometry;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp87_ = _tmp86_.x;
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp88_ = ceilf ((gfloat) _tmp87_);
#line 175 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			clutter_actor_set_x (_tmp85_, _tmp88_);
#line 176 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 699 "WindowSwitcher.c"
		}
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_RIGHT:
#line 703 "WindowSwitcher.c"
		{
			ClutterActor* _tmp89_;
			MetaRectangle _tmp90_;
			gint _tmp91_;
			MetaRectangle _tmp92_;
			gint _tmp93_;
			gfloat _tmp94_;
			gfloat _tmp95_;
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp89_ = self->priv->dock;
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp90_ = geometry;
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp91_ = _tmp90_.x;
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp92_ = geometry;
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp93_ = _tmp92_.width;
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp94_ = height;
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp95_ = ceilf ((_tmp91_ + _tmp93_) - _tmp94_);
#line 178 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			clutter_actor_set_x (_tmp89_, _tmp95_);
#line 179 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 730 "WindowSwitcher.c"
		}
		default:
#line 167 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		break;
#line 735 "WindowSwitcher.c"
	}
#line 182 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_surface);
#line 182 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->dock_surface = NULL;
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (layout);
#line 132 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (screen);
#line 745 "WindowSwitcher.c"
}


static void gala_window_switcher_update_background (GalaWindowSwitcher* self) {
	gint width = 0;
	gint height = 0;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	ClutterActor* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 185 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	width = 0;
#line 187 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	height = 0;
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	meta_screen_get_size (_tmp1_, &_tmp2_, &_tmp3_);
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	width = _tmp2_;
#line 188 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	height = _tmp3_;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->background;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = width;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = height;
#line 190 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_size (_tmp4_, (gfloat) _tmp5_, (gfloat) _tmp6_);
#line 783 "WindowSwitcher.c"
}


static void gala_window_switcher_update_actors (GalaWindowSwitcher* self) {
#line 193 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 195 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_dock (self);
#line 196 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_background (self);
#line 794 "WindowSwitcher.c"
}


static gboolean gala_window_switcher_draw_dock_background (GalaWindowSwitcher* self, cairo_t* cr) {
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	GtkPositionType position = 0;
	PlankDockPreferences* _tmp3_;
	GtkPositionType _tmp4_;
	GtkPositionType _tmp5_;
	gint width = 0;
	ClutterActor* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gint height = 0;
	ClutterActor* _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	GtkPositionType _tmp12_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	PlankSurface* _tmp23_;
	gfloat x = 0.0F;
	gfloat y = 0.0F;
	GtkPositionType _tmp41_;
	cairo_t* _tmp44_;
	PlankSurface* _tmp45_;
	cairo_surface_t* _tmp46_;
	cairo_surface_t* _tmp47_;
	gfloat _tmp48_;
	gfloat _tmp49_;
	cairo_t* _tmp50_;
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 199 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 201 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = cr;
#line 201 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	cairo_set_operator (_tmp0_, CAIRO_OPERATOR_CLEAR);
#line 202 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = cr;
#line 202 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	cairo_paint (_tmp1_);
#line 203 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = cr;
#line 203 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	cairo_set_operator (_tmp2_, CAIRO_OPERATOR_OVER);
#line 205 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->dock_settings;
#line 205 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = plank_dock_preferences_get_Position (_tmp3_);
#line 205 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _tmp4_;
#line 205 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	position = _tmp5_;
#line 207 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = self->priv->dock;
#line 207 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = clutter_actor_get_width (_tmp6_);
#line 207 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 207 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	width = (gint) _tmp8_;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp9_ = self->priv->dock;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp10_ = clutter_actor_get_height (_tmp9_);
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp11_ = _tmp10_;
#line 208 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	height = (gint) _tmp11_;
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp12_ = position;
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	switch (_tmp12_) {
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_RIGHT:
#line 875 "WindowSwitcher.c"
		{
			gint _tmp13_;
			gfloat _tmp14_;
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp13_ = width;
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp14_ = self->priv->dock_height_offset;
#line 212 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			width = _tmp13_ + ((gint) _tmp14_);
#line 213 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 887 "WindowSwitcher.c"
		}
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_LEFT:
#line 891 "WindowSwitcher.c"
		{
			gint _tmp15_;
			gfloat _tmp16_;
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp15_ = width;
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp16_ = self->priv->dock_y_offset;
#line 215 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			width = _tmp15_ - ((gint) _tmp16_);
#line 216 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 903 "WindowSwitcher.c"
		}
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_TOP:
#line 907 "WindowSwitcher.c"
		{
			gint _tmp17_;
			gfloat _tmp18_;
#line 218 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp17_ = height;
#line 218 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp18_ = self->priv->dock_y_offset;
#line 218 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			height = _tmp17_ - ((gint) _tmp18_);
#line 219 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 919 "WindowSwitcher.c"
		}
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_BOTTOM:
#line 923 "WindowSwitcher.c"
		{
			gint _tmp19_;
			gfloat _tmp20_;
#line 221 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp19_ = height;
#line 221 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp20_ = self->priv->dock_height_offset;
#line 221 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			height = _tmp19_ + ((gint) _tmp20_);
#line 222 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 935 "WindowSwitcher.c"
		}
		default:
#line 210 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		break;
#line 940 "WindowSwitcher.c"
	}
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp23_ = self->priv->dock_surface;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp23_ == NULL) {
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp22_ = TRUE;
#line 948 "WindowSwitcher.c"
	} else {
		PlankSurface* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp24_ = self->priv->dock_surface;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp25_ = plank_surface_get_Width (_tmp24_);
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp26_ = _tmp25_;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp27_ = width;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp22_ = _tmp26_ != _tmp27_;
#line 964 "WindowSwitcher.c"
	}
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp22_) {
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp21_ = TRUE;
#line 970 "WindowSwitcher.c"
	} else {
		PlankSurface* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp28_ = self->priv->dock_surface;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp29_ = plank_surface_get_Height (_tmp28_);
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp30_ = _tmp29_;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp31_ = height;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp21_ = _tmp30_ != _tmp31_;
#line 986 "WindowSwitcher.c"
	}
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp21_) {
#line 990 "WindowSwitcher.c"
		PlankSurface* dummy_surface = NULL;
		cairo_t* _tmp32_;
		cairo_surface_t* _tmp33_;
		PlankSurface* _tmp34_;
		PlankDockTheme* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		GtkPositionType _tmp38_;
		PlankSurface* _tmp39_;
		PlankSurface* _tmp40_;
#line 226 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp32_ = cr;
#line 226 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp33_ = cairo_get_target (_tmp32_);
#line 226 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp34_ = plank_surface_new_with_cairo_surface (1, 1, _tmp33_);
#line 226 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		dummy_surface = _tmp34_;
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp35_ = self->priv->dock_theme;
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp36_ = width;
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp37_ = height;
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp38_ = position;
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp39_ = dummy_surface;
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp40_ = plank_dock_theme_create_background (_tmp35_, _tmp36_, _tmp37_, _tmp38_, _tmp39_);
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->dock_surface);
#line 228 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->dock_surface = _tmp40_;
#line 225 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (dummy_surface);
#line 1027 "WindowSwitcher.c"
	}
#line 231 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	x = (gfloat) 0;
#line 231 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	y = (gfloat) 0;
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp41_ = position;
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	switch (_tmp41_) {
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_RIGHT:
#line 1039 "WindowSwitcher.c"
		{
			gfloat _tmp42_;
#line 234 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp42_ = self->priv->dock_y_offset;
#line 234 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			x = _tmp42_;
#line 235 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 1048 "WindowSwitcher.c"
		}
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_BOTTOM:
#line 1052 "WindowSwitcher.c"
		{
			gfloat _tmp43_;
#line 237 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp43_ = self->priv->dock_y_offset;
#line 237 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			y = _tmp43_;
#line 238 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 1061 "WindowSwitcher.c"
		}
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_LEFT:
#line 1065 "WindowSwitcher.c"
		{
#line 240 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			x = (gfloat) 0;
#line 241 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 1071 "WindowSwitcher.c"
		}
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GTK_POS_TOP:
#line 1075 "WindowSwitcher.c"
		{
#line 243 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			y = (gfloat) 0;
#line 244 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			break;
#line 1081 "WindowSwitcher.c"
		}
		default:
#line 232 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		break;
#line 1086 "WindowSwitcher.c"
	}
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp44_ = cr;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp45_ = self->priv->dock_surface;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp46_ = plank_surface_get_Internal (_tmp45_);
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp47_ = _tmp46_;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp48_ = x;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp49_ = y;
#line 247 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	cairo_set_source_surface (_tmp44_, _tmp47_, (gdouble) _tmp48_, (gdouble) _tmp49_);
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp50_ = cr;
#line 248 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	cairo_paint (_tmp50_);
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = FALSE;
#line 250 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 1110 "WindowSwitcher.c"
}


static void gala_window_switcher_place_dock (GalaWindowSwitcher* self) {
	gint icon_size = 0;
	PlankDockPreferences* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gfloat scaled_icon_size = 0.0F;
	gint _tmp3_;
	gint line_width = 0;
	PlankDockTheme* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gdouble horiz_padding = 0.0;
	PlankDockTheme* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gfloat _tmp10_;
	gfloat item_padding = 0.0F;
	PlankDockTheme* _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gfloat _tmp14_;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_;
	gint items_offset = 0;
	gint _tmp18_;
	gint _tmp19_;
	PlankDockPreferences* _tmp29_;
	gboolean _tmp30_;
	ClutterActor* _tmp53_;
#line 253 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock_settings;
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = plank_dock_preferences_get_IconSize (_tmp0_);
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _tmp1_;
#line 255 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	icon_size = _tmp2_;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = icon_size;
#line 256 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	scaled_icon_size = _tmp3_ / 10.0f;
#line 257 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->dock_theme;
#line 257 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = plank_theme_get_LineWidth ((PlankTheme*) _tmp4_);
#line 257 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = _tmp5_;
#line 257 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	line_width = _tmp6_;
#line 258 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = self->priv->dock_theme;
#line 258 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = plank_dock_theme_get_HorizPadding (_tmp7_);
#line 258 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp9_ = _tmp8_;
#line 258 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp10_ = scaled_icon_size;
#line 258 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	horiz_padding = _tmp9_ * _tmp10_;
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp11_ = self->priv->dock_theme;
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp12_ = plank_dock_theme_get_ItemPadding (_tmp11_);
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp13_ = _tmp12_;
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp14_ = scaled_icon_size;
#line 259 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	item_padding = ((gfloat) _tmp13_) * _tmp14_;
#line 260 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp16_ = horiz_padding;
#line 260 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp16_ > ((gdouble) 0)) {
#line 1189 "WindowSwitcher.c"
		gdouble _tmp17_;
#line 260 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp17_ = horiz_padding;
#line 260 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp15_ = _tmp17_;
#line 1195 "WindowSwitcher.c"
	} else {
#line 260 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp15_ = (gdouble) 0;
#line 1199 "WindowSwitcher.c"
	}
#line 260 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp18_ = line_width;
#line 260 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	items_offset = (gint) ((2 * _tmp18_) + _tmp15_);
#line 262 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp19_ = self->priv->n_dock_items;
#line 262 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp19_ > 0) {
#line 1209 "WindowSwitcher.c"
		gint _tmp20_;
		gfloat _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp20_ = self->priv->n_dock_items;
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp21_ = item_padding;
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp22_ = icon_size;
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp23_ = items_offset;
#line 263 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->dock_width = (_tmp20_ * (_tmp21_ + _tmp22_)) + (_tmp23_ * 2);
#line 1224 "WindowSwitcher.c"
	} else {
		gfloat _tmp24_ = 0.0F;
		MetaWindowActor* _tmp25_;
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp25_ = self->priv->dock_window;
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		if (_tmp25_ != NULL) {
#line 1232 "WindowSwitcher.c"
			MetaWindowActor* _tmp26_;
			gfloat _tmp27_;
			gfloat _tmp28_;
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp26_ = self->priv->dock_window;
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp27_ = clutter_actor_get_width ((ClutterActor*) _tmp26_);
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp28_ = _tmp27_;
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp24_ = _tmp28_;
#line 1244 "WindowSwitcher.c"
		} else {
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp24_ = 300.0f;
#line 1248 "WindowSwitcher.c"
		}
#line 265 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->dock_width = _tmp24_;
#line 1252 "WindowSwitcher.c"
	}
#line 267 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp29_ = self->priv->dock_settings;
#line 267 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp30_ = plank_dock_preferences_is_horizontal_dock (_tmp29_);
#line 267 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp30_) {
#line 1260 "WindowSwitcher.c"
		ClutterActor* _tmp31_;
		gfloat _tmp32_;
		ClutterActor* _tmp33_;
		gfloat _tmp34_;
		gfloat _tmp35_;
		ClutterActor* _tmp36_;
		ClutterActor* _tmp37_;
		gint _tmp38_;
		ClutterActor* _tmp39_;
		ClutterActor* _tmp40_;
		gint _tmp41_;
#line 268 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp31_ = self->priv->dock;
#line 268 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp32_ = self->priv->dock_width;
#line 268 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp31_, _tmp32_);
#line 269 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp33_ = self->priv->dock;
#line 269 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp34_ = self->priv->dock_width;
#line 269 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp35_ = ceilf ((-_tmp34_) / 2.0f);
#line 269 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp33_, "translation-x", _tmp35_, NULL);
#line 270 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp36_ = self->priv->dock;
#line 270 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp37_ = clutter_actor_get_first_child (_tmp36_);
#line 270 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp38_ = items_offset;
#line 270 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_margin_left (_tmp37_, (gfloat) _tmp38_);
#line 271 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp39_ = self->priv->dock;
#line 271 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp40_ = clutter_actor_get_last_child (_tmp39_);
#line 271 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp41_ = items_offset;
#line 271 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_margin_right (_tmp40_, (gfloat) _tmp41_);
#line 1302 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp42_;
		gfloat _tmp43_;
		ClutterActor* _tmp44_;
		gfloat _tmp45_;
		gfloat _tmp46_;
		ClutterActor* _tmp47_;
		ClutterActor* _tmp48_;
		gint _tmp49_;
		ClutterActor* _tmp50_;
		ClutterActor* _tmp51_;
		gint _tmp52_;
#line 273 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp42_ = self->priv->dock;
#line 273 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp43_ = self->priv->dock_width;
#line 273 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_height (_tmp42_, _tmp43_);
#line 274 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp44_ = self->priv->dock;
#line 274 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp45_ = self->priv->dock_width;
#line 274 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp46_ = ceilf ((-_tmp45_) / 2.0f);
#line 274 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp44_, "translation-y", _tmp46_, NULL);
#line 275 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp47_ = self->priv->dock;
#line 275 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp48_ = clutter_actor_get_first_child (_tmp47_);
#line 275 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp49_ = items_offset;
#line 275 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_margin_top (_tmp48_, (gfloat) _tmp49_);
#line 276 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp50_ = self->priv->dock;
#line 276 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp51_ = clutter_actor_get_last_child (_tmp50_);
#line 276 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp52_ = items_offset;
#line 276 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_margin_bottom (_tmp51_, (gfloat) _tmp52_);
#line 1345 "WindowSwitcher.c"
	}
#line 279 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp53_ = self->priv->dock;
#line 279 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity (_tmp53_, (guint) 255);
#line 1351 "WindowSwitcher.c"
}


static void gala_window_switcher_animate_dock_width (GalaWindowSwitcher* self) {
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	gfloat dest_width = 0.0F;
	PlankDockPreferences* _tmp3_;
	gboolean _tmp4_;
	ClutterActor* _tmp31_;
#line 282 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock;
#line 284 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_save_easing_state (_tmp0_);
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->dock;
#line 285 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->dock;
#line 286 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
#line 289 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->dock_settings;
#line 289 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = plank_dock_preferences_is_horizontal_dock (_tmp3_);
#line 289 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp4_) {
#line 1383 "WindowSwitcher.c"
		ClutterActor* _tmp5_;
		ClutterLayoutManager* _tmp6_;
		ClutterLayoutManager* _tmp7_;
		ClutterActor* _tmp8_;
		ClutterActor* _tmp9_;
		gfloat _tmp10_;
		gfloat _tmp11_;
		gfloat _tmp12_ = 0.0F;
		ClutterActor* _tmp13_;
		gfloat _tmp14_;
		ClutterActor* _tmp15_;
		gfloat _tmp16_;
		gfloat _tmp17_;
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp5_ = self->priv->dock;
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp6_ = clutter_actor_get_layout_manager (_tmp5_);
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp7_ = _tmp6_;
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp8_ = self->priv->dock;
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp9_ = self->priv->dock;
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp10_ = clutter_actor_get_height (_tmp9_);
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp11_ = _tmp10_;
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_layout_manager_get_preferred_width (_tmp7_, (ClutterContainer*) _tmp8_, _tmp11_, NULL, &_tmp12_);
#line 290 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		dest_width = _tmp12_;
#line 291 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp13_ = self->priv->dock;
#line 291 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp14_ = dest_width;
#line 291 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp13_, _tmp14_);
#line 292 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp15_ = self->priv->dock;
#line 292 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp16_ = dest_width;
#line 292 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp17_ = ceilf ((-_tmp16_) / 2.0f);
#line 292 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp15_, "translation-x", _tmp17_, NULL);
#line 1429 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp18_;
		ClutterLayoutManager* _tmp19_;
		ClutterLayoutManager* _tmp20_;
		ClutterActor* _tmp21_;
		ClutterActor* _tmp22_;
		gfloat _tmp23_;
		gfloat _tmp24_;
		gfloat _tmp25_ = 0.0F;
		ClutterActor* _tmp26_;
		gfloat _tmp27_;
		ClutterActor* _tmp28_;
		gfloat _tmp29_;
		gfloat _tmp30_;
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp18_ = self->priv->dock;
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp19_ = clutter_actor_get_layout_manager (_tmp18_);
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp20_ = _tmp19_;
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp21_ = self->priv->dock;
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp22_ = self->priv->dock;
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp23_ = clutter_actor_get_width (_tmp22_);
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp24_ = _tmp23_;
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_layout_manager_get_preferred_height (_tmp20_, (ClutterContainer*) _tmp21_, _tmp24_, NULL, &_tmp25_);
#line 294 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		dest_width = _tmp25_;
#line 295 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp26_ = self->priv->dock;
#line 295 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp27_ = dest_width;
#line 295 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_height (_tmp26_, _tmp27_);
#line 296 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp28_ = self->priv->dock;
#line 296 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp29_ = dest_width;
#line 296 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp30_ = ceilf ((-_tmp29_) / 2.0f);
#line 296 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp28_, "translation-y", _tmp30_, NULL);
#line 1476 "WindowSwitcher.c"
	}
#line 299 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp31_ = self->priv->dock;
#line 299 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_restore_easing_state (_tmp31_);
#line 1482 "WindowSwitcher.c"
}


static void gala_window_switcher_show_background (GalaWindowSwitcher* self) {
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
#line 302 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 304 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->background;
#line 304 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_save_easing_state (_tmp0_);
#line 305 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->background;
#line 305 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
#line 306 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->background;
#line 306 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
#line 307 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->background;
#line 307 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity (_tmp3_, (guint) GALA_WINDOW_SWITCHER_BACKGROUND_OPACITY);
#line 308 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->background;
#line 308 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_restore_easing_state (_tmp4_);
#line 1514 "WindowSwitcher.c"
}


static void gala_window_switcher_hide_background (GalaWindowSwitcher* self) {
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
#line 311 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 313 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->background;
#line 313 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_save_easing_state (_tmp0_);
#line 314 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->background;
#line 314 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_duration (_tmp1_, (guint) 250);
#line 315 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->background;
#line 315 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_mode (_tmp2_, CLUTTER_EASE_OUT_CUBIC);
#line 316 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = self->priv->background;
#line 316 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity (_tmp3_, (guint) 0);
#line 317 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->background;
#line 317 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_restore_easing_state (_tmp4_);
#line 1546 "WindowSwitcher.c"
}


static gboolean ___lambda32_ (GalaWindowSwitcher* self) {
	gboolean result = FALSE;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	guint32 _tmp3_;
#line 329 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 329 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 329 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = meta_screen_get_display (_tmp1_);
#line 329 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = meta_display_get_current_time (_tmp2_);
#line 329 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_close (self, (guint) _tmp3_);
#line 330 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = FALSE;
#line 330 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 1570 "WindowSwitcher.c"
}


static gboolean ____lambda32__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda32_ ((GalaWindowSwitcher*) self);
#line 328 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 1579 "WindowSwitcher.c"
}


static gboolean gala_window_switcher_clicked_icon (GalaWindowSwitcher* self, ClutterButtonEvent* event) {
	gboolean result = FALSE;
	GalaWindowIcon* icon = NULL;
	ClutterButtonEvent* _tmp0_;
	ClutterActor* _tmp1_;
	GalaWindowIcon* _tmp2_;
	GalaWindowIcon* _tmp3_;
#line 320 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 320 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 321 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = event;
#line 321 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = _tmp0_->source;
#line 321 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 323 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->current_window;
#line 323 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = icon;
#line 323 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp2_ != _tmp3_) {
#line 1606 "WindowSwitcher.c"
		GalaWindowIcon* _tmp4_;
		GalaWindowIcon* _tmp5_;
#line 324 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp4_ = icon;
#line 324 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 324 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 324 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = _tmp5_;
#line 325 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_dim_windows (self);
#line 328 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ____lambda32__gsource_func, g_object_ref (self), g_object_unref);
#line 1621 "WindowSwitcher.c"
	} else {
		ClutterButtonEvent* _tmp6_;
		guint32 _tmp7_;
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp6_ = event;
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp7_ = _tmp6_->time;
#line 333 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close (self, (guint) _tmp7_);
#line 1631 "WindowSwitcher.c"
	}
#line 335 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = TRUE;
#line 335 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 1637 "WindowSwitcher.c"
}


static void gala_window_switcher_window_removed (GalaWindowSwitcher* self, ClutterActor* actor) {
	ClutterActor* _tmp0_;
#line 338 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 338 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (actor != NULL);
#line 340 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = actor;
#line 340 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->clone_sort_order = g_list_remove (self->priv->clone_sort_order, _tmp0_);
#line 1651 "WindowSwitcher.c"
}


static void gala_window_switcher_icon_removed (GalaWindowSwitcher* self, ClutterActor* actor) {
	ClutterActor* _tmp0_;
	gint _tmp1_;
	ClutterActor* _tmp6_;
	GalaWindowIcon* _tmp7_;
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 343 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (actor != NULL);
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->dock;
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = clutter_actor_get_n_children (_tmp0_);
#line 345 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp1_ == 1) {
#line 1670 "WindowSwitcher.c"
		GalaWindowManager* _tmp2_;
		MetaScreen* _tmp3_;
		MetaDisplay* _tmp4_;
		guint32 _tmp5_;
#line 346 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp2_ = self->priv->_wm;
#line 346 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp3_ = meta_plugin_get_screen ((MetaPlugin*) _tmp2_);
#line 346 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp4_ = meta_screen_get_display (_tmp3_);
#line 346 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp5_ = meta_display_get_current_time (_tmp4_);
#line 346 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close (self, (guint) _tmp5_);
#line 347 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return;
#line 1687 "WindowSwitcher.c"
	}
#line 350 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = actor;
#line 350 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = self->priv->current_window;
#line 350 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp6_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, clutter_actor_get_type (), ClutterActor)) {
#line 1695 "WindowSwitcher.c"
		GalaWindowIcon* _tmp8_;
		ClutterActor* _tmp9_;
		GalaWindowIcon* _tmp10_;
		GalaWindowIcon* _tmp11_;
#line 351 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp8_ = self->priv->current_window;
#line 351 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp9_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp8_);
#line 351 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
#line 351 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 351 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = _tmp10_;
#line 352 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp11_ = self->priv->current_window;
#line 352 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		if (_tmp11_ == NULL) {
#line 1714 "WindowSwitcher.c"
			ClutterActor* _tmp12_;
			ClutterActor* _tmp13_;
			GalaWindowIcon* _tmp14_;
#line 353 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp12_ = self->priv->dock;
#line 353 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp13_ = clutter_actor_get_first_child (_tmp12_);
#line 353 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
#line 353 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (self->priv->current_window);
#line 353 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			self->priv->current_window = _tmp14_;
#line 1728 "WindowSwitcher.c"
		}
#line 355 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_dim_windows (self);
#line 1732 "WindowSwitcher.c"
	}
#line 358 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_animate_dock_width (self);
#line 1736 "WindowSwitcher.c"
}


static gboolean gala_window_switcher_real_key_release_event (ClutterActor* base, ClutterKeyEvent* event) {
	GalaWindowSwitcher * self;
	gboolean result = FALSE;
	GdkModifierType _tmp0_;
	guint _tmp1_;
#line 361 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 361 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 363 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = gala_window_switcher_get_current_modifiers (self);
#line 363 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->modifier_mask;
#line 363 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if ((_tmp0_ & _tmp1_) == 0) {
#line 1755 "WindowSwitcher.c"
		ClutterKeyEvent* _tmp2_;
		guint32 _tmp3_;
#line 364 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp2_ = event;
#line 364 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp3_ = _tmp2_->time;
#line 364 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close (self, (guint) _tmp3_);
#line 1764 "WindowSwitcher.c"
	}
#line 366 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = TRUE;
#line 366 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 1770 "WindowSwitcher.c"
}


static void gala_window_switcher_real_key_focus_out (ClutterActor* base) {
	GalaWindowSwitcher * self;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	guint32 _tmp3_;
#line 369 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self = (GalaWindowSwitcher*) base;
#line 371 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 371 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 371 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = meta_screen_get_display (_tmp1_);
#line 371 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = meta_display_get_current_time (_tmp2_);
#line 371 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_close (self, (guint) _tmp3_);
#line 1792 "WindowSwitcher.c"
}


static gboolean __lambda34_ (GalaWindowSwitcher* self, MetaKeyBinding* binding) {
	gboolean result = FALSE;
	MetaKeyBinding* _tmp0_;
	gboolean _tmp1_;
	gchar* name = NULL;
	MetaKeyBinding* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
#line 417 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 419 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = binding;
#line 419 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_key_binding_is_builtin (_tmp0_);
#line 419 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (!_tmp1_) {
#line 420 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		result = TRUE;
#line 420 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return result;
#line 1820 "WindowSwitcher.c"
	}
#line 423 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = binding;
#line 423 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = meta_key_binding_get_name (_tmp2_);
#line 423 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 423 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	name = _tmp4_;
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = name;
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (g_strcmp0 (_tmp8_, "switch-applications") == 0) {
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp7_ = TRUE;
#line 1836 "WindowSwitcher.c"
	} else {
		const gchar* _tmp9_;
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp9_ = name;
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp7_ = g_strcmp0 (_tmp9_, "switch-applications-backward") == 0;
#line 1843 "WindowSwitcher.c"
	}
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp7_) {
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp6_ = TRUE;
#line 1849 "WindowSwitcher.c"
	} else {
		const gchar* _tmp10_;
#line 426 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp10_ = name;
#line 426 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp6_ = g_strcmp0 (_tmp10_, "switch-windows") == 0;
#line 1856 "WindowSwitcher.c"
	}
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp6_) {
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp5_ = TRUE;
#line 1862 "WindowSwitcher.c"
	} else {
		const gchar* _tmp11_;
#line 426 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp11_ = name;
#line 426 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp5_ = g_strcmp0 (_tmp11_, "switch-windows-backward") == 0;
#line 1869 "WindowSwitcher.c"
	}
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = !_tmp5_;
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_free0 (name);
#line 425 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 1877 "WindowSwitcher.c"
}


static gboolean ___lambda34__gala_keybinding_filter (MetaKeyBinding* binding, gpointer self) {
	gboolean result;
	result = __lambda34_ ((GalaWindowSwitcher*) self, binding);
#line 417 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 1886 "WindowSwitcher.c"
}


void gala_window_switcher_handle_switch_windows (MetaDisplay* display, MetaScreen* screen, MetaWindow* window, ClutterKeyEvent* event, MetaKeyBinding* binding, GalaWindowSwitcher* self) {
	gint64 now = 0LL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	gint64 _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gint64 _tmp7_;
	MetaWorkspace* workspace = NULL;
	MetaScreen* _tmp8_;
	MetaWorkspace* _tmp9_;
	MetaWorkspace* _tmp10_;
	gchar* binding_name = NULL;
	MetaKeyBinding* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean backward = FALSE;
	const gchar* _tmp14_;
	gboolean _tmp15_;
	const gchar* _tmp16_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_;
	gboolean _tmp20_;
	MetaWorkspace* _tmp25_;
	gboolean _tmp26_;
	MetaKeyBinding* _tmp27_;
	guint _tmp28_;
	MetaWorkspace* _tmp29_;
	gboolean _tmp30_;
	GalaWindowIcon* _tmp31_;
	GalaWindowManager* _tmp32_;
	GalaModalProxy* _tmp33_;
	GalaModalProxy* _tmp34_;
	GdkModifierType _tmp35_;
	guint _tmp36_;
#line 375 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 375 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (display != NULL);
#line 375 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (screen != NULL);
#line 375 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (event != NULL);
#line 375 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (binding != NULL);
#line 378 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = g_get_monotonic_time ();
#line 378 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	now = _tmp0_ / 1000;
#line 379 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = now;
#line 379 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->last_switch;
#line 379 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if ((_tmp1_ - _tmp2_) < ((gint64) GALA_WINDOW_SWITCHER_MIN_DELTA)) {
#line 380 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return;
#line 1948 "WindowSwitcher.c"
	}
#line 384 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp4_, NULL);
#line 384 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _tmp4_;
#line 384 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp5_) {
#line 1956 "WindowSwitcher.c"
		gboolean _tmp6_;
#line 384 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp6_ = self->priv->closing;
#line 384 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp3_ = _tmp6_;
#line 1962 "WindowSwitcher.c"
	} else {
#line 384 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp3_ = FALSE;
#line 1966 "WindowSwitcher.c"
	}
#line 384 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp3_) {
#line 385 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close_cleanup (self);
#line 1972 "WindowSwitcher.c"
	}
#line 388 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = now;
#line 388 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->last_switch = _tmp7_;
#line 390 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = screen;
#line 390 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp9_ = meta_screen_get_active_workspace (_tmp8_);
#line 390 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 390 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	workspace = _tmp10_;
#line 391 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp11_ = binding;
#line 391 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp12_ = meta_key_binding_get_name (_tmp11_);
#line 391 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 391 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	binding_name = _tmp13_;
#line 392 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp14_ = binding_name;
#line 392 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp15_ = g_str_has_suffix (_tmp14_, "-backward");
#line 392 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	backward = _tmp15_;
#line 396 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp16_ = binding_name;
#line 396 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (g_strcmp0 (_tmp16_, "switch-applications") == 0) {
#line 2004 "WindowSwitcher.c"
		GdkModifierType _tmp17_;
#line 397 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp17_ = gala_window_switcher_get_current_modifiers (self);
#line 397 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		backward = (_tmp17_ & CLUTTER_SHIFT_MASK) != 0;
#line 2010 "WindowSwitcher.c"
	}
#line 399 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_get ((ClutterActor*) self, "visible", &_tmp19_, NULL);
#line 399 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp20_ = _tmp19_;
#line 399 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp20_) {
#line 2018 "WindowSwitcher.c"
		gboolean _tmp21_;
#line 399 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp21_ = self->priv->closing;
#line 399 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp18_ = !_tmp21_;
#line 2024 "WindowSwitcher.c"
	} else {
#line 399 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp18_ = FALSE;
#line 2028 "WindowSwitcher.c"
	}
#line 399 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp18_) {
#line 2032 "WindowSwitcher.c"
		MetaWorkspace* _tmp22_;
		gboolean _tmp23_;
		GalaWindowIcon* _tmp24_;
#line 400 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp22_ = workspace;
#line 400 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp23_ = backward;
#line 400 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp24_ = gala_window_switcher_next_window (self, _tmp22_, _tmp23_);
#line 400 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 400 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = _tmp24_;
#line 401 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_dim_windows (self);
#line 402 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_free0 (binding_name);
#line 402 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (workspace);
#line 402 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return;
#line 2054 "WindowSwitcher.c"
	}
#line 405 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp25_ = workspace;
#line 405 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp26_ = gala_window_switcher_collect_windows (self, _tmp25_);
#line 405 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (!_tmp26_) {
#line 406 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_free0 (binding_name);
#line 406 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (workspace);
#line 406 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return;
#line 2068 "WindowSwitcher.c"
	}
#line 408 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp27_ = binding;
#line 408 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp28_ = meta_key_binding_get_mask (_tmp27_);
#line 408 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_set_primary_modifier (self, _tmp28_);
#line 410 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp29_ = workspace;
#line 410 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp30_ = backward;
#line 410 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp31_ = gala_window_switcher_next_window (self, _tmp29_, _tmp30_);
#line 410 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->current_window);
#line 410 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->current_window = _tmp31_;
#line 412 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_place_dock (self);
#line 414 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
#line 415 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->closing = FALSE;
#line 416 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp32_ = self->priv->_wm;
#line 416 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp33_ = gala_window_manager_push_modal (_tmp32_);
#line 416 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 416 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->modal_proxy = _tmp33_;
#line 417 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp34_ = self->priv->modal_proxy;
#line 417 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_modal_proxy_set_keybinding_filter (_tmp34_, ___lambda34__gala_keybinding_filter, g_object_ref (self), g_object_unref);
#line 429 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_animate_dock_width (self);
#line 430 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_show_background (self);
#line 432 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_dim_windows (self);
#line 433 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_grab_key_focus ((ClutterActor*) self);
#line 435 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp35_ = gala_window_switcher_get_current_modifiers (self);
#line 435 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp36_ = self->priv->modifier_mask;
#line 435 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if ((_tmp35_ & _tmp36_) == 0) {
#line 2118 "WindowSwitcher.c"
		GalaWindowManager* _tmp37_;
		MetaScreen* _tmp38_;
		MetaDisplay* _tmp39_;
		guint32 _tmp40_;
#line 436 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp37_ = self->priv->_wm;
#line 436 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp38_ = meta_plugin_get_screen ((MetaPlugin*) _tmp37_);
#line 436 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp39_ = meta_screen_get_display (_tmp38_);
#line 436 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp40_ = meta_display_get_current_time (_tmp39_);
#line 436 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close (self, (guint) _tmp40_);
#line 2133 "WindowSwitcher.c"
	}
#line 375 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_free0 (binding_name);
#line 375 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (workspace);
#line 2139 "WindowSwitcher.c"
}


static void gala_window_switcher_close_cleanup (GalaWindowSwitcher* self) {
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaWorkspace* workspace = NULL;
	MetaScreen* _tmp3_;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	MetaScreen* _tmp8_;
	GList* _tmp9_;
#line 439 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 441 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 441 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
#line 441 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 441 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	screen = _tmp2_;
#line 442 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = screen;
#line 442 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = meta_screen_get_active_workspace (_tmp3_);
#line 442 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 442 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	workspace = _tmp5_;
#line 444 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = self->priv->dock;
#line 444 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_destroy_all_children (_tmp6_);
#line 446 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_window);
#line 446 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->dock_window = NULL;
#line 447 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 448 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->closing = FALSE;
#line 450 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = self->priv->window_clones;
#line 450 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_destroy_all_children (_tmp7_);
#line 453 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = screen;
#line 453 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp9_ = meta_get_window_actors (_tmp8_);
#line 2194 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 453 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp9_;
#line 453 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 2202 "WindowSwitcher.c"
			MetaWindowActor* actor = NULL;
#line 453 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			actor = (MetaWindowActor*) actor_it->data;
#line 2206 "WindowSwitcher.c"
			{
				MetaWindowActor* _tmp10_;
				gboolean _tmp11_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp12_;
				MetaWindow* _tmp13_;
				gboolean _tmp14_ = FALSE;
				MetaWindow* _tmp15_;
				MetaWorkspace* _tmp16_;
				MetaWorkspace* _tmp17_;
#line 454 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp10_ = actor;
#line 454 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp11_ = meta_window_actor_is_destroyed (_tmp10_);
#line 454 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp11_) {
#line 455 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					continue;
#line 2225 "WindowSwitcher.c"
				}
#line 457 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp12_ = actor;
#line 457 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp13_ = meta_window_actor_get_meta_window (_tmp12_);
#line 457 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				window = _tmp13_;
#line 458 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp15_ = window;
#line 458 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp16_ = meta_window_get_workspace (_tmp15_);
#line 458 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp17_ = workspace;
#line 458 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp16_ == _tmp17_) {
#line 2241 "WindowSwitcher.c"
					MetaWindow* _tmp18_;
					gboolean _tmp19_;
#line 459 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp18_ = window;
#line 459 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp19_ = meta_window_showing_on_its_workspace (_tmp18_);
#line 459 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp14_ = _tmp19_;
#line 2250 "WindowSwitcher.c"
				} else {
#line 458 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp14_ = FALSE;
#line 2254 "WindowSwitcher.c"
				}
#line 458 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp14_) {
#line 2258 "WindowSwitcher.c"
					MetaWindowActor* _tmp20_;
#line 460 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp20_ = actor;
#line 460 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_show ((ClutterActor*) _tmp20_);
#line 2264 "WindowSwitcher.c"
				}
			}
		}
	}
#line 439 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (workspace);
#line 439 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (screen);
#line 2273 "WindowSwitcher.c"
}


static void ___lambda33_ (GalaWindowSwitcher* self) {
#line 536 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_close_cleanup (self);
#line 2280 "WindowSwitcher.c"
}


static void ____lambda33__clutter_timeline_completed (ClutterTimeline* _sender, gpointer self) {
#line 536 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	___lambda33_ ((GalaWindowSwitcher*) self);
#line 2287 "WindowSwitcher.c"
}


static void gala_window_switcher_close (GalaWindowSwitcher* self, guint time) {
	gboolean _tmp0_;
	GList* _tmp1_;
	GalaWindowIcon* _tmp24_;
	GalaWindowManager* _tmp29_;
	GalaModalProxy* _tmp30_;
	MetaWindowActor* _tmp31_;
	gfloat _tmp33_ = 0.0F;
	gfloat _tmp34_;
	gfloat dest_width = 0.0F;
	ClutterActor* _tmp36_;
	MetaWindowActor* _tmp37_;
	ClutterActor* _tmp44_;
	ClutterActor* _tmp45_;
	ClutterActor* _tmp46_;
	PlankDockPreferences* _tmp47_;
	gboolean _tmp48_;
	ClutterActor* _tmp59_;
	ClutterActor* _tmp60_;
	ClutterTransition* transition = NULL;
	ClutterActor* _tmp61_;
	ClutterTransition* _tmp62_;
	ClutterTransition* _tmp63_;
	ClutterTransition* _tmp64_;
#line 464 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 466 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->closing;
#line 466 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp0_) {
#line 467 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return;
#line 2323 "WindowSwitcher.c"
	}
#line 469 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->closing = TRUE;
#line 470 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->last_switch = (gint64) 0;
#line 472 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->clone_sort_order;
#line 2331 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 472 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp1_;
#line 472 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 2339 "WindowSwitcher.c"
			ClutterActor* _tmp2_;
			ClutterActor* actor = NULL;
#line 472 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp2_ = _g_object_ref0 ((ClutterActor*) actor_it->data);
#line 472 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			actor = _tmp2_;
#line 2346 "WindowSwitcher.c"
			{
				GalaSafeWindowClone* clone = NULL;
				ClutterActor* _tmp3_;
				GalaSafeWindowClone* _tmp4_;
				MetaWindow* _tmp5_;
				MetaWindow* _tmp6_;
				GalaWindowIcon* _tmp7_;
				MetaWindow* _tmp8_;
				MetaWindow* _tmp9_;
				GalaSafeWindowClone* _tmp10_;
				ClutterActor* _tmp11_;
				GalaSafeWindowClone* _tmp12_;
				GalaSafeWindowClone* _tmp13_;
				MetaWindow* _tmp14_;
				MetaWindow* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
#line 473 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp3_ = actor;
#line 473 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clone = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone);
#line 476 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp4_ = clone;
#line 476 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp5_ = gala_safe_window_clone_get_window (_tmp4_);
#line 476 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp6_ = _tmp5_;
#line 476 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp7_ = self->priv->current_window;
#line 476 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp8_ = gala_window_icon_get_window (_tmp7_);
#line 476 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp9_ = _tmp8_;
#line 476 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp6_ == _tmp9_) {
#line 477 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_g_object_unref0 (actor);
#line 477 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					continue;
#line 2386 "WindowSwitcher.c"
				}
#line 479 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp10_ = clone;
#line 479 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_remove_effect_by_name ((ClutterActor*) _tmp10_, "brightness");
#line 482 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp11_ = self->priv->window_clones;
#line 482 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp12_ = clone;
#line 482 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_child_below_sibling (_tmp11_, (ClutterActor*) _tmp12_, NULL);
#line 484 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp13_ = clone;
#line 484 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp14_ = gala_safe_window_clone_get_window (_tmp13_);
#line 484 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp15_ = _tmp14_;
#line 484 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				g_object_get (_tmp15_, "minimized", &_tmp16_, NULL);
#line 484 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp17_ = _tmp16_;
#line 484 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (!_tmp17_) {
#line 2410 "WindowSwitcher.c"
					GalaSafeWindowClone* _tmp18_;
					GalaSafeWindowClone* _tmp19_;
					GalaSafeWindowClone* _tmp20_;
					GalaSafeWindowClone* _tmp21_;
					GalaSafeWindowClone* _tmp22_;
					GalaSafeWindowClone* _tmp23_;
#line 485 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp18_ = clone;
#line 485 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_save_easing_state ((ClutterActor*) _tmp18_);
#line 486 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp19_ = clone;
#line 486 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_easing_duration ((ClutterActor*) _tmp19_, (guint) 150);
#line 487 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp20_ = clone;
#line 487 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_easing_mode ((ClutterActor*) _tmp20_, CLUTTER_EASE_OUT_CUBIC);
#line 488 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp21_ = clone;
#line 488 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_z_position ((ClutterActor*) _tmp21_, (gfloat) 0);
#line 489 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp22_ = clone;
#line 489 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_opacity ((ClutterActor*) _tmp22_, (guint) 255);
#line 490 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp23_ = clone;
#line 490 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_restore_easing_state ((ClutterActor*) _tmp23_);
#line 2441 "WindowSwitcher.c"
				}
#line 472 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_g_object_unref0 (actor);
#line 2445 "WindowSwitcher.c"
			}
		}
	}
#line 494 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp24_ = self->priv->current_window;
#line 494 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp24_ != NULL) {
#line 2453 "WindowSwitcher.c"
		GalaWindowIcon* _tmp25_;
		MetaWindow* _tmp26_;
		MetaWindow* _tmp27_;
		guint _tmp28_;
#line 495 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp25_ = self->priv->current_window;
#line 495 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp26_ = gala_window_icon_get_window (_tmp25_);
#line 495 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp27_ = _tmp26_;
#line 495 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp28_ = time;
#line 495 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		meta_window_activate (_tmp27_, (guint32) _tmp28_);
#line 496 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 496 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = NULL;
#line 2472 "WindowSwitcher.c"
	}
#line 499 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp29_ = self->priv->_wm;
#line 499 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp30_ = self->priv->modal_proxy;
#line 499 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_manager_pop_modal (_tmp29_, _tmp30_);
#line 501 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp31_ = self->priv->dock_window;
#line 501 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp31_ != NULL) {
#line 2484 "WindowSwitcher.c"
		MetaWindowActor* _tmp32_;
#line 502 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp32_ = self->priv->dock_window;
#line 502 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_opacity ((ClutterActor*) _tmp32_, (guint) 0);
#line 2490 "WindowSwitcher.c"
	}
#line 504 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp34_ = self->priv->dock_width;
#line 504 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp34_ > ((gfloat) 0)) {
#line 2496 "WindowSwitcher.c"
		gfloat _tmp35_;
#line 504 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp35_ = self->priv->dock_width;
#line 504 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp33_ = _tmp35_;
#line 2502 "WindowSwitcher.c"
	} else {
#line 504 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp33_ = 600.0f;
#line 2506 "WindowSwitcher.c"
	}
#line 504 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	dest_width = _tmp33_;
#line 506 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp36_ = self->priv->dock;
#line 506 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_child_above_sibling ((ClutterActor*) self, _tmp36_, NULL);
#line 508 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp37_ = self->priv->dock_window;
#line 508 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp37_ != NULL) {
#line 2518 "WindowSwitcher.c"
		MetaWindowActor* _tmp38_;
		MetaWindowActor* _tmp39_;
		MetaWindowActor* _tmp40_;
		MetaWindowActor* _tmp41_;
		MetaWindowActor* _tmp42_;
		MetaWindowActor* _tmp43_;
#line 509 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp38_ = self->priv->dock_window;
#line 509 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_show ((ClutterActor*) _tmp38_);
#line 510 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp39_ = self->priv->dock_window;
#line 510 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_save_easing_state ((ClutterActor*) _tmp39_);
#line 511 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp40_ = self->priv->dock_window;
#line 511 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) _tmp40_, CLUTTER_LINEAR);
#line 512 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp41_ = self->priv->dock_window;
#line 512 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) _tmp41_, (guint) 250);
#line 513 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp42_ = self->priv->dock_window;
#line 513 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_opacity ((ClutterActor*) _tmp42_, (guint) 255);
#line 514 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp43_ = self->priv->dock_window;
#line 514 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) _tmp43_);
#line 2549 "WindowSwitcher.c"
	}
#line 517 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_hide_background (self);
#line 519 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp44_ = self->priv->dock;
#line 519 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_save_easing_state (_tmp44_);
#line 520 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp45_ = self->priv->dock;
#line 520 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_duration (_tmp45_, (guint) 250);
#line 521 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp46_ = self->priv->dock;
#line 521 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_easing_mode (_tmp46_, CLUTTER_EASE_OUT_CUBIC);
#line 523 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp47_ = self->priv->dock_settings;
#line 523 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp48_ = plank_dock_preferences_is_horizontal_dock (_tmp47_);
#line 523 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp48_) {
#line 2571 "WindowSwitcher.c"
		ClutterActor* _tmp49_;
		gfloat _tmp50_;
		ClutterActor* _tmp51_;
		gfloat _tmp52_;
		gfloat _tmp53_;
#line 524 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp49_ = self->priv->dock;
#line 524 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp50_ = dest_width;
#line 524 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_width (_tmp49_, _tmp50_);
#line 525 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp51_ = self->priv->dock;
#line 525 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp52_ = dest_width;
#line 525 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp53_ = ceilf ((-_tmp52_) / 2.0f);
#line 525 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp51_, "translation-x", _tmp53_, NULL);
#line 2591 "WindowSwitcher.c"
	} else {
		ClutterActor* _tmp54_;
		gfloat _tmp55_;
		ClutterActor* _tmp56_;
		gfloat _tmp57_;
		gfloat _tmp58_;
#line 527 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp54_ = self->priv->dock;
#line 527 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp55_ = dest_width;
#line 527 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		clutter_actor_set_height (_tmp54_, _tmp55_);
#line 528 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp56_ = self->priv->dock;
#line 528 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp57_ = dest_width;
#line 528 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp58_ = ceilf ((-_tmp57_) / 2.0f);
#line 528 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_object_set (_tmp56_, "translation-y", _tmp58_, NULL);
#line 2612 "WindowSwitcher.c"
	}
#line 531 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp59_ = self->priv->dock;
#line 531 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity (_tmp59_, (guint) 0);
#line 532 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp60_ = self->priv->dock;
#line 532 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_restore_easing_state (_tmp60_);
#line 534 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp61_ = self->priv->dock;
#line 534 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp62_ = clutter_actor_get_transition (_tmp61_, "opacity");
#line 534 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp63_ = _g_object_ref0 (_tmp62_);
#line 534 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	transition = _tmp63_;
#line 535 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp64_ = transition;
#line 535 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp64_ != NULL) {
#line 2634 "WindowSwitcher.c"
		ClutterTransition* _tmp65_;
#line 536 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp65_ = transition;
#line 536 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_signal_connect_object ((ClutterTimeline*) _tmp65_, "completed", (GCallback) ____lambda33__clutter_timeline_completed, self, 0);
#line 2640 "WindowSwitcher.c"
	} else {
#line 538 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_close_cleanup (self);
#line 2644 "WindowSwitcher.c"
	}
#line 464 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (transition);
#line 2648 "WindowSwitcher.c"
}


static gboolean _gala_window_switcher_clicked_icon_clutter_actor_button_release_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self) {
	gboolean result;
	result = gala_window_switcher_clicked_icon ((GalaWindowSwitcher*) self, event);
#line 562 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 2657 "WindowSwitcher.c"
}


static GalaWindowIcon* gala_window_switcher_add_window (GalaWindowSwitcher* self, MetaWindow* window) {
	GalaWindowIcon* result = NULL;
	MetaWindowActor* actor = NULL;
	MetaWindow* _tmp0_;
	GObject* _tmp1_;
	MetaWindowActor* _tmp2_;
	MetaWindowActor* _tmp3_;
	MetaWindowActor* _tmp4_;
	GalaSafeWindowClone* clone = NULL;
	MetaWindow* _tmp5_;
	GalaSafeWindowClone* _tmp6_;
	GalaSafeWindowClone* _tmp7_;
	MetaWindowActor* _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	GalaSafeWindowClone* _tmp11_;
	MetaWindowActor* _tmp12_;
	gfloat _tmp13_;
	gfloat _tmp14_;
	ClutterActor* _tmp15_;
	GalaSafeWindowClone* _tmp16_;
	GalaWindowIcon* icon = NULL;
	MetaWindow* _tmp17_;
	PlankDockPreferences* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GalaWindowIcon* _tmp21_;
	GalaWindowIcon* _tmp22_;
	GalaWindowIcon* _tmp23_;
	GalaWindowIcon* _tmp24_;
	GalaWindowIcon* _tmp25_;
	GalaWindowIcon* _tmp26_;
	GalaWindowIcon* _tmp27_;
	GalaWindowIcon* _tmp28_;
	ClutterActor* _tmp29_;
	GalaWindowIcon* _tmp30_;
#line 541 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 541 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 543 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = window;
#line 543 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_window_get_compositor_private (_tmp0_);
#line 543 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, meta_window_actor_get_type ()) ? ((MetaWindowActor*) _tmp1_) : NULL);
#line 543 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	actor = _tmp2_;
#line 544 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = actor;
#line 544 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp3_ == NULL) {
#line 545 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		result = NULL;
#line 545 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 545 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return result;
#line 2719 "WindowSwitcher.c"
	}
#line 547 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = actor;
#line 547 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_hide ((ClutterActor*) _tmp4_);
#line 549 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = window;
#line 549 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = gala_safe_window_clone_new (_tmp5_, TRUE);
#line 549 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp6_);
#line 549 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clone = _tmp6_;
#line 550 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = clone;
#line 550 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = actor;
#line 550 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp9_ = clutter_actor_get_x ((ClutterActor*) _tmp8_);
#line 550 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp10_ = _tmp9_;
#line 550 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_x ((ClutterActor*) _tmp7_, _tmp10_);
#line 551 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp11_ = clone;
#line 551 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp12_ = actor;
#line 551 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp13_ = clutter_actor_get_y ((ClutterActor*) _tmp12_);
#line 551 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp14_ = _tmp13_;
#line 551 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_y ((ClutterActor*) _tmp11_, _tmp14_);
#line 553 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp15_ = self->priv->window_clones;
#line 553 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp16_ = clone;
#line 553 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child (_tmp15_, (ClutterActor*) _tmp16_);
#line 555 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp17_ = window;
#line 555 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp18_ = self->priv->dock_settings;
#line 555 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp19_ = plank_dock_preferences_get_IconSize (_tmp18_);
#line 555 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp20_ = _tmp19_;
#line 555 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp21_ = gala_window_icon_new (_tmp17_, _tmp20_, TRUE);
#line 555 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp21_);
#line 555 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	icon = _tmp21_;
#line 556 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp22_ = icon;
#line 556 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_reactive ((ClutterActor*) _tmp22_, TRUE);
#line 557 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp23_ = icon;
#line 557 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp23_, (guint) 100);
#line 558 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp24_ = icon;
#line 558 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_x_expand ((ClutterActor*) _tmp24_, TRUE);
#line 559 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp25_ = icon;
#line 559 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_y_expand ((ClutterActor*) _tmp25_, TRUE);
#line 560 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp26_ = icon;
#line 560 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_x_align ((ClutterActor*) _tmp26_, CLUTTER_ACTOR_ALIGN_CENTER);
#line 561 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp27_ = icon;
#line 561 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_y_align ((ClutterActor*) _tmp27_, CLUTTER_ACTOR_ALIGN_CENTER);
#line 562 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp28_ = icon;
#line 562 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((ClutterActor*) _tmp28_, "button-release-event", (GCallback) _gala_window_switcher_clicked_icon_clutter_actor_button_release_event, self, 0);
#line 564 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp29_ = self->priv->dock;
#line 564 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp30_ = icon;
#line 564 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child (_tmp29_, (ClutterActor*) _tmp30_);
#line 566 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = icon;
#line 566 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (clone);
#line 566 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (actor);
#line 566 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 2815 "WindowSwitcher.c"
}


static void gala_window_switcher_dim_windows (GalaWindowSwitcher* self) {
	ClutterActor* _tmp0_;
	GList* _tmp1_;
	ClutterActor* _tmp24_;
	GList* _tmp25_;
#line 569 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 571 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->window_clones;
#line 571 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = clutter_actor_get_children (_tmp0_);
#line 2830 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 571 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp1_;
#line 571 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 2838 "WindowSwitcher.c"
			ClutterActor* actor = NULL;
#line 571 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			actor = (ClutterActor*) actor_it->data;
#line 2842 "WindowSwitcher.c"
			{
				GalaSafeWindowClone* clone = NULL;
				ClutterActor* _tmp2_;
				ClutterActor* _tmp3_;
				ClutterActor* _tmp4_;
				ClutterActor* _tmp5_;
				GalaSafeWindowClone* _tmp6_;
				MetaWindow* _tmp7_;
				MetaWindow* _tmp8_;
				GalaWindowIcon* _tmp9_;
				MetaWindow* _tmp10_;
				MetaWindow* _tmp11_;
				ClutterActor* _tmp23_;
#line 572 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp2_ = actor;
#line 572 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clone = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GALA_TYPE_SAFE_WINDOW_CLONE, GalaSafeWindowClone);
#line 574 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp3_ = actor;
#line 574 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_save_easing_state (_tmp3_);
#line 575 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp4_ = actor;
#line 575 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_easing_duration (_tmp4_, (guint) 250);
#line 576 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp5_ = actor;
#line 576 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_easing_mode (_tmp5_, CLUTTER_EASE_IN_OUT_QUART);
#line 578 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp6_ = clone;
#line 578 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp7_ = gala_safe_window_clone_get_window (_tmp6_);
#line 578 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp8_ = _tmp7_;
#line 578 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp9_ = self->priv->current_window;
#line 578 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp10_ = gala_window_icon_get_window (_tmp9_);
#line 578 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp11_ = _tmp10_;
#line 578 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp8_ == _tmp11_) {
#line 2886 "WindowSwitcher.c"
					ClutterActor* _tmp12_;
					ClutterActor* _tmp13_;
					ClutterActor* _tmp14_;
					ClutterActor* _tmp15_;
#line 579 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp12_ = self->priv->window_clones;
#line 579 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp13_ = actor;
#line 579 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_child_above_sibling (_tmp12_, _tmp13_, NULL);
#line 580 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp14_ = actor;
#line 580 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_remove_effect_by_name (_tmp14_, "brightness");
#line 581 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp15_ = actor;
#line 581 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_z_position (_tmp15_, (gfloat) 0);
#line 2905 "WindowSwitcher.c"
				} else {
					ClutterActor* _tmp16_;
					ClutterEffect* _tmp17_;
					ClutterActor* _tmp22_;
#line 583 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp16_ = actor;
#line 583 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp17_ = clutter_actor_get_effect (_tmp16_, "brightness");
#line 583 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					if (_tmp17_ == NULL) {
#line 2916 "WindowSwitcher.c"
						ClutterBrightnessContrastEffect* brightness_effect = NULL;
						ClutterBrightnessContrastEffect* _tmp18_;
						ClutterBrightnessContrastEffect* _tmp19_;
						ClutterActor* _tmp20_;
						ClutterBrightnessContrastEffect* _tmp21_;
#line 584 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						_tmp18_ = (ClutterBrightnessContrastEffect*) clutter_brightness_contrast_effect_new ();
#line 584 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						g_object_ref_sink (_tmp18_);
#line 584 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						brightness_effect = _tmp18_;
#line 585 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						_tmp19_ = brightness_effect;
#line 585 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						clutter_brightness_contrast_effect_set_brightness (_tmp19_, GALA_WINDOW_SWITCHER_DIM_WINDOW_BRIGHTNESS);
#line 586 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						_tmp20_ = actor;
#line 586 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						_tmp21_ = brightness_effect;
#line 586 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						clutter_actor_add_effect_with_name (_tmp20_, "brightness", (ClutterEffect*) _tmp21_);
#line 583 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
						_g_object_unref0 (brightness_effect);
#line 2940 "WindowSwitcher.c"
					}
#line 589 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp22_ = actor;
#line 589 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_z_position (_tmp22_, (gfloat) -100);
#line 2946 "WindowSwitcher.c"
				}
#line 592 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp23_ = actor;
#line 592 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_restore_easing_state (_tmp23_);
#line 2952 "WindowSwitcher.c"
			}
		}
#line 571 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_list_free0 (actor_collection);
#line 2957 "WindowSwitcher.c"
	}
#line 595 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp24_ = self->priv->dock;
#line 595 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp25_ = clutter_actor_get_children (_tmp24_);
#line 2963 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 595 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp25_;
#line 595 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 2971 "WindowSwitcher.c"
			ClutterActor* actor = NULL;
#line 595 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			actor = (ClutterActor*) actor_it->data;
#line 2975 "WindowSwitcher.c"
			{
				GalaWindowIcon* icon = NULL;
				ClutterActor* _tmp26_;
				GalaWindowIcon* _tmp27_;
				GalaWindowIcon* _tmp28_;
				GalaWindowIcon* _tmp29_;
				GalaWindowIcon* _tmp30_;
				GalaWindowIcon* _tmp31_;
				GalaWindowIcon* _tmp34_;
#line 596 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp26_ = actor;
#line 596 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				icon = G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon);
#line 597 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp27_ = icon;
#line 597 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_save_easing_state ((ClutterActor*) _tmp27_);
#line 598 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp28_ = icon;
#line 598 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_easing_duration ((ClutterActor*) _tmp28_, (guint) 100);
#line 599 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp29_ = icon;
#line 599 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_set_easing_mode ((ClutterActor*) _tmp29_, CLUTTER_LINEAR);
#line 601 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp30_ = icon;
#line 601 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp31_ = self->priv->current_window;
#line 601 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp30_ == _tmp31_) {
#line 3007 "WindowSwitcher.c"
					GalaWindowIcon* _tmp32_;
#line 602 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp32_ = icon;
#line 602 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_opacity ((ClutterActor*) _tmp32_, (guint) 255);
#line 3013 "WindowSwitcher.c"
				} else {
					GalaWindowIcon* _tmp33_;
#line 604 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp33_ = icon;
#line 604 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_set_opacity ((ClutterActor*) _tmp33_, (guint) 100);
#line 3020 "WindowSwitcher.c"
				}
#line 606 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp34_ = icon;
#line 606 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clutter_actor_restore_easing_state ((ClutterActor*) _tmp34_);
#line 3026 "WindowSwitcher.c"
			}
		}
#line 595 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_list_free0 (actor_collection);
#line 3031 "WindowSwitcher.c"
	}
}


/**
 * Adds the suitable windows on the given workspace to the switcher
 *
 * @return whether the switcher should actually be started or if there are
 *         not enough windows
 */
static gboolean _vala_string_array_contains (gchar* * stack, int stack_length, gchar* needle) {
	int i;
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	for (i = 0; i < stack_length; i++) {
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			return TRUE;
#line 3050 "WindowSwitcher.c"
		}
	}
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return FALSE;
#line 3055 "WindowSwitcher.c"
}


static gboolean gala_window_switcher_collect_windows (GalaWindowSwitcher* self, MetaWorkspace* workspace) {
	gboolean result = FALSE;
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaDisplay* display = NULL;
	MetaScreen* _tmp3_;
	MetaDisplay* _tmp4_;
	MetaDisplay* _tmp5_;
	GList* windows = NULL;
	MetaDisplay* _tmp6_;
	MetaWorkspace* _tmp7_;
	GList* _tmp8_;
	MetaWindow* current = NULL;
	MetaDisplay* _tmp9_;
	MetaWorkspace* _tmp10_;
	MetaWindow* _tmp11_;
	MetaWindow* _tmp12_;
	GList* _tmp13_;
	guint _tmp14_;
	GList* _tmp15_;
	guint _tmp16_;
	GList* _tmp28_;
	ClutterActor* _tmp35_;
	GList* _tmp36_;
	GList* _tmp37_;
	GList* _tmp38_;
	GalaWindowIcon* _tmp39_;
	MetaScreen* _tmp43_;
	GList* _tmp44_;
#line 616 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 616 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (workspace != NULL, FALSE);
#line 618 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = workspace;
#line 618 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = meta_workspace_get_screen (_tmp0_);
#line 618 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 618 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	screen = _tmp2_;
#line 619 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = screen;
#line 619 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = meta_screen_get_display (_tmp3_);
#line 619 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 619 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	display = _tmp5_;
#line 621 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = display;
#line 621 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = workspace;
#line 621 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = meta_display_get_tab_list (_tmp6_, META_TAB_LIST_NORMAL, _tmp7_);
#line 621 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	windows = _tmp8_;
#line 622 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp9_ = display;
#line 622 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp10_ = workspace;
#line 622 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp11_ = meta_display_get_tab_current (_tmp9_, META_TAB_LIST_NORMAL, _tmp10_);
#line 622 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 622 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	current = _tmp12_;
#line 624 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp13_ = windows;
#line 624 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp14_ = g_list_length (_tmp13_);
#line 624 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp14_ < ((guint) 1)) {
#line 625 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		result = FALSE;
#line 625 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (current);
#line 625 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_list_free0 (windows);
#line 625 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (display);
#line 625 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (screen);
#line 625 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return result;
#line 3146 "WindowSwitcher.c"
	}
#line 627 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp15_ = windows;
#line 627 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp16_ = g_list_length (_tmp15_);
#line 627 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp16_ == ((guint) 1)) {
#line 3154 "WindowSwitcher.c"
		MetaWindow* window = NULL;
		GList* _tmp17_;
		gconstpointer _tmp18_;
		MetaWindow* _tmp19_;
		MetaWindow* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
		MetaWindow* _tmp25_;
		MetaDisplay* _tmp26_;
		guint32 _tmp27_;
#line 628 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp17_ = windows;
#line 628 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp18_ = _tmp17_->data;
#line 628 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp19_ = _g_object_ref0 ((MetaWindow*) _tmp18_);
#line 628 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		window = _tmp19_;
#line 629 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp20_ = window;
#line 629 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_object_get (_tmp20_, "minimized", &_tmp21_, NULL);
#line 629 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp22_ = _tmp21_;
#line 629 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		if (_tmp22_) {
#line 3181 "WindowSwitcher.c"
			MetaWindow* _tmp23_;
#line 630 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp23_ = window;
#line 630 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			meta_window_unminimize (_tmp23_);
#line 3187 "WindowSwitcher.c"
		} else {
			MetaScreen* _tmp24_;
#line 632 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp24_ = screen;
#line 632 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			gala_utils_bell (_tmp24_);
#line 3194 "WindowSwitcher.c"
		}
#line 634 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp25_ = window;
#line 634 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp26_ = display;
#line 634 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp27_ = meta_display_get_current_time (_tmp26_);
#line 634 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		meta_window_activate (_tmp25_, _tmp27_);
#line 636 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		result = FALSE;
#line 636 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (window);
#line 636 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (current);
#line 636 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_list_free0 (windows);
#line 636 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (display);
#line 636 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (screen);
#line 636 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return result;
#line 3218 "WindowSwitcher.c"
	}
#line 639 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp28_ = windows;
#line 3222 "WindowSwitcher.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 639 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		window_collection = _tmp28_;
#line 639 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 3230 "WindowSwitcher.c"
			MetaWindow* window = NULL;
#line 639 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			window = (MetaWindow*) window_it->data;
#line 3234 "WindowSwitcher.c"
			{
				GalaWindowIcon* clone = NULL;
				MetaWindow* _tmp29_;
				GalaWindowIcon* _tmp30_;
				MetaWindow* _tmp31_;
				MetaWindow* _tmp32_;
#line 640 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp29_ = window;
#line 640 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp30_ = gala_window_switcher_add_window (self, _tmp29_);
#line 640 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				clone = _tmp30_;
#line 641 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp31_ = window;
#line 641 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp32_ = current;
#line 641 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp31_ == _tmp32_) {
#line 3253 "WindowSwitcher.c"
					GalaWindowIcon* _tmp33_;
					GalaWindowIcon* _tmp34_;
#line 642 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp33_ = clone;
#line 642 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp34_ = _g_object_ref0 (_tmp33_);
#line 642 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_g_object_unref0 (self->priv->current_window);
#line 642 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					self->priv->current_window = _tmp34_;
#line 3264 "WindowSwitcher.c"
				}
#line 639 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_g_object_unref0 (clone);
#line 3268 "WindowSwitcher.c"
			}
		}
	}
#line 645 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp35_ = self->priv->window_clones;
#line 645 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp36_ = clutter_actor_get_children (_tmp35_);
#line 645 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp37_ = _tmp36_;
#line 645 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp38_ = g_list_copy (_tmp37_);
#line 645 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	__g_list_free__g_object_unref0_0 (self->priv->clone_sort_order);
#line 645 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->clone_sort_order = _tmp38_;
#line 645 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_list_free0 (_tmp37_);
#line 647 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp39_ = self->priv->current_window;
#line 647 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp39_ == NULL) {
#line 3290 "WindowSwitcher.c"
		ClutterActor* _tmp40_;
		ClutterActor* _tmp41_;
		GalaWindowIcon* _tmp42_;
#line 648 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp40_ = self->priv->dock;
#line 648 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp41_ = clutter_actor_get_child_at_index (_tmp40_, 0);
#line 648 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
#line 648 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->current_window);
#line 648 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->current_window = _tmp42_;
#line 3304 "WindowSwitcher.c"
	}
#line 651 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp43_ = screen;
#line 651 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp44_ = meta_get_window_actors (_tmp43_);
#line 3310 "WindowSwitcher.c"
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
#line 651 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		actor_collection = _tmp44_;
#line 651 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
#line 3318 "WindowSwitcher.c"
			MetaWindowActor* actor = NULL;
#line 651 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			actor = (MetaWindowActor*) actor_it->data;
#line 3322 "WindowSwitcher.c"
			{
				MetaWindowActor* _tmp45_;
				gboolean _tmp46_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp47_;
				MetaWindow* _tmp48_;
				MetaWindowType type = 0;
				MetaWindow* _tmp49_;
				MetaWindowType _tmp50_;
				MetaWindowType _tmp51_;
				gboolean _tmp52_ = FALSE;
				gboolean _tmp53_ = FALSE;
				MetaWindowType _tmp54_;
				gboolean _tmp58_ = FALSE;
				MetaWindow* _tmp59_;
				const gchar* _tmp60_;
				const gchar* _tmp61_;
				GalaBehaviorSettings* _tmp62_;
				gchar** _tmp63_;
				gint _tmp63__length1;
				gchar** _tmp64_;
				gint _tmp64__length1;
#line 652 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp45_ = actor;
#line 652 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp46_ = meta_window_actor_is_destroyed (_tmp45_);
#line 652 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp46_) {
#line 653 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					continue;
#line 3353 "WindowSwitcher.c"
				}
#line 655 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp47_ = actor;
#line 655 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp48_ = meta_window_actor_get_meta_window (_tmp47_);
#line 655 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				window = _tmp48_;
#line 656 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp49_ = window;
#line 656 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp50_ = meta_window_get_window_type (_tmp49_);
#line 656 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp51_ = _tmp50_;
#line 656 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				type = _tmp51_;
#line 658 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp54_ = type;
#line 658 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp54_ != META_WINDOW_DOCK) {
#line 3373 "WindowSwitcher.c"
					MetaWindowType _tmp55_;
#line 659 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp55_ = type;
#line 659 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp53_ = _tmp55_ != META_WINDOW_DESKTOP;
#line 3379 "WindowSwitcher.c"
				} else {
#line 658 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp53_ = FALSE;
#line 3383 "WindowSwitcher.c"
				}
#line 658 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp53_) {
#line 3387 "WindowSwitcher.c"
					MetaWindowType _tmp56_;
#line 660 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp56_ = type;
#line 660 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp52_ = _tmp56_ != META_WINDOW_NOTIFICATION;
#line 3393 "WindowSwitcher.c"
				} else {
#line 658 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp52_ = FALSE;
#line 3397 "WindowSwitcher.c"
				}
#line 658 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp52_) {
#line 3401 "WindowSwitcher.c"
					MetaWindowActor* _tmp57_;
#line 661 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp57_ = actor;
#line 661 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_hide ((ClutterActor*) _tmp57_);
#line 3407 "WindowSwitcher.c"
				}
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp59_ = window;
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp60_ = meta_window_get_title (_tmp59_);
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp61_ = _tmp60_;
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp62_ = gala_behavior_settings_get_default ();
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp63_ = gala_behavior_settings_get_dock_names (_tmp62_, &_tmp63__length1);
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp64_ = _tmp63_;
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_tmp64__length1 = _tmp63__length1;
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_vala_string_array_contains (_tmp64_, _tmp64__length1, _tmp61_)) {
#line 3425 "WindowSwitcher.c"
					MetaWindowType _tmp65_;
#line 664 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp65_ = type;
#line 664 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp58_ = _tmp65_ == META_WINDOW_DOCK;
#line 3431 "WindowSwitcher.c"
				} else {
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp58_ = FALSE;
#line 3435 "WindowSwitcher.c"
				}
#line 663 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				if (_tmp58_) {
#line 3439 "WindowSwitcher.c"
					MetaWindowActor* _tmp66_;
					MetaWindowActor* _tmp67_;
					MetaWindowActor* _tmp68_;
#line 665 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp66_ = actor;
#line 665 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp67_ = _g_object_ref0 (_tmp66_);
#line 665 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_g_object_unref0 (self->priv->dock_window);
#line 665 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					self->priv->dock_window = _tmp67_;
#line 666 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					_tmp68_ = self->priv->dock_window;
#line 666 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
					clutter_actor_hide ((ClutterActor*) _tmp68_);
#line 3455 "WindowSwitcher.c"
				}
			}
		}
	}
#line 670 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = TRUE;
#line 670 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (current);
#line 670 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_list_free0 (windows);
#line 670 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (display);
#line 670 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (screen);
#line 670 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 3472 "WindowSwitcher.c"
}


static GalaWindowIcon* gala_window_switcher_next_window (GalaWindowSwitcher* self, MetaWorkspace* workspace, gboolean backward) {
	GalaWindowIcon* result = NULL;
	ClutterActor* actor = NULL;
	gboolean _tmp0_;
	ClutterActor* _tmp15_;
	GalaWindowIcon* _tmp16_;
#line 673 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 673 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (workspace != NULL, NULL);
#line 676 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = backward;
#line 676 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (!_tmp0_) {
#line 3490 "WindowSwitcher.c"
		GalaWindowIcon* _tmp1_;
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
		ClutterActor* _tmp4_;
#line 677 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp1_ = self->priv->current_window;
#line 677 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp2_ = clutter_actor_get_next_sibling ((ClutterActor*) _tmp1_);
#line 677 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 677 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 677 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		actor = _tmp3_;
#line 678 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp4_ = actor;
#line 678 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		if (_tmp4_ == NULL) {
#line 3509 "WindowSwitcher.c"
			ClutterActor* _tmp5_;
			ClutterActor* _tmp6_;
			ClutterActor* _tmp7_;
#line 679 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp5_ = self->priv->dock;
#line 679 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp6_ = clutter_actor_get_first_child (_tmp5_);
#line 679 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 679 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 679 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			actor = _tmp7_;
#line 3523 "WindowSwitcher.c"
		}
	} else {
		GalaWindowIcon* _tmp8_;
		ClutterActor* _tmp9_;
		ClutterActor* _tmp10_;
		ClutterActor* _tmp11_;
#line 681 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp8_ = self->priv->current_window;
#line 681 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp9_ = clutter_actor_get_previous_sibling ((ClutterActor*) _tmp8_);
#line 681 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 681 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (actor);
#line 681 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		actor = _tmp10_;
#line 682 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp11_ = actor;
#line 682 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		if (_tmp11_ == NULL) {
#line 3544 "WindowSwitcher.c"
			ClutterActor* _tmp12_;
			ClutterActor* _tmp13_;
			ClutterActor* _tmp14_;
#line 683 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp12_ = self->priv->dock;
#line 683 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp13_ = clutter_actor_get_last_child (_tmp12_);
#line 683 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp14_ = _g_object_ref0 (_tmp13_);
#line 683 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (actor);
#line 683 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			actor = _tmp14_;
#line 3558 "WindowSwitcher.c"
		}
	}
#line 686 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp15_ = actor;
#line 686 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GALA_TYPE_WINDOW_ICON, GalaWindowIcon));
#line 686 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = _tmp16_;
#line 686 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (actor);
#line 686 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 3571 "WindowSwitcher.c"
}


/**
 * copied from gnome-shell, finds the primary modifier in the mask and saves it
 * to our modifier_mask field
 *
 * @param mask The modifier mask to extract the primary one from
 */
static void gala_window_switcher_set_primary_modifier (GalaWindowSwitcher* self, guint mask) {
	guint _tmp0_;
#line 695 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 697 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = mask;
#line 697 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp0_ == ((guint) 0)) {
#line 698 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->modifier_mask = (guint) 0;
#line 3591 "WindowSwitcher.c"
	} else {
#line 700 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->modifier_mask = (guint) 1;
#line 701 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		while (TRUE) {
#line 3597 "WindowSwitcher.c"
			guint _tmp1_;
			guint _tmp2_;
			guint _tmp3_;
#line 701 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp1_ = mask;
#line 701 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			if (!(_tmp1_ > ((guint) 1))) {
#line 701 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				break;
#line 3607 "WindowSwitcher.c"
			}
#line 702 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp2_ = mask;
#line 702 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			mask = _tmp2_ >> 1;
#line 703 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp3_ = self->priv->modifier_mask;
#line 703 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			self->priv->modifier_mask = _tmp3_ << 1;
#line 3617 "WindowSwitcher.c"
		}
	}
}


/**
 * Counts the launcher items to get an estimate of the window size
 */
static void gala_window_switcher_update_n_dock_items (GalaWindowSwitcher* self, GFile* folder, GFile* other_file, GFileMonitorEvent event) {
	gboolean _tmp0_ = FALSE;
	GFileMonitorEvent _tmp1_;
	gint count = 0;
	gint _tmp11_;
	GError * _inner_error_ = NULL;
#line 711 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 711 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (folder != NULL);
#line 713 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = event;
#line 713 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp1_ != G_FILE_MONITOR_EVENT_CREATED) {
#line 3640 "WindowSwitcher.c"
		GFileMonitorEvent _tmp2_;
#line 713 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp2_ = event;
#line 713 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp0_ = _tmp2_ != G_FILE_MONITOR_EVENT_DELETED;
#line 3646 "WindowSwitcher.c"
	} else {
#line 713 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp0_ = FALSE;
#line 3650 "WindowSwitcher.c"
	}
#line 713 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp0_) {
#line 714 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return;
#line 3656 "WindowSwitcher.c"
	}
#line 716 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	count = 0;
#line 3660 "WindowSwitcher.c"
	{
		GFileEnumerator* children = NULL;
		GFile* _tmp3_;
		GFileEnumerator* _tmp4_;
#line 719 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp3_ = folder;
#line 719 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp4_ = g_file_enumerate_children (_tmp3_, "", 0, NULL, &_inner_error_);
#line 719 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		children = _tmp4_;
#line 719 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3673 "WindowSwitcher.c"
			goto __catch23_g_error;
		}
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		while (TRUE) {
#line 3678 "WindowSwitcher.c"
			GFileInfo* _tmp5_ = NULL;
			GFileEnumerator* _tmp6_;
			GFileInfo* _tmp7_;
			gint _tmp8_;
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp6_ = children;
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp7_ = g_file_enumerator_next_file (_tmp6_, NULL, &_inner_error_);
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp5_ = _tmp7_;
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_g_object_unref0 (children);
#line 3693 "WindowSwitcher.c"
				goto __catch23_g_error;
			}
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			if (!(_tmp5_ != NULL)) {
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				_g_object_unref0 (_tmp5_);
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
				break;
#line 3702 "WindowSwitcher.c"
			}
#line 721 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp8_ = count;
#line 721 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			count = _tmp8_ + 1;
#line 720 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (_tmp5_);
#line 3710 "WindowSwitcher.c"
		}
#line 718 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (children);
#line 3714 "WindowSwitcher.c"
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 718 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		e = _inner_error_;
#line 718 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_inner_error_ = NULL;
#line 723 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp9_ = e;
#line 723 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp10_ = _tmp9_->message;
#line 723 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_warning ("WindowSwitcher.vala:723: %s", _tmp10_);
#line 718 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_error_free0 (e);
#line 3734 "WindowSwitcher.c"
	}
	__finally23:
#line 718 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 718 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 718 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_clear_error (&_inner_error_);
#line 718 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		return;
#line 3745 "WindowSwitcher.c"
	}
#line 725 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp11_ = count;
#line 725 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->n_dock_items = _tmp11_;
#line 3751 "WindowSwitcher.c"
}


static GdkModifierType gala_window_switcher_get_current_modifiers (GalaWindowSwitcher* self) {
	GdkModifierType result = 0;
	GdkModifierType modifiers = 0;
	gdouble* axes = NULL;
	gdouble* _tmp0_;
	gint axes_length1;
	gint _axes_size_;
	GdkDisplay* _tmp1_;
	GdkDeviceManager* _tmp2_;
	GdkDevice* _tmp3_;
	GdkWindow* _tmp4_;
	GdkModifierType _tmp5_ = 0;
#line 728 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 731 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = g_new0 (gdouble, 0);
#line 731 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	axes = _tmp0_;
#line 731 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	axes_length1 = 0;
#line 731 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_axes_size_ = axes_length1;
#line 732 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = gdk_display_get_default ();
#line 732 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = gdk_display_get_device_manager (_tmp1_);
#line 732 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = gdk_device_manager_get_client_pointer (_tmp2_);
#line 732 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = gdk_get_default_root_window ();
#line 732 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gdk_device_get_state (_tmp3_, _tmp4_, axes, &_tmp5_);
#line 732 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	modifiers = _tmp5_;
#line 735 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = modifiers;
#line 735 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	axes = (g_free (axes), NULL);
#line 735 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 3795 "WindowSwitcher.c"
}


GalaWindowManager* gala_window_switcher_get_wm (GalaWindowSwitcher* self) {
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->_wm;
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	result = _tmp0_;
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 3810 "WindowSwitcher.c"
}


static void gala_window_switcher_set_wm (GalaWindowSwitcher* self, GalaWindowManager* value) {
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_return_if_fail (self != NULL);
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (gala_window_switcher_get_wm (self) != value) {
#line 3819 "WindowSwitcher.c"
		GalaWindowManager* _tmp0_;
		GalaWindowManager* _tmp1_;
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp0_ = value;
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self->priv->_wm);
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self->priv->_wm = _tmp1_;
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM]);
#line 3832 "WindowSwitcher.c"
	}
}


static Block40Data* block40_data_ref (Block40Data* _data40_) {
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_atomic_int_inc (&_data40_->_ref_count_);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return _data40_;
#line 3842 "WindowSwitcher.c"
}


static void block40_data_unref (void * _userdata_) {
	Block40Data* _data40_;
	_data40_ = (Block40Data*) _userdata_;
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (g_atomic_int_dec_and_test (&_data40_->_ref_count_)) {
#line 3851 "WindowSwitcher.c"
		GalaWindowSwitcher* self;
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		self = _data40_->self;
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (_data40_->dock_canvas);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_g_object_unref0 (self);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_slice_free (Block40Data, _data40_);
#line 3861 "WindowSwitcher.c"
	}
}


static void _gala_window_switcher_load_dock_theme_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_load_dock_theme ((GalaWindowSwitcher*) self);
#line 3869 "WindowSwitcher.c"
}


static void _gala_window_switcher_update_n_dock_items_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 73 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_n_dock_items ((GalaWindowSwitcher*) self, file, other_file, event_type);
#line 3876 "WindowSwitcher.c"
}


static gboolean _gala_window_switcher_draw_dock_background_clutter_canvas_draw (ClutterCanvas* _sender, cairo_t* cr, gint width, gint height, gpointer self) {
	gboolean result;
	result = gala_window_switcher_draw_dock_background ((GalaWindowSwitcher*) self, cr);
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return result;
#line 3885 "WindowSwitcher.c"
}


static void _gala_window_switcher_icon_removed_clutter_container_actor_removed (ClutterContainer* _sender, ClutterActor* actor, gpointer self) {
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_icon_removed ((GalaWindowSwitcher*) self, actor);
#line 3892 "WindowSwitcher.c"
}


static void _gala_window_switcher___lambda35_ (Block40Data* _data40_) {
	GalaWindowSwitcher* self;
	ClutterCanvas* _tmp0_;
	ClutterActor* _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	ClutterActor* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self = _data40_->self;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = _data40_->dock_canvas;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->dock;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = clutter_actor_get_width (_tmp1_);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = _tmp2_;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = self->priv->dock;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = clutter_actor_get_height (_tmp4_);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = _tmp5_;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_canvas_set_size (_tmp0_, (gint) _tmp3_, (gint) _tmp6_);
#line 3923 "WindowSwitcher.c"
}


static void __gala_window_switcher___lambda35__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_gala_window_switcher___lambda35_ (self);
#line 3930 "WindowSwitcher.c"
}


static void _gala_window_switcher_window_removed_clutter_container_actor_removed (ClutterContainer* _sender, ClutterActor* actor, gpointer self) {
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_window_removed ((GalaWindowSwitcher*) self, actor);
#line 3937 "WindowSwitcher.c"
}


static GObject * gala_window_switcher_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowSwitcher * self;
	Block40Data* _data40_;
	PlankDockPreferences* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	GFile* launcher_folder = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	gboolean _tmp10_;
	ClutterActor* _tmp19_;
	ClutterActor* _tmp20_;
	ClutterBoxLayout* _tmp21_;
	ClutterBoxLayout* _tmp22_;
	ClutterCanvas* _tmp23_;
	ClutterCanvas* _tmp24_;
	ClutterActor* _tmp25_;
	ClutterCanvas* _tmp26_;
	ClutterActor* _tmp27_;
	ClutterActor* _tmp28_;
	ClutterActor* _tmp29_;
	ClutterActor* _tmp30_;
	ClutterActor* _tmp31_;
	ClutterActor* _tmp32_;
	ClutterColor* _tmp33_;
	ClutterActor* _tmp34_;
	ClutterActor* _tmp35_;
	ClutterActor* _tmp36_;
	GalaWindowManager* _tmp37_;
	MetaScreen* _tmp38_;
	GError * _inner_error_ = NULL;
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	parent_class = G_OBJECT_CLASS (gala_window_switcher_parent_class);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_data40_ = g_slice_new0 (Block40Data);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_data40_->_ref_count_ = 1;
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_data40_->self = g_object_ref (self);
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = plank_dock_preferences_new ("dock1");
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_settings);
#line 64 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->dock_settings = _tmp0_;
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp1_ = self->priv->dock_settings;
#line 65 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify", (GCallback) _gala_window_switcher_update_dock_g_object_notify, self, 0);
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->dock_settings;
#line 66 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::Theme", (GCallback) _gala_window_switcher_load_dock_theme_g_object_notify, self, 0);
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = plank_paths_get_AppConfigFolder ();
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp4_ = _tmp3_;
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp5_ = g_file_get_child (_tmp4_, "dock1");
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp6_ = _tmp5_;
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp7_ = g_file_get_child (_tmp6_, "launchers");
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp8_ = _tmp7_;
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (_tmp6_);
#line 68 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	launcher_folder = _tmp8_;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp9_ = launcher_folder;
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp10_ = g_file_query_exists (_tmp9_, NULL);
#line 70 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp10_) {
#line 4027 "WindowSwitcher.c"
		GFile* _tmp18_;
		{
			GFileMonitor* _tmp11_ = NULL;
			GFile* _tmp12_;
			GFileMonitor* _tmp13_;
			GFileMonitor* _tmp14_;
			GFileMonitor* _tmp15_;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp12_ = launcher_folder;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp13_ = g_file_monitor (_tmp12_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp11_ = _tmp13_;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4043 "WindowSwitcher.c"
				goto __catch24_g_error;
			}
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp14_ = _tmp11_;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp11_ = NULL;
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (self->priv->monitor);
#line 72 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			self->priv->monitor = _tmp14_;
#line 73 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp15_ = self->priv->monitor;
#line 73 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			g_signal_connect_object (_tmp15_, "changed", (GCallback) _gala_window_switcher_update_n_dock_items_g_file_monitor_changed, self, 0);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (_tmp11_);
#line 4060 "WindowSwitcher.c"
		}
		goto __finally24;
		__catch24_g_error:
		{
			GError* e = NULL;
			GError* _tmp16_;
			const gchar* _tmp17_;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			e = _inner_error_;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp16_ = e;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_tmp17_ = _tmp16_->message;
#line 74 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			g_warning ("WindowSwitcher.vala:74: %s", _tmp17_);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_g_error_free0 (e);
#line 4080 "WindowSwitcher.c"
		}
		__finally24:
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_g_object_unref0 (launcher_folder);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			block40_data_unref (_data40_);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			_data40_ = NULL;
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 71 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
			g_clear_error (&_inner_error_);
#line 4095 "WindowSwitcher.c"
		}
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp18_ = launcher_folder;
#line 77 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_update_n_dock_items (self, _tmp18_, NULL, G_FILE_MONITOR_EVENT_CREATED);
#line 4101 "WindowSwitcher.c"
	}
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp19_ = clutter_actor_new ();
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp19_);
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock);
#line 80 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->dock = _tmp19_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp20_ = self->priv->dock;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp21_ = (ClutterBoxLayout*) clutter_box_layout_new ();
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp21_);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp22_ = _tmp21_;
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_layout_manager (_tmp20_, (ClutterLayoutManager*) _tmp22_);
#line 81 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (_tmp22_);
#line 83 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp23_ = (ClutterCanvas*) clutter_canvas_new ();
#line 83 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_data40_->dock_canvas = _tmp23_;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp24_ = _data40_->dock_canvas;
#line 84 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object (_tmp24_, "draw", (GCallback) _gala_window_switcher_draw_dock_background_clutter_canvas_draw, self, 0);
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp25_ = self->priv->dock;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp26_ = _data40_->dock_canvas;
#line 86 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_content (_tmp25_, (ClutterContent*) _tmp26_);
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp27_ = self->priv->dock;
#line 87 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((ClutterContainer*) _tmp27_, "actor-removed", (GCallback) _gala_window_switcher_icon_removed_clutter_container_actor_removed, self, 0);
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp28_ = self->priv->dock;
#line 88 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_data ((GObject*) _tmp28_, "notify::allocation", (GCallback) __gala_window_switcher___lambda35__g_object_notify, block40_data_ref (_data40_), (GClosureNotify) block40_data_unref, 0);
#line 91 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_load_dock_theme (self);
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp29_ = clutter_actor_new ();
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp29_);
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->window_clones);
#line 93 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->window_clones = _tmp29_;
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp30_ = self->priv->window_clones;
#line 94 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object ((ClutterContainer*) _tmp30_, "actor-removed", (GCallback) _gala_window_switcher_window_removed_clutter_container_actor_removed, self, 0);
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp31_ = clutter_actor_new ();
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_ref_sink (_tmp31_);
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->background);
#line 96 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->background = _tmp31_;
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp32_ = self->priv->background;
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp33_ = clutter_color_get_static (CLUTTER_COLOR_BLACK);
#line 97 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_set_background_color (_tmp32_, _tmp33_);
#line 98 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_update_background (self);
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp34_ = self->priv->background;
#line 100 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp34_);
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp35_ = self->priv->window_clones;
#line 101 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp35_);
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp36_ = self->priv->dock;
#line 102 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp36_);
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp37_ = self->priv->_wm;
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp38_ = meta_plugin_get_screen ((MetaPlugin*) _tmp37_);
#line 104 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_connect_object (_tmp38_, "monitors-changed", (GCallback) _gala_window_switcher_update_actors_meta_screen_monitors_changed, self, 0);
#line 106 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_set ((ClutterActor*) self, "visible", FALSE, NULL);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (launcher_folder);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	block40_data_unref (_data40_);
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_data40_ = NULL;
#line 61 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	return obj;
#line 4203 "WindowSwitcher.c"
}


static void gala_window_switcher_class_init (GalaWindowSwitcherClass * klass) {
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	gala_window_switcher_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_type_class_add_private (klass, sizeof (GalaWindowSwitcherPrivate));
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_release_event = (gboolean (*) (ClutterActor *, ClutterKeyEvent*)) gala_window_switcher_real_key_release_event;
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	((ClutterActorClass *) klass)->key_focus_out = (void (*) (ClutterActor *)) gala_window_switcher_real_key_focus_out;
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_switcher_get_property;
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_switcher_set_property;
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_switcher_constructor;
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_switcher_finalize;
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_SWITCHER_WM, gala_window_switcher_properties[GALA_WINDOW_SWITCHER_WM] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 4226 "WindowSwitcher.c"
}


static void gala_window_switcher_instance_init (GalaWindowSwitcher * self) {
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv = GALA_WINDOW_SWITCHER_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->current_window = NULL;
#line 48 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->last_switch = (gint64) 0;
#line 49 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->closing = FALSE;
#line 53 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->dock_width = 0.0f;
#line 54 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self->priv->n_dock_items = 0;
#line 4243 "WindowSwitcher.c"
}


static void gala_window_switcher_finalize (GObject * obj) {
	GalaWindowSwitcher * self;
	GFileMonitor* _tmp0_;
	GalaWindowManager* _tmp2_;
	MetaScreen* _tmp3_;
	guint _tmp4_;
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp0_ = self->priv->monitor;
#line 111 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	if (_tmp0_ != NULL) {
#line 4259 "WindowSwitcher.c"
		GFileMonitor* _tmp1_;
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		_tmp1_ = self->priv->monitor;
#line 112 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_file_monitor_cancel (_tmp1_);
#line 4265 "WindowSwitcher.c"
	}
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp2_ = self->priv->_wm;
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_tmp3_ = meta_plugin_get_screen ((MetaPlugin*) _tmp2_);
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_parse_name ("monitors-changed", meta_screen_get_type (), &_tmp4_, NULL, FALSE);
#line 114 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _gala_window_switcher_update_actors_meta_screen_monitors_changed, self);
#line 29 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->_wm);
#line 31 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->current_window);
#line 33 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->window_clones);
#line 34 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	__g_list_free__g_object_unref0_0 (self->priv->clone_sort_order);
#line 36 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_window);
#line 37 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock);
#line 38 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_surface);
#line 39 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_theme);
#line 40 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->dock_settings);
#line 43 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->monitor);
#line 45 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->background);
#line 50 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	_g_object_unref0 (self->priv->modal_proxy);
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	G_OBJECT_CLASS (gala_window_switcher_parent_class)->finalize (obj);
#line 4301 "WindowSwitcher.c"
}


GType gala_window_switcher_get_type (void) {
	static volatile gsize gala_window_switcher_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_switcher_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWindowSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowSwitcher), 0, (GInstanceInitFunc) gala_window_switcher_instance_init, NULL };
		GType gala_window_switcher_type_id;
		gala_window_switcher_type_id = g_type_register_static (clutter_actor_get_type (), "GalaWindowSwitcher", &g_define_type_info, 0);
		g_once_init_leave (&gala_window_switcher_type_id__volatile, gala_window_switcher_type_id);
	}
	return gala_window_switcher_type_id__volatile;
}


static void _vala_gala_window_switcher_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM:
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		g_value_set_object (value, gala_window_switcher_get_wm (self));
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		break;
#line 4328 "WindowSwitcher.c"
		default:
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		break;
#line 4334 "WindowSwitcher.c"
	}
}


static void _vala_gala_window_switcher_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaWindowSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher);
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		case GALA_WINDOW_SWITCHER_WM:
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		gala_window_switcher_set_wm (self, g_value_get_object (value));
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		break;
#line 4350 "WindowSwitcher.c"
		default:
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/gala-0.3.0.124-cd28/src/Widgets/WindowSwitcher.vala"
		break;
#line 4356 "WindowSwitcher.c"
	}
}



